#ifdef GET_AT_DECL
enum ATValues {
  S1E1R = 960,
  S1E2R = 9152,
  S1E3R = 13248,
  S1E1W = 961,
  S1E2W = 9153,
  S1E3W = 13249,
  S1E0R = 962,
  S1E0W = 963,
  S12E1R = 9156,
  S12E1W = 9157,
  S12E0R = 9158,
  S12E0W = 9159,
  S1E1RP = 968,
  S1E1WP = 969,
};
#endif

#ifdef GET_BTI_DECL
enum BTIValues {
  c = 2,
  j = 4,
  jc = 6,
};
#endif

#ifdef GET_DB_DECL
enum DBValues {
  oshld = 1,
  oshst = 2,
  osh = 3,
  nshld = 5,
  nshst = 6,
  nsh = 7,
  ishld = 9,
  ishst = 10,
  ish = 11,
  ld = 13,
  st = 14,
  sy = 15,
};
#endif

#ifdef GET_DBNXS_DECL
enum DBnXSValues {
  oshnxs = 3,
  nshnxs = 7,
  ishnxs = 11,
  synxs = 15,
};
#endif

#ifdef GET_DC_DECL
enum DCValues {
  ZVA = 7073,
  IVAC = 945,
  ISW = 946,
  CVAC = 7121,
  CSW = 978,
  CVAU = 7129,
  CIVAC = 7153,
  CISW = 1010,
  CVAP = 7137,
  CVADP = 7145,
  IGVAC = 947,
  IGSW = 948,
  CGSW = 980,
  CIGSW = 1012,
  CGVAC = 7123,
  CGVAP = 7139,
  CGVADP = 7147,
  CIGVAC = 7155,
  GVA = 7075,
  IGDVAC = 949,
  IGDSW = 950,
  CGDSW = 982,
  CIGDSW = 1014,
  CGDVAC = 7125,
  CGDVAP = 7141,
  CGDVADP = 7149,
  CIGDVAC = 7157,
  GZVA = 7076,
};
#endif

#ifdef GET_EXACTFPIMM_DECL
enum ExactFPImmValues {
  zero = 0,
  half = 1,
  one = 2,
  two = 3,
};
#endif

#ifdef GET_IC_DECL
enum ICValues {
  IALLUIS = 904,
  IALLU = 936,
  IVAU = 7081,
};
#endif

#ifdef GET_ISB_DECL
enum ISBValues {
  sy = 15,
};
#endif

#ifdef GET_PRCTX_DECL
enum PRCTXValues {
  RCTX = 883,
};
#endif

#ifdef GET_PRFM_DECL
enum PRFMValues {
  pldl1keep = 0,
  pldl1strm = 1,
  pldl2keep = 2,
  pldl2strm = 3,
  pldl3keep = 4,
  pldl3strm = 5,
  plil1keep = 8,
  plil1strm = 9,
  plil2keep = 10,
  plil2strm = 11,
  plil3keep = 12,
  plil3strm = 13,
  pstl1keep = 16,
  pstl1strm = 17,
  pstl2keep = 18,
  pstl2strm = 19,
  pstl3keep = 20,
  pstl3strm = 21,
};
#endif

#ifdef GET_PSB_DECL
enum PSBValues {
  csync = 17,
};
#endif

#ifdef GET_PSTATE_DECL
enum PStateValues {
  SPSel = 5,
  DAIFSet = 30,
  DAIFClr = 31,
  PAN = 4,
  UAO = 3,
  DIT = 26,
  SSBS = 25,
  TCO = 28,
};
#endif

#ifdef GET_SVCR_DECL
enum SVCRValues {
  SVCRSM = 1,
  SVCRZA = 2,
  SVCRSMZA = 3,
};
#endif

#ifdef GET_SVEPREDPAT_DECL
enum SVEPREDPATValues {
  pow2 = 0,
  vl1 = 1,
  vl2 = 2,
  vl3 = 3,
  vl4 = 4,
  vl5 = 5,
  vl6 = 6,
  vl7 = 7,
  vl8 = 8,
  vl16 = 9,
  vl32 = 10,
  vl64 = 11,
  vl128 = 12,
  vl256 = 13,
  mul4 = 29,
  mul3 = 30,
  all = 31,
};
#endif

#ifdef GET_SVEPRFM_DECL
enum SVEPRFMValues {
  pldl1keep = 0,
  pldl1strm = 1,
  pldl2keep = 2,
  pldl2strm = 3,
  pldl3keep = 4,
  pldl3strm = 5,
  pstl1keep = 8,
  pstl1strm = 9,
  pstl2keep = 10,
  pstl2strm = 11,
  pstl3keep = 12,
  pstl3strm = 13,
};
#endif

#ifdef GET_SYSREG_DECL
enum SysRegValues {
  MDCCSR_EL0 = 38920,
  DBGDTRRX_EL0 = 38952,
  MDRAR_EL1 = 32896,
  OSLSR_EL1 = 32908,
  DBGAUTHSTATUS_EL1 = 33782,
  PMCEID0_EL0 = 56550,
  PMCEID1_EL0 = 56551,
  MIDR_EL1 = 49152,
  CCSIDR_EL1 = 51200,
  CCSIDR2_EL1 = 51202,
  CLIDR_EL1 = 51201,
  CTR_EL0 = 55297,
  MPIDR_EL1 = 49157,
  REVIDR_EL1 = 49158,
  AIDR_EL1 = 51207,
  DCZID_EL0 = 55303,
  ID_PFR0_EL1 = 49160,
  ID_PFR1_EL1 = 49161,
  ID_PFR2_EL1 = 49180,
  ID_DFR0_EL1 = 49162,
  ID_AFR0_EL1 = 49163,
  ID_MMFR0_EL1 = 49164,
  ID_MMFR1_EL1 = 49165,
  ID_MMFR2_EL1 = 49166,
  ID_MMFR3_EL1 = 49167,
  ID_ISAR0_EL1 = 49168,
  ID_ISAR1_EL1 = 49169,
  ID_ISAR2_EL1 = 49170,
  ID_ISAR3_EL1 = 49171,
  ID_ISAR4_EL1 = 49172,
  ID_ISAR5_EL1 = 49173,
  ID_ISAR6_EL1 = 49175,
  ID_AA64PFR0_EL1 = 49184,
  ID_AA64PFR1_EL1 = 49185,
  ID_AA64DFR0_EL1 = 49192,
  ID_AA64DFR1_EL1 = 49193,
  ID_AA64AFR0_EL1 = 49196,
  ID_AA64AFR1_EL1 = 49197,
  ID_AA64ISAR0_EL1 = 49200,
  ID_AA64ISAR1_EL1 = 49201,
  ID_AA64ISAR2_EL1 = 49202,
  ID_AA64MMFR0_EL1 = 49208,
  ID_AA64MMFR1_EL1 = 49209,
  ID_AA64MMFR2_EL1 = 49210,
  MVFR0_EL1 = 49176,
  MVFR1_EL1 = 49177,
  MVFR2_EL1 = 49178,
  RVBAR_EL1 = 50689,
  RVBAR_EL2 = 58881,
  RVBAR_EL3 = 62977,
  ISR_EL1 = 50696,
  CNTPCT_EL0 = 57089,
  CNTVCT_EL0 = 57090,
  ID_MMFR4_EL1 = 49174,
  ID_MMFR5_EL1 = 49182,
  TRCSTATR = 34840,
  TRCIDR8 = 34822,
  TRCIDR9 = 34830,
  TRCIDR10 = 34838,
  TRCIDR11 = 34846,
  TRCIDR12 = 34854,
  TRCIDR13 = 34862,
  TRCIDR0 = 34887,
  TRCIDR1 = 34895,
  TRCIDR2 = 34903,
  TRCIDR3 = 34911,
  TRCIDR4 = 34919,
  TRCIDR5 = 34927,
  TRCIDR6 = 34935,
  TRCIDR7 = 34943,
  TRCOSLSR = 34956,
  TRCPDSR = 34988,
  TRCDEVAFF0 = 35798,
  TRCDEVAFF1 = 35806,
  TRCLSR = 35822,
  TRCAUTHSTATUS = 35830,
  TRCDEVARCH = 35838,
  TRCDEVID = 35735,
  TRCDEVTYPE = 35743,
  TRCPIDR4 = 35751,
  TRCPIDR5 = 35759,
  TRCPIDR6 = 35767,
  TRCPIDR7 = 35775,
  TRCPIDR0 = 35783,
  TRCPIDR1 = 35791,
  TRCPIDR2 = 35799,
  TRCPIDR3 = 35807,
  TRCCIDR0 = 35815,
  TRCCIDR1 = 35823,
  TRCCIDR2 = 35831,
  TRCCIDR3 = 35839,
  ICC_IAR1_EL1 = 50784,
  ICC_IAR0_EL1 = 50752,
  ICC_HPPIR1_EL1 = 50786,
  ICC_HPPIR0_EL1 = 50754,
  ICC_RPR_EL1 = 50779,
  ICH_VTR_EL2 = 58969,
  ICH_EISR_EL2 = 58971,
  ICH_ELRSR_EL2 = 58973,
  ID_AA64ZFR0_EL1 = 49188,
  LORID_EL1 = 50471,
  ERRIDR_EL1 = 49816,
  ERXFR_EL1 = 49824,
  RNDR = 55584,
  RNDRRS = 55585,
  SCXTNUM_EL0 = 56967,
  SCXTNUM_EL1 = 50823,
  SCXTNUM_EL2 = 59015,
  SCXTNUM_EL3 = 63111,
  SCXTNUM_EL12 = 61063,
  MFAR_EL3 = 62213,
  GPCCR_EL3 = 61710,
  GPTBR_EL3 = 61708,
  ID_AA64SMFR0_EL1 = 49189,
  DBGDTRTX_EL0 = 38952,
  OSLAR_EL1 = 32900,
  PMSWINC_EL0 = 56548,
  TRCOSLAR = 34948,
  TRCLAR = 35814,
  ICC_EOIR1_EL1 = 50785,
  ICC_EOIR0_EL1 = 50753,
  ICC_DIR_EL1 = 50777,
  ICC_SGI1R_EL1 = 50781,
  ICC_ASGI1R_EL1 = 50782,
  ICC_SGI0R_EL1 = 50783,
  OSDTRRX_EL1 = 32770,
  OSDTRTX_EL1 = 32794,
  TEECR32_EL1 = 36864,
  MDCCINT_EL1 = 32784,
  MDSCR_EL1 = 32786,
  DBGDTR_EL0 = 38944,
  OSECCR_EL1 = 32818,
  DBGVCR32_EL2 = 41016,
  DBGBVR0_EL1 = 32772,
  DBGBVR1_EL1 = 32780,
  DBGBVR2_EL1 = 32788,
  DBGBVR3_EL1 = 32796,
  DBGBVR4_EL1 = 32804,
  DBGBVR5_EL1 = 32812,
  DBGBVR6_EL1 = 32820,
  DBGBVR7_EL1 = 32828,
  DBGBVR8_EL1 = 32836,
  DBGBVR9_EL1 = 32844,
  DBGBVR10_EL1 = 32852,
  DBGBVR11_EL1 = 32860,
  DBGBVR12_EL1 = 32868,
  DBGBVR13_EL1 = 32876,
  DBGBVR14_EL1 = 32884,
  DBGBVR15_EL1 = 32892,
  DBGBCR0_EL1 = 32773,
  DBGBCR1_EL1 = 32781,
  DBGBCR2_EL1 = 32789,
  DBGBCR3_EL1 = 32797,
  DBGBCR4_EL1 = 32805,
  DBGBCR5_EL1 = 32813,
  DBGBCR6_EL1 = 32821,
  DBGBCR7_EL1 = 32829,
  DBGBCR8_EL1 = 32837,
  DBGBCR9_EL1 = 32845,
  DBGBCR10_EL1 = 32853,
  DBGBCR11_EL1 = 32861,
  DBGBCR12_EL1 = 32869,
  DBGBCR13_EL1 = 32877,
  DBGBCR14_EL1 = 32885,
  DBGBCR15_EL1 = 32893,
  DBGWVR0_EL1 = 32774,
  DBGWVR1_EL1 = 32782,
  DBGWVR2_EL1 = 32790,
  DBGWVR3_EL1 = 32798,
  DBGWVR4_EL1 = 32806,
  DBGWVR5_EL1 = 32814,
  DBGWVR6_EL1 = 32822,
  DBGWVR7_EL1 = 32830,
  DBGWVR8_EL1 = 32838,
  DBGWVR9_EL1 = 32846,
  DBGWVR10_EL1 = 32854,
  DBGWVR11_EL1 = 32862,
  DBGWVR12_EL1 = 32870,
  DBGWVR13_EL1 = 32878,
  DBGWVR14_EL1 = 32886,
  DBGWVR15_EL1 = 32894,
  DBGWCR0_EL1 = 32775,
  DBGWCR1_EL1 = 32783,
  DBGWCR2_EL1 = 32791,
  DBGWCR3_EL1 = 32799,
  DBGWCR4_EL1 = 32807,
  DBGWCR5_EL1 = 32815,
  DBGWCR6_EL1 = 32823,
  DBGWCR7_EL1 = 32831,
  DBGWCR8_EL1 = 32839,
  DBGWCR9_EL1 = 32847,
  DBGWCR10_EL1 = 32855,
  DBGWCR11_EL1 = 32863,
  DBGWCR12_EL1 = 32871,
  DBGWCR13_EL1 = 32879,
  DBGWCR14_EL1 = 32887,
  DBGWCR15_EL1 = 32895,
  TEEHBR32_EL1 = 36992,
  OSDLR_EL1 = 32924,
  DBGPRCR_EL1 = 32932,
  DBGCLAIMSET_EL1 = 33734,
  DBGCLAIMCLR_EL1 = 33742,
  CSSELR_EL1 = 53248,
  VPIDR_EL2 = 57344,
  VMPIDR_EL2 = 57349,
  CPACR_EL1 = 49282,
  SCTLR_EL1 = 49280,
  SCTLR_EL2 = 57472,
  SCTLR_EL3 = 61568,
  ACTLR_EL1 = 49281,
  ACTLR_EL2 = 57473,
  ACTLR_EL3 = 61569,
  HCR_EL2 = 57480,
  HCRX_EL2 = 57490,
  SCR_EL3 = 61576,
  MDCR_EL2 = 57481,
  SDER32_EL3 = 61577,
  CPTR_EL2 = 57482,
  CPTR_EL3 = 61578,
  HSTR_EL2 = 57483,
  HACR_EL2 = 57487,
  MDCR_EL3 = 61593,
  TTBR0_EL1 = 49408,
  TTBR0_EL3 = 61696,
  TTBR0_EL2 = 57600,
  VTTBR_EL2 = 57608,
  TTBR1_EL1 = 49409,
  TCR_EL1 = 49410,
  TCR_EL2 = 57602,
  TCR_EL3 = 61698,
  VTCR_EL2 = 57610,
  DACR32_EL2 = 57728,
  SPSR_EL1 = 49664,
  SPSR_EL2 = 57856,
  SPSR_EL3 = 61952,
  ELR_EL1 = 49665,
  ELR_EL2 = 57857,
  ELR_EL3 = 61953,
  SP_EL0 = 49672,
  SP_EL1 = 57864,
  SP_EL2 = 61960,
  SPSel = 49680,
  NZCV = 55824,
  DAIF = 55825,
  CurrentEL = 49682,
  SPSR_irq = 57880,
  SPSR_abt = 57881,
  SPSR_und = 57882,
  SPSR_fiq = 57883,
  FPCR = 55840,
  FPSR = 55841,
  DSPSR_EL0 = 55848,
  DLR_EL0 = 55849,
  IFSR32_EL2 = 57985,
  AFSR0_EL1 = 49800,
  AFSR0_EL2 = 57992,
  AFSR0_EL3 = 62088,
  AFSR1_EL1 = 49801,
  AFSR1_EL2 = 57993,
  AFSR1_EL3 = 62089,
  ESR_EL1 = 49808,
  ESR_EL2 = 58000,
  ESR_EL3 = 62096,
  FPEXC32_EL2 = 58008,
  FAR_EL1 = 49920,
  FAR_EL2 = 58112,
  FAR_EL3 = 62208,
  HPFAR_EL2 = 58116,
  PAR_EL1 = 50080,
  PMCR_EL0 = 56544,
  PMCNTENSET_EL0 = 56545,
  PMCNTENCLR_EL0 = 56546,
  PMOVSCLR_EL0 = 56547,
  PMSELR_EL0 = 56549,
  PMCCNTR_EL0 = 56552,
  PMXEVTYPER_EL0 = 56553,
  PMXEVCNTR_EL0 = 56554,
  PMUSERENR_EL0 = 56560,
  PMINTENSET_EL1 = 50417,
  PMINTENCLR_EL1 = 50418,
  PMOVSSET_EL0 = 56563,
  PMMIR_EL1 = 50422,
  MAIR_EL1 = 50448,
  MAIR_EL2 = 58640,
  MAIR_EL3 = 62736,
  AMAIR_EL1 = 50456,
  AMAIR_EL2 = 58648,
  AMAIR_EL3 = 62744,
  VBAR_EL1 = 50688,
  VBAR_EL2 = 58880,
  VBAR_EL3 = 62976,
  RMR_EL1 = 50690,
  RMR_EL2 = 58882,
  RMR_EL3 = 62978,
  CONTEXTIDR_EL1 = 50817,
  TPIDR_EL0 = 56962,
  TPIDR_EL2 = 59010,
  TPIDR_EL3 = 63106,
  TPIDRRO_EL0 = 56963,
  TPIDR_EL1 = 50820,
  CNTFRQ_EL0 = 57088,
  CNTVOFF_EL2 = 59139,
  CNTKCTL_EL1 = 50952,
  CNTHCTL_EL2 = 59144,
  CNTP_TVAL_EL0 = 57104,
  CNTHP_TVAL_EL2 = 59152,
  CNTPS_TVAL_EL1 = 65296,
  CNTP_CTL_EL0 = 57105,
  CNTHP_CTL_EL2 = 59153,
  CNTPS_CTL_EL1 = 65297,
  CNTP_CVAL_EL0 = 57106,
  CNTHP_CVAL_EL2 = 59154,
  CNTPS_CVAL_EL1 = 65298,
  CNTV_TVAL_EL0 = 57112,
  CNTV_CTL_EL0 = 57113,
  CNTV_CVAL_EL0 = 57114,
  PMEVCNTR0_EL0 = 57152,
  PMEVCNTR1_EL0 = 57153,
  PMEVCNTR2_EL0 = 57154,
  PMEVCNTR3_EL0 = 57155,
  PMEVCNTR4_EL0 = 57156,
  PMEVCNTR5_EL0 = 57157,
  PMEVCNTR6_EL0 = 57158,
  PMEVCNTR7_EL0 = 57159,
  PMEVCNTR8_EL0 = 57160,
  PMEVCNTR9_EL0 = 57161,
  PMEVCNTR10_EL0 = 57162,
  PMEVCNTR11_EL0 = 57163,
  PMEVCNTR12_EL0 = 57164,
  PMEVCNTR13_EL0 = 57165,
  PMEVCNTR14_EL0 = 57166,
  PMEVCNTR15_EL0 = 57167,
  PMEVCNTR16_EL0 = 57168,
  PMEVCNTR17_EL0 = 57169,
  PMEVCNTR18_EL0 = 57170,
  PMEVCNTR19_EL0 = 57171,
  PMEVCNTR20_EL0 = 57172,
  PMEVCNTR21_EL0 = 57173,
  PMEVCNTR22_EL0 = 57174,
  PMEVCNTR23_EL0 = 57175,
  PMEVCNTR24_EL0 = 57176,
  PMEVCNTR25_EL0 = 57177,
  PMEVCNTR26_EL0 = 57178,
  PMEVCNTR27_EL0 = 57179,
  PMEVCNTR28_EL0 = 57180,
  PMEVCNTR29_EL0 = 57181,
  PMEVCNTR30_EL0 = 57182,
  PMCCFILTR_EL0 = 57215,
  PMEVTYPER0_EL0 = 57184,
  PMEVTYPER1_EL0 = 57185,
  PMEVTYPER2_EL0 = 57186,
  PMEVTYPER3_EL0 = 57187,
  PMEVTYPER4_EL0 = 57188,
  PMEVTYPER5_EL0 = 57189,
  PMEVTYPER6_EL0 = 57190,
  PMEVTYPER7_EL0 = 57191,
  PMEVTYPER8_EL0 = 57192,
  PMEVTYPER9_EL0 = 57193,
  PMEVTYPER10_EL0 = 57194,
  PMEVTYPER11_EL0 = 57195,
  PMEVTYPER12_EL0 = 57196,
  PMEVTYPER13_EL0 = 57197,
  PMEVTYPER14_EL0 = 57198,
  PMEVTYPER15_EL0 = 57199,
  PMEVTYPER16_EL0 = 57200,
  PMEVTYPER17_EL0 = 57201,
  PMEVTYPER18_EL0 = 57202,
  PMEVTYPER19_EL0 = 57203,
  PMEVTYPER20_EL0 = 57204,
  PMEVTYPER21_EL0 = 57205,
  PMEVTYPER22_EL0 = 57206,
  PMEVTYPER23_EL0 = 57207,
  PMEVTYPER24_EL0 = 57208,
  PMEVTYPER25_EL0 = 57209,
  PMEVTYPER26_EL0 = 57210,
  PMEVTYPER27_EL0 = 57211,
  PMEVTYPER28_EL0 = 57212,
  PMEVTYPER29_EL0 = 57213,
  PMEVTYPER30_EL0 = 57214,
  TRCPRGCTLR = 34824,
  TRCPROCSELR = 34832,
  TRCCONFIGR = 34848,
  TRCAUXCTLR = 34864,
  TRCEVENTCTL0R = 34880,
  TRCEVENTCTL1R = 34888,
  TRCSTALLCTLR = 34904,
  TRCTSCTLR = 34912,
  TRCSYNCPR = 34920,
  TRCCCCTLR = 34928,
  TRCBBCTLR = 34936,
  TRCTRACEIDR = 34817,
  TRCQCTLR = 34825,
  TRCVICTLR = 34818,
  TRCVIIECTLR = 34826,
  TRCVISSCTLR = 34834,
  TRCVIPCSSCTLR = 34842,
  TRCVDCTLR = 34882,
  TRCVDSACCTLR = 34890,
  TRCVDARCCTLR = 34898,
  TRCSEQEVR0 = 34820,
  TRCSEQEVR1 = 34828,
  TRCSEQEVR2 = 34836,
  TRCSEQRSTEVR = 34868,
  TRCSEQSTR = 34876,
  TRCEXTINSELR = 34884,
  TRCCNTRLDVR0 = 34821,
  TRCCNTRLDVR1 = 34829,
  TRCCNTRLDVR2 = 34837,
  TRCCNTRLDVR3 = 34845,
  TRCCNTCTLR0 = 34853,
  TRCCNTCTLR1 = 34861,
  TRCCNTCTLR2 = 34869,
  TRCCNTCTLR3 = 34877,
  TRCCNTVR0 = 34885,
  TRCCNTVR1 = 34893,
  TRCCNTVR2 = 34901,
  TRCCNTVR3 = 34909,
  TRCIMSPEC0 = 34823,
  TRCIMSPEC1 = 34831,
  TRCIMSPEC2 = 34839,
  TRCIMSPEC3 = 34847,
  TRCIMSPEC4 = 34855,
  TRCIMSPEC5 = 34863,
  TRCIMSPEC6 = 34871,
  TRCIMSPEC7 = 34879,
  TRCRSCTLR2 = 34960,
  TRCRSCTLR3 = 34968,
  TRCRSCTLR4 = 34976,
  TRCRSCTLR5 = 34984,
  TRCRSCTLR6 = 34992,
  TRCRSCTLR7 = 35000,
  TRCRSCTLR8 = 35008,
  TRCRSCTLR9 = 35016,
  TRCRSCTLR10 = 35024,
  TRCRSCTLR11 = 35032,
  TRCRSCTLR12 = 35040,
  TRCRSCTLR13 = 35048,
  TRCRSCTLR14 = 35056,
  TRCRSCTLR15 = 35064,
  TRCRSCTLR16 = 34945,
  TRCRSCTLR17 = 34953,
  TRCRSCTLR18 = 34961,
  TRCRSCTLR19 = 34969,
  TRCRSCTLR20 = 34977,
  TRCRSCTLR21 = 34985,
  TRCRSCTLR22 = 34993,
  TRCRSCTLR23 = 35001,
  TRCRSCTLR24 = 35009,
  TRCRSCTLR25 = 35017,
  TRCRSCTLR26 = 35025,
  TRCRSCTLR27 = 35033,
  TRCRSCTLR28 = 35041,
  TRCRSCTLR29 = 35049,
  TRCRSCTLR30 = 35057,
  TRCRSCTLR31 = 35065,
  TRCSSCCR0 = 34946,
  TRCSSCCR1 = 34954,
  TRCSSCCR2 = 34962,
  TRCSSCCR3 = 34970,
  TRCSSCCR4 = 34978,
  TRCSSCCR5 = 34986,
  TRCSSCCR6 = 34994,
  TRCSSCCR7 = 35002,
  TRCSSCSR0 = 35010,
  TRCSSCSR1 = 35018,
  TRCSSCSR2 = 35026,
  TRCSSCSR3 = 35034,
  TRCSSCSR4 = 35042,
  TRCSSCSR5 = 35050,
  TRCSSCSR6 = 35058,
  TRCSSCSR7 = 35066,
  TRCSSPCICR0 = 34947,
  TRCSSPCICR1 = 34955,
  TRCSSPCICR2 = 34963,
  TRCSSPCICR3 = 34971,
  TRCSSPCICR4 = 34979,
  TRCSSPCICR5 = 34987,
  TRCSSPCICR6 = 34995,
  TRCSSPCICR7 = 35003,
  TRCPDCR = 34980,
  TRCACVR0 = 35072,
  TRCACVR1 = 35088,
  TRCACVR2 = 35104,
  TRCACVR3 = 35120,
  TRCACVR4 = 35136,
  TRCACVR5 = 35152,
  TRCACVR6 = 35168,
  TRCACVR7 = 35184,
  TRCACVR8 = 35073,
  TRCACVR9 = 35089,
  TRCACVR10 = 35105,
  TRCACVR11 = 35121,
  TRCACVR12 = 35137,
  TRCACVR13 = 35153,
  TRCACVR14 = 35169,
  TRCACVR15 = 35185,
  TRCACATR0 = 35074,
  TRCACATR1 = 35090,
  TRCACATR2 = 35106,
  TRCACATR3 = 35122,
  TRCACATR4 = 35138,
  TRCACATR5 = 35154,
  TRCACATR6 = 35170,
  TRCACATR7 = 35186,
  TRCACATR8 = 35075,
  TRCACATR9 = 35091,
  TRCACATR10 = 35107,
  TRCACATR11 = 35123,
  TRCACATR12 = 35139,
  TRCACATR13 = 35155,
  TRCACATR14 = 35171,
  TRCACATR15 = 35187,
  TRCDVCVR0 = 35076,
  TRCDVCVR1 = 35108,
  TRCDVCVR2 = 35140,
  TRCDVCVR3 = 35172,
  TRCDVCVR4 = 35077,
  TRCDVCVR5 = 35109,
  TRCDVCVR6 = 35141,
  TRCDVCVR7 = 35173,
  TRCDVCMR0 = 35078,
  TRCDVCMR1 = 35110,
  TRCDVCMR2 = 35142,
  TRCDVCMR3 = 35174,
  TRCDVCMR4 = 35079,
  TRCDVCMR5 = 35111,
  TRCDVCMR6 = 35143,
  TRCDVCMR7 = 35175,
  TRCCIDCVR0 = 35200,
  TRCCIDCVR1 = 35216,
  TRCCIDCVR2 = 35232,
  TRCCIDCVR3 = 35248,
  TRCCIDCVR4 = 35264,
  TRCCIDCVR5 = 35280,
  TRCCIDCVR6 = 35296,
  TRCCIDCVR7 = 35312,
  TRCVMIDCVR0 = 35201,
  TRCVMIDCVR1 = 35217,
  TRCVMIDCVR2 = 35233,
  TRCVMIDCVR3 = 35249,
  TRCVMIDCVR4 = 35265,
  TRCVMIDCVR5 = 35281,
  TRCVMIDCVR6 = 35297,
  TRCVMIDCVR7 = 35313,
  TRCCIDCCTLR0 = 35202,
  TRCCIDCCTLR1 = 35210,
  TRCVMIDCCTLR0 = 35218,
  TRCVMIDCCTLR1 = 35226,
  TRCITCTRL = 35716,
  TRCCLAIMSET = 35782,
  TRCCLAIMCLR = 35790,
  ICC_BPR1_EL1 = 50787,
  ICC_BPR0_EL1 = 50755,
  ICC_PMR_EL1 = 49712,
  ICC_CTLR_EL1 = 50788,
  ICC_CTLR_EL3 = 63076,
  ICC_SRE_EL1 = 50789,
  ICC_SRE_EL2 = 58957,
  ICC_SRE_EL3 = 63077,
  ICC_IGRPEN0_EL1 = 50790,
  ICC_IGRPEN1_EL1 = 50791,
  ICC_IGRPEN1_EL3 = 63079,
  ICC_AP0R0_EL1 = 50756,
  ICC_AP0R1_EL1 = 50757,
  ICC_AP0R2_EL1 = 50758,
  ICC_AP0R3_EL1 = 50759,
  ICC_AP1R0_EL1 = 50760,
  ICC_AP1R1_EL1 = 50761,
  ICC_AP1R2_EL1 = 50762,
  ICC_AP1R3_EL1 = 50763,
  ICH_AP0R0_EL2 = 58944,
  ICH_AP0R1_EL2 = 58945,
  ICH_AP0R2_EL2 = 58946,
  ICH_AP0R3_EL2 = 58947,
  ICH_AP1R0_EL2 = 58952,
  ICH_AP1R1_EL2 = 58953,
  ICH_AP1R2_EL2 = 58954,
  ICH_AP1R3_EL2 = 58955,
  ICH_HCR_EL2 = 58968,
  ICH_MISR_EL2 = 58970,
  ICH_VMCR_EL2 = 58975,
  ICH_LR0_EL2 = 58976,
  ICH_LR1_EL2 = 58977,
  ICH_LR2_EL2 = 58978,
  ICH_LR3_EL2 = 58979,
  ICH_LR4_EL2 = 58980,
  ICH_LR5_EL2 = 58981,
  ICH_LR6_EL2 = 58982,
  ICH_LR7_EL2 = 58983,
  ICH_LR8_EL2 = 58984,
  ICH_LR9_EL2 = 58985,
  ICH_LR10_EL2 = 58986,
  ICH_LR11_EL2 = 58987,
  ICH_LR12_EL2 = 58988,
  ICH_LR13_EL2 = 58989,
  ICH_LR14_EL2 = 58990,
  ICH_LR15_EL2 = 58991,
  VSCTLR_EL2 = 57600,
  MPUIR_EL1 = 49156,
  MPUIR_EL2 = 57348,
  PRENR_EL1 = 49929,
  PRENR_EL2 = 58121,
  PRSELR_EL1 = 49937,
  PRSELR_EL2 = 58129,
  PRBAR_EL1 = 49984,
  PRBAR_EL2 = 58176,
  PRLAR_EL1 = 49985,
  PRLAR_EL2 = 58177,
  PRBAR0_EL1 = 49984,
  PRLAR0_EL1 = 49985,
  PRBAR0_EL2 = 58176,
  PRLAR0_EL2 = 58177,
  PRBAR1_EL1 = 49988,
  PRLAR1_EL1 = 49989,
  PRBAR1_EL2 = 58180,
  PRLAR1_EL2 = 58181,
  PRBAR2_EL1 = 49992,
  PRLAR2_EL1 = 49993,
  PRBAR2_EL2 = 58184,
  PRLAR2_EL2 = 58185,
  PRBAR3_EL1 = 49996,
  PRLAR3_EL1 = 49997,
  PRBAR3_EL2 = 58188,
  PRLAR3_EL2 = 58189,
  PRBAR4_EL1 = 50000,
  PRLAR4_EL1 = 50001,
  PRBAR4_EL2 = 58192,
  PRLAR4_EL2 = 58193,
  PRBAR5_EL1 = 50004,
  PRLAR5_EL1 = 50005,
  PRBAR5_EL2 = 58196,
  PRLAR5_EL2 = 58197,
  PRBAR6_EL1 = 50008,
  PRLAR6_EL1 = 50009,
  PRBAR6_EL2 = 58200,
  PRLAR6_EL2 = 58201,
  PRBAR7_EL1 = 50012,
  PRLAR7_EL1 = 50013,
  PRBAR7_EL2 = 58204,
  PRLAR7_EL2 = 58205,
  PRBAR8_EL1 = 50016,
  PRLAR8_EL1 = 50017,
  PRBAR8_EL2 = 58208,
  PRLAR8_EL2 = 58209,
  PRBAR9_EL1 = 50020,
  PRLAR9_EL1 = 50021,
  PRBAR9_EL2 = 58212,
  PRLAR9_EL2 = 58213,
  PRBAR10_EL1 = 50024,
  PRLAR10_EL1 = 50025,
  PRBAR10_EL2 = 58216,
  PRLAR10_EL2 = 58217,
  PRBAR11_EL1 = 50028,
  PRLAR11_EL1 = 50029,
  PRBAR11_EL2 = 58220,
  PRLAR11_EL2 = 58221,
  PRBAR12_EL1 = 50032,
  PRLAR12_EL1 = 50033,
  PRBAR12_EL2 = 58224,
  PRLAR12_EL2 = 58225,
  PRBAR13_EL1 = 50036,
  PRLAR13_EL1 = 50037,
  PRBAR13_EL2 = 58228,
  PRLAR13_EL2 = 58229,
  PRBAR14_EL1 = 50040,
  PRLAR14_EL1 = 50041,
  PRBAR14_EL2 = 58232,
  PRLAR14_EL2 = 58233,
  PRBAR15_EL1 = 50044,
  PRLAR15_EL1 = 50045,
  PRBAR15_EL2 = 58236,
  PRLAR15_EL2 = 58237,
  PAN = 49683,
  LORSA_EL1 = 50464,
  LOREA_EL1 = 50465,
  LORN_EL1 = 50466,
  LORC_EL1 = 50467,
  TTBR1_EL2 = 57601,
  CNTHV_TVAL_EL2 = 59160,
  CNTHV_CVAL_EL2 = 59162,
  CNTHV_CTL_EL2 = 59161,
  SCTLR_EL12 = 59520,
  CPACR_EL12 = 59522,
  TTBR0_EL12 = 59648,
  TTBR1_EL12 = 59649,
  TCR_EL12 = 59650,
  AFSR0_EL12 = 60040,
  AFSR1_EL12 = 60041,
  ESR_EL12 = 60048,
  FAR_EL12 = 60160,
  MAIR_EL12 = 60688,
  AMAIR_EL12 = 60696,
  VBAR_EL12 = 60928,
  CONTEXTIDR_EL12 = 61057,
  CNTKCTL_EL12 = 61192,
  CNTP_TVAL_EL02 = 61200,
  CNTP_CTL_EL02 = 61201,
  CNTP_CVAL_EL02 = 61202,
  CNTV_TVAL_EL02 = 61208,
  CNTV_CTL_EL02 = 61209,
  CNTV_CVAL_EL02 = 61210,
  SPSR_EL12 = 59904,
  ELR_EL12 = 59905,
  CONTEXTIDR_EL2 = 59009,
  UAO = 49684,
  PMBLIMITR_EL1 = 50384,
  PMBPTR_EL1 = 50385,
  PMBSR_EL1 = 50387,
  PMBIDR_EL1 = 50391,
  PMSCR_EL2 = 58568,
  PMSCR_EL12 = 60616,
  PMSCR_EL1 = 50376,
  PMSICR_EL1 = 50378,
  PMSIRR_EL1 = 50379,
  PMSFCR_EL1 = 50380,
  PMSEVFR_EL1 = 50381,
  PMSLATFR_EL1 = 50382,
  PMSIDR_EL1 = 50383,
  ERRSELR_EL1 = 49817,
  ERXCTLR_EL1 = 49825,
  ERXSTATUS_EL1 = 49826,
  ERXADDR_EL1 = 49827,
  ERXMISC0_EL1 = 49832,
  ERXMISC1_EL1 = 49833,
  DISR_EL1 = 50697,
  VDISR_EL2 = 58889,
  VSESR_EL2 = 58003,
  APIAKeyLo_EL1 = 49416,
  APIAKeyHi_EL1 = 49417,
  APIBKeyLo_EL1 = 49418,
  APIBKeyHi_EL1 = 49419,
  APDAKeyLo_EL1 = 49424,
  APDAKeyHi_EL1 = 49425,
  APDBKeyLo_EL1 = 49426,
  APDBKeyHi_EL1 = 49427,
  APGAKeyLo_EL1 = 49432,
  APGAKeyHi_EL1 = 49433,
  VSTCR_EL2 = 57650,
  VSTTBR_EL2 = 57648,
  CNTHVS_TVAL_EL2 = 59168,
  CNTHVS_CVAL_EL2 = 59170,
  CNTHVS_CTL_EL2 = 59169,
  CNTHPS_TVAL_EL2 = 59176,
  CNTHPS_CVAL_EL2 = 59178,
  CNTHPS_CTL_EL2 = 59177,
  SDER32_EL2 = 57497,
  ERXPFGCTL_EL1 = 49829,
  ERXPFGCDN_EL1 = 49830,
  ERXMISC2_EL1 = 49834,
  ERXMISC3_EL1 = 49835,
  ERXPFGF_EL1 = 49828,
  MPAM0_EL1 = 50473,
  MPAM1_EL1 = 50472,
  MPAM2_EL2 = 58664,
  MPAM3_EL3 = 62760,
  MPAM1_EL12 = 60712,
  MPAMHCR_EL2 = 58656,
  MPAMVPMV_EL2 = 58657,
  MPAMVPM0_EL2 = 58672,
  MPAMVPM1_EL2 = 58673,
  MPAMVPM2_EL2 = 58674,
  MPAMVPM3_EL2 = 58675,
  MPAMVPM4_EL2 = 58676,
  MPAMVPM5_EL2 = 58677,
  MPAMVPM6_EL2 = 58678,
  MPAMVPM7_EL2 = 58679,
  MPAMIDR_EL1 = 50468,
  AMCR_EL0 = 56976,
  AMCFGR_EL0 = 56977,
  AMCGCR_EL0 = 56978,
  AMUSERENR_EL0 = 56979,
  AMCNTENCLR0_EL0 = 56980,
  AMCNTENSET0_EL0 = 56981,
  AMEVCNTR00_EL0 = 56992,
  AMEVCNTR01_EL0 = 56993,
  AMEVCNTR02_EL0 = 56994,
  AMEVCNTR03_EL0 = 56995,
  AMEVTYPER00_EL0 = 57008,
  AMEVTYPER01_EL0 = 57009,
  AMEVTYPER02_EL0 = 57010,
  AMEVTYPER03_EL0 = 57011,
  AMCNTENCLR1_EL0 = 56984,
  AMCNTENSET1_EL0 = 56985,
  AMEVCNTR10_EL0 = 57056,
  AMEVCNTR11_EL0 = 57057,
  AMEVCNTR12_EL0 = 57058,
  AMEVCNTR13_EL0 = 57059,
  AMEVCNTR14_EL0 = 57060,
  AMEVCNTR15_EL0 = 57061,
  AMEVCNTR16_EL0 = 57062,
  AMEVCNTR17_EL0 = 57063,
  AMEVCNTR18_EL0 = 57064,
  AMEVCNTR19_EL0 = 57065,
  AMEVCNTR110_EL0 = 57066,
  AMEVCNTR111_EL0 = 57067,
  AMEVCNTR112_EL0 = 57068,
  AMEVCNTR113_EL0 = 57069,
  AMEVCNTR114_EL0 = 57070,
  AMEVCNTR115_EL0 = 57071,
  AMEVTYPER10_EL0 = 57072,
  AMEVTYPER11_EL0 = 57073,
  AMEVTYPER12_EL0 = 57074,
  AMEVTYPER13_EL0 = 57075,
  AMEVTYPER14_EL0 = 57076,
  AMEVTYPER15_EL0 = 57077,
  AMEVTYPER16_EL0 = 57078,
  AMEVTYPER17_EL0 = 57079,
  AMEVTYPER18_EL0 = 57080,
  AMEVTYPER19_EL0 = 57081,
  AMEVTYPER110_EL0 = 57082,
  AMEVTYPER111_EL0 = 57083,
  AMEVTYPER112_EL0 = 57084,
  AMEVTYPER113_EL0 = 57085,
  AMEVTYPER114_EL0 = 57086,
  AMEVTYPER115_EL0 = 57087,
  TRFCR_EL1 = 49297,
  TRFCR_EL2 = 57489,
  TRFCR_EL12 = 59537,
  DIT = 55829,
  VNCR_EL2 = 57616,
  ZCR_EL1 = 49296,
  ZCR_EL2 = 57488,
  ZCR_EL3 = 61584,
  ZCR_EL12 = 59536,
  SSBS = 55830,
  TCO = 55831,
  GCR_EL1 = 49286,
  RGSR_EL1 = 49285,
  TFSR_EL1 = 49840,
  TFSR_EL2 = 58032,
  TFSR_EL3 = 62128,
  TFSR_EL12 = 60080,
  TFSRE0_EL1 = 49841,
  GMID_EL1 = 51204,
  TRCRSR = 34896,
  TRCEXTINSELR0 = 34884,
  TRCEXTINSELR1 = 34892,
  TRCEXTINSELR2 = 34900,
  TRCEXTINSELR3 = 34908,
  TRBLIMITR_EL1 = 50392,
  TRBPTR_EL1 = 50393,
  TRBBASER_EL1 = 50394,
  TRBSR_EL1 = 50395,
  TRBMAR_EL1 = 50396,
  TRBTRG_EL1 = 50398,
  TRBIDR_EL1 = 50399,
  AMEVCNTVOFF00_EL2 = 59072,
  AMEVCNTVOFF10_EL2 = 59088,
  AMEVCNTVOFF01_EL2 = 59073,
  AMEVCNTVOFF11_EL2 = 59089,
  AMEVCNTVOFF02_EL2 = 59074,
  AMEVCNTVOFF12_EL2 = 59090,
  AMEVCNTVOFF03_EL2 = 59075,
  AMEVCNTVOFF13_EL2 = 59091,
  AMEVCNTVOFF04_EL2 = 59076,
  AMEVCNTVOFF14_EL2 = 59092,
  AMEVCNTVOFF05_EL2 = 59077,
  AMEVCNTVOFF15_EL2 = 59093,
  AMEVCNTVOFF06_EL2 = 59078,
  AMEVCNTVOFF16_EL2 = 59094,
  AMEVCNTVOFF07_EL2 = 59079,
  AMEVCNTVOFF17_EL2 = 59095,
  AMEVCNTVOFF08_EL2 = 59080,
  AMEVCNTVOFF18_EL2 = 59096,
  AMEVCNTVOFF09_EL2 = 59081,
  AMEVCNTVOFF19_EL2 = 59097,
  AMEVCNTVOFF010_EL2 = 59082,
  AMEVCNTVOFF110_EL2 = 59098,
  AMEVCNTVOFF011_EL2 = 59083,
  AMEVCNTVOFF111_EL2 = 59099,
  AMEVCNTVOFF012_EL2 = 59084,
  AMEVCNTVOFF112_EL2 = 59100,
  AMEVCNTVOFF013_EL2 = 59085,
  AMEVCNTVOFF113_EL2 = 59101,
  AMEVCNTVOFF014_EL2 = 59086,
  AMEVCNTVOFF114_EL2 = 59102,
  AMEVCNTVOFF015_EL2 = 59087,
  AMEVCNTVOFF115_EL2 = 59103,
  HFGRTR_EL2 = 57484,
  HFGWTR_EL2 = 57485,
  HFGITR_EL2 = 57486,
  HDFGRTR_EL2 = 57740,
  HDFGWTR_EL2 = 57741,
  CNTSCALE_EL2 = 59140,
  CNTISCALE_EL2 = 59141,
  CNTPOFF_EL2 = 59142,
  CNTVFRQ_EL2 = 59143,
  CNTPCTSS_EL0 = 57093,
  CNTVCTSS_EL0 = 57094,
  ACCDATA_EL1 = 50821,
  BRBCR_EL1 = 35968,
  BRBCR_EL12 = 44160,
  BRBCR_EL2 = 42112,
  BRBFCR_EL1 = 35969,
  BRBIDR0_EL1 = 35984,
  BRBINFINJ_EL1 = 35976,
  BRBSRCINJ_EL1 = 35977,
  BRBTGTINJ_EL1 = 35978,
  BRBTS_EL1 = 35970,
  BRBINF0_EL1 = 35840,
  BRBSRC0_EL1 = 35841,
  BRBTGT0_EL1 = 35842,
  BRBINF1_EL1 = 35848,
  BRBSRC1_EL1 = 35849,
  BRBTGT1_EL1 = 35850,
  BRBINF2_EL1 = 35856,
  BRBSRC2_EL1 = 35857,
  BRBTGT2_EL1 = 35858,
  BRBINF3_EL1 = 35864,
  BRBSRC3_EL1 = 35865,
  BRBTGT3_EL1 = 35866,
  BRBINF4_EL1 = 35872,
  BRBSRC4_EL1 = 35873,
  BRBTGT4_EL1 = 35874,
  BRBINF5_EL1 = 35880,
  BRBSRC5_EL1 = 35881,
  BRBTGT5_EL1 = 35882,
  BRBINF6_EL1 = 35888,
  BRBSRC6_EL1 = 35889,
  BRBTGT6_EL1 = 35890,
  BRBINF7_EL1 = 35896,
  BRBSRC7_EL1 = 35897,
  BRBTGT7_EL1 = 35898,
  BRBINF8_EL1 = 35904,
  BRBSRC8_EL1 = 35905,
  BRBTGT8_EL1 = 35906,
  BRBINF9_EL1 = 35912,
  BRBSRC9_EL1 = 35913,
  BRBTGT9_EL1 = 35914,
  BRBINF10_EL1 = 35920,
  BRBSRC10_EL1 = 35921,
  BRBTGT10_EL1 = 35922,
  BRBINF11_EL1 = 35928,
  BRBSRC11_EL1 = 35929,
  BRBTGT11_EL1 = 35930,
  BRBINF12_EL1 = 35936,
  BRBSRC12_EL1 = 35937,
  BRBTGT12_EL1 = 35938,
  BRBINF13_EL1 = 35944,
  BRBSRC13_EL1 = 35945,
  BRBTGT13_EL1 = 35946,
  BRBINF14_EL1 = 35952,
  BRBSRC14_EL1 = 35953,
  BRBTGT14_EL1 = 35954,
  BRBINF15_EL1 = 35960,
  BRBSRC15_EL1 = 35961,
  BRBTGT15_EL1 = 35962,
  BRBINF16_EL1 = 35844,
  BRBSRC16_EL1 = 35845,
  BRBTGT16_EL1 = 35846,
  BRBINF17_EL1 = 35852,
  BRBSRC17_EL1 = 35853,
  BRBTGT17_EL1 = 35854,
  BRBINF18_EL1 = 35860,
  BRBSRC18_EL1 = 35861,
  BRBTGT18_EL1 = 35862,
  BRBINF19_EL1 = 35868,
  BRBSRC19_EL1 = 35869,
  BRBTGT19_EL1 = 35870,
  BRBINF20_EL1 = 35876,
  BRBSRC20_EL1 = 35877,
  BRBTGT20_EL1 = 35878,
  BRBINF21_EL1 = 35884,
  BRBSRC21_EL1 = 35885,
  BRBTGT21_EL1 = 35886,
  BRBINF22_EL1 = 35892,
  BRBSRC22_EL1 = 35893,
  BRBTGT22_EL1 = 35894,
  BRBINF23_EL1 = 35900,
  BRBSRC23_EL1 = 35901,
  BRBTGT23_EL1 = 35902,
  BRBINF24_EL1 = 35908,
  BRBSRC24_EL1 = 35909,
  BRBTGT24_EL1 = 35910,
  BRBINF25_EL1 = 35916,
  BRBSRC25_EL1 = 35917,
  BRBTGT25_EL1 = 35918,
  BRBINF26_EL1 = 35924,
  BRBSRC26_EL1 = 35925,
  BRBTGT26_EL1 = 35926,
  BRBINF27_EL1 = 35932,
  BRBSRC27_EL1 = 35933,
  BRBTGT27_EL1 = 35934,
  BRBINF28_EL1 = 35940,
  BRBSRC28_EL1 = 35941,
  BRBTGT28_EL1 = 35942,
  BRBINF29_EL1 = 35948,
  BRBSRC29_EL1 = 35949,
  BRBTGT29_EL1 = 35950,
  BRBINF30_EL1 = 35956,
  BRBSRC30_EL1 = 35957,
  BRBTGT30_EL1 = 35958,
  BRBINF31_EL1 = 35964,
  BRBSRC31_EL1 = 35965,
  BRBTGT31_EL1 = 35966,
  PMSNEVFR_EL1 = 50377,
  CPM_IOACC_CTL_EL3 = 65424,
  SMCR_EL1 = 49302,
  SMCR_EL2 = 57494,
  SMCR_EL3 = 61590,
  SMCR_EL12 = 59542,
  SVCR = 55826,
  SMPRI_EL1 = 49300,
  SMPRIMAP_EL2 = 57493,
  SMIDR_EL1 = 51206,
  TPIDR2_EL0 = 56965,
  MPAMSM_EL1 = 50475,
};
#endif

#ifdef GET_TSB_DECL
enum TSBValues {
  csync = 0,
};
#endif

#ifdef GET_TLBITable_DECL
const TLBI *lookupTLBIByEncoding(uint16_t Encoding);
const TLBI *lookupTLBIByName(StringRef Name);
#endif

#ifdef GET_TLBITable_IMPL
constexpr TLBI TLBITable[] = {
  { "IPAS2E1IS", 0x2401, true,  {  }  }, // 0
  { "IPAS2E1ISnXS", 0x2481, true,  { AArch64::FeatureXS }  }, // 1
  { "IPAS2LE1IS", 0x2405, true,  {  }  }, // 2
  { "IPAS2LE1ISnXS", 0x2485, true,  { AArch64::FeatureXS }  }, // 3
  { "VMALLE1IS", 0x418, false,  {  }  }, // 4
  { "VMALLE1ISnXS", 0x498, false,  { AArch64::FeatureXS }  }, // 5
  { "ALLE2IS", 0x2418, false,  {  }  }, // 6
  { "ALLE2ISnXS", 0x2498, false,  { AArch64::FeatureXS }  }, // 7
  { "ALLE3IS", 0x3418, false,  {  }  }, // 8
  { "ALLE3ISnXS", 0x3498, false,  { AArch64::FeatureXS }  }, // 9
  { "VAE1IS", 0x419, true,  {  }  }, // 10
  { "VAE1ISnXS", 0x499, true,  { AArch64::FeatureXS }  }, // 11
  { "VAE2IS", 0x2419, true,  {  }  }, // 12
  { "VAE2ISnXS", 0x2499, true,  { AArch64::FeatureXS }  }, // 13
  { "VAE3IS", 0x3419, true,  {  }  }, // 14
  { "VAE3ISnXS", 0x3499, true,  { AArch64::FeatureXS }  }, // 15
  { "ASIDE1IS", 0x41A, true,  {  }  }, // 16
  { "ASIDE1ISnXS", 0x49A, true,  { AArch64::FeatureXS }  }, // 17
  { "VAAE1IS", 0x41B, true,  {  }  }, // 18
  { "VAAE1ISnXS", 0x49B, true,  { AArch64::FeatureXS }  }, // 19
  { "ALLE1IS", 0x241C, false,  {  }  }, // 20
  { "ALLE1ISnXS", 0x249C, false,  { AArch64::FeatureXS }  }, // 21
  { "VALE1IS", 0x41D, true,  {  }  }, // 22
  { "VALE1ISnXS", 0x49D, true,  { AArch64::FeatureXS }  }, // 23
  { "VALE2IS", 0x241D, true,  {  }  }, // 24
  { "VALE2ISnXS", 0x249D, true,  { AArch64::FeatureXS }  }, // 25
  { "VALE3IS", 0x341D, true,  {  }  }, // 26
  { "VALE3ISnXS", 0x349D, true,  { AArch64::FeatureXS }  }, // 27
  { "VMALLS12E1IS", 0x241E, false,  {  }  }, // 28
  { "VMALLS12E1ISnXS", 0x249E, false,  { AArch64::FeatureXS }  }, // 29
  { "VAALE1IS", 0x41F, true,  {  }  }, // 30
  { "VAALE1ISnXS", 0x49F, true,  { AArch64::FeatureXS }  }, // 31
  { "IPAS2E1", 0x2421, true,  {  }  }, // 32
  { "IPAS2E1nXS", 0x24A1, true,  { AArch64::FeatureXS }  }, // 33
  { "IPAS2LE1", 0x2425, true,  {  }  }, // 34
  { "IPAS2LE1nXS", 0x24A5, true,  { AArch64::FeatureXS }  }, // 35
  { "VMALLE1", 0x438, false,  {  }  }, // 36
  { "VMALLE1nXS", 0x4B8, false,  { AArch64::FeatureXS }  }, // 37
  { "ALLE2", 0x2438, false,  {  }  }, // 38
  { "ALLE2nXS", 0x24B8, false,  { AArch64::FeatureXS }  }, // 39
  { "ALLE3", 0x3438, false,  {  }  }, // 40
  { "ALLE3nXS", 0x34B8, false,  { AArch64::FeatureXS }  }, // 41
  { "VAE1", 0x439, true,  {  }  }, // 42
  { "VAE1nXS", 0x4B9, true,  { AArch64::FeatureXS }  }, // 43
  { "VAE2", 0x2439, true,  {  }  }, // 44
  { "VAE2nXS", 0x24B9, true,  { AArch64::FeatureXS }  }, // 45
  { "VAE3", 0x3439, true,  {  }  }, // 46
  { "VAE3nXS", 0x34B9, true,  { AArch64::FeatureXS }  }, // 47
  { "ASIDE1", 0x43A, true,  {  }  }, // 48
  { "ASIDE1nXS", 0x4BA, true,  { AArch64::FeatureXS }  }, // 49
  { "VAAE1", 0x43B, true,  {  }  }, // 50
  { "VAAE1nXS", 0x4BB, true,  { AArch64::FeatureXS }  }, // 51
  { "ALLE1", 0x243C, false,  {  }  }, // 52
  { "ALLE1nXS", 0x24BC, false,  { AArch64::FeatureXS }  }, // 53
  { "VALE1", 0x43D, true,  {  }  }, // 54
  { "VALE1nXS", 0x4BD, true,  { AArch64::FeatureXS }  }, // 55
  { "VALE2", 0x243D, true,  {  }  }, // 56
  { "VALE2nXS", 0x24BD, true,  { AArch64::FeatureXS }  }, // 57
  { "VALE3", 0x343D, true,  {  }  }, // 58
  { "VALE3nXS", 0x34BD, true,  { AArch64::FeatureXS }  }, // 59
  { "VMALLS12E1", 0x243E, false,  {  }  }, // 60
  { "VMALLS12E1nXS", 0x24BE, false,  { AArch64::FeatureXS }  }, // 61
  { "VAALE1", 0x43F, true,  {  }  }, // 62
  { "VAALE1nXS", 0x4BF, true,  { AArch64::FeatureXS }  }, // 63
  { "VMALLE1OS", 0x408, false,  { AArch64::FeatureTLB_RMI }  }, // 64
  { "VMALLE1OSnXS", 0x488, false,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 65
  { "VAE1OS", 0x409, true,  { AArch64::FeatureTLB_RMI }  }, // 66
  { "VAE1OSnXS", 0x489, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 67
  { "ASIDE1OS", 0x40A, true,  { AArch64::FeatureTLB_RMI }  }, // 68
  { "ASIDE1OSnXS", 0x48A, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 69
  { "VAAE1OS", 0x40B, true,  { AArch64::FeatureTLB_RMI }  }, // 70
  { "VAAE1OSnXS", 0x48B, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 71
  { "VALE1OS", 0x40D, true,  { AArch64::FeatureTLB_RMI }  }, // 72
  { "VALE1OSnXS", 0x48D, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 73
  { "VAALE1OS", 0x40F, true,  { AArch64::FeatureTLB_RMI }  }, // 74
  { "VAALE1OSnXS", 0x48F, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 75
  { "IPAS2E1OS", 0x2420, true,  { AArch64::FeatureTLB_RMI }  }, // 76
  { "IPAS2E1OSnXS", 0x24A0, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 77
  { "IPAS2LE1OS", 0x2424, true,  { AArch64::FeatureTLB_RMI }  }, // 78
  { "IPAS2LE1OSnXS", 0x24A4, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 79
  { "VAE2OS", 0x2409, true,  { AArch64::FeatureTLB_RMI }  }, // 80
  { "VAE2OSnXS", 0x2489, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 81
  { "VALE2OS", 0x240D, true,  { AArch64::FeatureTLB_RMI }  }, // 82
  { "VALE2OSnXS", 0x248D, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 83
  { "VMALLS12E1OS", 0x240E, false,  { AArch64::FeatureTLB_RMI }  }, // 84
  { "VMALLS12E1OSnXS", 0x248E, false,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 85
  { "VAE3OS", 0x3409, true,  { AArch64::FeatureTLB_RMI }  }, // 86
  { "VAE3OSnXS", 0x3489, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 87
  { "VALE3OS", 0x340D, true,  { AArch64::FeatureTLB_RMI }  }, // 88
  { "VALE3OSnXS", 0x348D, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 89
  { "ALLE2OS", 0x2408, false,  { AArch64::FeatureTLB_RMI }  }, // 90
  { "ALLE2OSnXS", 0x2488, false,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 91
  { "ALLE1OS", 0x240C, false,  { AArch64::FeatureTLB_RMI }  }, // 92
  { "ALLE1OSnXS", 0x248C, false,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 93
  { "ALLE3OS", 0x3408, false,  { AArch64::FeatureTLB_RMI }  }, // 94
  { "ALLE3OSnXS", 0x3488, false,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 95
  { "RVAE1", 0x431, true,  { AArch64::FeatureTLB_RMI }  }, // 96
  { "RVAE1nXS", 0x4B1, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 97
  { "RVAAE1", 0x433, true,  { AArch64::FeatureTLB_RMI }  }, // 98
  { "RVAAE1nXS", 0x4B3, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 99
  { "RVALE1", 0x435, true,  { AArch64::FeatureTLB_RMI }  }, // 100
  { "RVALE1nXS", 0x4B5, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 101
  { "RVAALE1", 0x437, true,  { AArch64::FeatureTLB_RMI }  }, // 102
  { "RVAALE1nXS", 0x4B7, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 103
  { "RVAE1IS", 0x411, true,  { AArch64::FeatureTLB_RMI }  }, // 104
  { "RVAE1ISnXS", 0x491, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 105
  { "RVAAE1IS", 0x413, true,  { AArch64::FeatureTLB_RMI }  }, // 106
  { "RVAAE1ISnXS", 0x493, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 107
  { "RVALE1IS", 0x415, true,  { AArch64::FeatureTLB_RMI }  }, // 108
  { "RVALE1ISnXS", 0x495, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 109
  { "RVAALE1IS", 0x417, true,  { AArch64::FeatureTLB_RMI }  }, // 110
  { "RVAALE1ISnXS", 0x497, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 111
  { "RVAE1OS", 0x429, true,  { AArch64::FeatureTLB_RMI }  }, // 112
  { "RVAE1OSnXS", 0x4A9, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 113
  { "RVAAE1OS", 0x42B, true,  { AArch64::FeatureTLB_RMI }  }, // 114
  { "RVAAE1OSnXS", 0x4AB, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 115
  { "RVALE1OS", 0x42D, true,  { AArch64::FeatureTLB_RMI }  }, // 116
  { "RVALE1OSnXS", 0x4AD, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 117
  { "RVAALE1OS", 0x42F, true,  { AArch64::FeatureTLB_RMI }  }, // 118
  { "RVAALE1OSnXS", 0x4AF, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 119
  { "RIPAS2E1IS", 0x2402, true,  { AArch64::FeatureTLB_RMI }  }, // 120
  { "RIPAS2E1ISnXS", 0x2482, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 121
  { "RIPAS2LE1IS", 0x2406, true,  { AArch64::FeatureTLB_RMI }  }, // 122
  { "RIPAS2LE1ISnXS", 0x2486, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 123
  { "RIPAS2E1", 0x2422, true,  { AArch64::FeatureTLB_RMI }  }, // 124
  { "RIPAS2E1nXS", 0x24A2, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 125
  { "RIPAS2LE1", 0x2426, true,  { AArch64::FeatureTLB_RMI }  }, // 126
  { "RIPAS2LE1nXS", 0x24A6, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 127
  { "RIPAS2E1OS", 0x2423, true,  { AArch64::FeatureTLB_RMI }  }, // 128
  { "RIPAS2E1OSnXS", 0x24A3, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 129
  { "RIPAS2LE1OS", 0x2427, true,  { AArch64::FeatureTLB_RMI }  }, // 130
  { "RIPAS2LE1OSnXS", 0x24A7, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 131
  { "RVAE2", 0x2431, true,  { AArch64::FeatureTLB_RMI }  }, // 132
  { "RVAE2nXS", 0x24B1, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 133
  { "RVALE2", 0x2435, true,  { AArch64::FeatureTLB_RMI }  }, // 134
  { "RVALE2nXS", 0x24B5, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 135
  { "RVAE2IS", 0x2411, true,  { AArch64::FeatureTLB_RMI }  }, // 136
  { "RVAE2ISnXS", 0x2491, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 137
  { "RVALE2IS", 0x2415, true,  { AArch64::FeatureTLB_RMI }  }, // 138
  { "RVALE2ISnXS", 0x2495, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 139
  { "RVAE2OS", 0x2429, true,  { AArch64::FeatureTLB_RMI }  }, // 140
  { "RVAE2OSnXS", 0x24A9, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 141
  { "RVALE2OS", 0x242D, true,  { AArch64::FeatureTLB_RMI }  }, // 142
  { "RVALE2OSnXS", 0x24AD, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 143
  { "RVAE3", 0x3431, true,  { AArch64::FeatureTLB_RMI }  }, // 144
  { "RVAE3nXS", 0x34B1, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 145
  { "RVALE3", 0x3435, true,  { AArch64::FeatureTLB_RMI }  }, // 146
  { "RVALE3nXS", 0x34B5, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 147
  { "RVAE3IS", 0x3411, true,  { AArch64::FeatureTLB_RMI }  }, // 148
  { "RVAE3ISnXS", 0x3491, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 149
  { "RVALE3IS", 0x3415, true,  { AArch64::FeatureTLB_RMI }  }, // 150
  { "RVALE3ISnXS", 0x3495, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 151
  { "RVAE3OS", 0x3429, true,  { AArch64::FeatureTLB_RMI }  }, // 152
  { "RVAE3OSnXS", 0x34A9, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 153
  { "RVALE3OS", 0x342D, true,  { AArch64::FeatureTLB_RMI }  }, // 154
  { "RVALE3OSnXS", 0x34AD, true,  { AArch64::FeatureTLB_RMI, AArch64::FeatureXS }  }, // 155
  { "RPAOS", 0x3423, true,  { AArch64::FeatureRME }  }, // 156
  { "RPAOSnXS", 0x34A3, true,  { AArch64::FeatureRME, AArch64::FeatureXS }  }, // 157
  { "RPALOS", 0x3427, true,  { AArch64::FeatureRME }  }, // 158
  { "RPALOSnXS", 0x34A7, true,  { AArch64::FeatureRME, AArch64::FeatureXS }  }, // 159
  { "PAALLOS", 0x340C, false,  { AArch64::FeatureRME }  }, // 160
  { "PAALLOSnXS", 0x348C, false,  { AArch64::FeatureRME, AArch64::FeatureXS }  }, // 161
  { "PAALL", 0x343C, false,  { AArch64::FeatureRME }  }, // 162
  { "PAALLnXS", 0x34BC, false,  { AArch64::FeatureRME, AArch64::FeatureXS }  }, // 163
 };

const TLBI *lookupTLBIByEncoding(uint16_t Encoding) {
  struct IndexType {
    uint16_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x408, 64 },
    { 0x409, 66 },
    { 0x40A, 68 },
    { 0x40B, 70 },
    { 0x40D, 72 },
    { 0x40F, 74 },
    { 0x411, 104 },
    { 0x413, 106 },
    { 0x415, 108 },
    { 0x417, 110 },
    { 0x418, 4 },
    { 0x419, 10 },
    { 0x41A, 16 },
    { 0x41B, 18 },
    { 0x41D, 22 },
    { 0x41F, 30 },
    { 0x429, 112 },
    { 0x42B, 114 },
    { 0x42D, 116 },
    { 0x42F, 118 },
    { 0x431, 96 },
    { 0x433, 98 },
    { 0x435, 100 },
    { 0x437, 102 },
    { 0x438, 36 },
    { 0x439, 42 },
    { 0x43A, 48 },
    { 0x43B, 50 },
    { 0x43D, 54 },
    { 0x43F, 62 },
    { 0x488, 65 },
    { 0x489, 67 },
    { 0x48A, 69 },
    { 0x48B, 71 },
    { 0x48D, 73 },
    { 0x48F, 75 },
    { 0x491, 105 },
    { 0x493, 107 },
    { 0x495, 109 },
    { 0x497, 111 },
    { 0x498, 5 },
    { 0x499, 11 },
    { 0x49A, 17 },
    { 0x49B, 19 },
    { 0x49D, 23 },
    { 0x49F, 31 },
    { 0x4A9, 113 },
    { 0x4AB, 115 },
    { 0x4AD, 117 },
    { 0x4AF, 119 },
    { 0x4B1, 97 },
    { 0x4B3, 99 },
    { 0x4B5, 101 },
    { 0x4B7, 103 },
    { 0x4B8, 37 },
    { 0x4B9, 43 },
    { 0x4BA, 49 },
    { 0x4BB, 51 },
    { 0x4BD, 55 },
    { 0x4BF, 63 },
    { 0x2401, 0 },
    { 0x2402, 120 },
    { 0x2405, 2 },
    { 0x2406, 122 },
    { 0x2408, 90 },
    { 0x2409, 80 },
    { 0x240C, 92 },
    { 0x240D, 82 },
    { 0x240E, 84 },
    { 0x2411, 136 },
    { 0x2415, 138 },
    { 0x2418, 6 },
    { 0x2419, 12 },
    { 0x241C, 20 },
    { 0x241D, 24 },
    { 0x241E, 28 },
    { 0x2420, 76 },
    { 0x2421, 32 },
    { 0x2422, 124 },
    { 0x2423, 128 },
    { 0x2424, 78 },
    { 0x2425, 34 },
    { 0x2426, 126 },
    { 0x2427, 130 },
    { 0x2429, 140 },
    { 0x242D, 142 },
    { 0x2431, 132 },
    { 0x2435, 134 },
    { 0x2438, 38 },
    { 0x2439, 44 },
    { 0x243C, 52 },
    { 0x243D, 56 },
    { 0x243E, 60 },
    { 0x2481, 1 },
    { 0x2482, 121 },
    { 0x2485, 3 },
    { 0x2486, 123 },
    { 0x2488, 91 },
    { 0x2489, 81 },
    { 0x248C, 93 },
    { 0x248D, 83 },
    { 0x248E, 85 },
    { 0x2491, 137 },
    { 0x2495, 139 },
    { 0x2498, 7 },
    { 0x2499, 13 },
    { 0x249C, 21 },
    { 0x249D, 25 },
    { 0x249E, 29 },
    { 0x24A0, 77 },
    { 0x24A1, 33 },
    { 0x24A2, 125 },
    { 0x24A3, 129 },
    { 0x24A4, 79 },
    { 0x24A5, 35 },
    { 0x24A6, 127 },
    { 0x24A7, 131 },
    { 0x24A9, 141 },
    { 0x24AD, 143 },
    { 0x24B1, 133 },
    { 0x24B5, 135 },
    { 0x24B8, 39 },
    { 0x24B9, 45 },
    { 0x24BC, 53 },
    { 0x24BD, 57 },
    { 0x24BE, 61 },
    { 0x3408, 94 },
    { 0x3409, 86 },
    { 0x340C, 160 },
    { 0x340D, 88 },
    { 0x3411, 148 },
    { 0x3415, 150 },
    { 0x3418, 8 },
    { 0x3419, 14 },
    { 0x341D, 26 },
    { 0x3423, 156 },
    { 0x3427, 158 },
    { 0x3429, 152 },
    { 0x342D, 154 },
    { 0x3431, 144 },
    { 0x3435, 146 },
    { 0x3438, 40 },
    { 0x3439, 46 },
    { 0x343C, 162 },
    { 0x343D, 58 },
    { 0x3488, 95 },
    { 0x3489, 87 },
    { 0x348C, 161 },
    { 0x348D, 89 },
    { 0x3491, 149 },
    { 0x3495, 151 },
    { 0x3498, 9 },
    { 0x3499, 15 },
    { 0x349D, 27 },
    { 0x34A3, 157 },
    { 0x34A7, 159 },
    { 0x34A9, 153 },
    { 0x34AD, 155 },
    { 0x34B1, 145 },
    { 0x34B5, 147 },
    { 0x34B8, 41 },
    { 0x34B9, 47 },
    { 0x34BC, 163 },
    { 0x34BD, 59 },
  };

  struct KeyType {
    uint16_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &TLBITable[Idx->_index];
}

const TLBI *lookupTLBIByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "ALLE1", 52 },
    { "ALLE1IS", 20 },
    { "ALLE1ISNXS", 21 },
    { "ALLE1NXS", 53 },
    { "ALLE1OS", 92 },
    { "ALLE1OSNXS", 93 },
    { "ALLE2", 38 },
    { "ALLE2IS", 6 },
    { "ALLE2ISNXS", 7 },
    { "ALLE2NXS", 39 },
    { "ALLE2OS", 90 },
    { "ALLE2OSNXS", 91 },
    { "ALLE3", 40 },
    { "ALLE3IS", 8 },
    { "ALLE3ISNXS", 9 },
    { "ALLE3NXS", 41 },
    { "ALLE3OS", 94 },
    { "ALLE3OSNXS", 95 },
    { "ASIDE1", 48 },
    { "ASIDE1IS", 16 },
    { "ASIDE1ISNXS", 17 },
    { "ASIDE1NXS", 49 },
    { "ASIDE1OS", 68 },
    { "ASIDE1OSNXS", 69 },
    { "IPAS2E1", 32 },
    { "IPAS2E1IS", 0 },
    { "IPAS2E1ISNXS", 1 },
    { "IPAS2E1NXS", 33 },
    { "IPAS2E1OS", 76 },
    { "IPAS2E1OSNXS", 77 },
    { "IPAS2LE1", 34 },
    { "IPAS2LE1IS", 2 },
    { "IPAS2LE1ISNXS", 3 },
    { "IPAS2LE1NXS", 35 },
    { "IPAS2LE1OS", 78 },
    { "IPAS2LE1OSNXS", 79 },
    { "PAALL", 162 },
    { "PAALLNXS", 163 },
    { "PAALLOS", 160 },
    { "PAALLOSNXS", 161 },
    { "RIPAS2E1", 124 },
    { "RIPAS2E1IS", 120 },
    { "RIPAS2E1ISNXS", 121 },
    { "RIPAS2E1NXS", 125 },
    { "RIPAS2E1OS", 128 },
    { "RIPAS2E1OSNXS", 129 },
    { "RIPAS2LE1", 126 },
    { "RIPAS2LE1IS", 122 },
    { "RIPAS2LE1ISNXS", 123 },
    { "RIPAS2LE1NXS", 127 },
    { "RIPAS2LE1OS", 130 },
    { "RIPAS2LE1OSNXS", 131 },
    { "RPALOS", 158 },
    { "RPALOSNXS", 159 },
    { "RPAOS", 156 },
    { "RPAOSNXS", 157 },
    { "RVAAE1", 98 },
    { "RVAAE1IS", 106 },
    { "RVAAE1ISNXS", 107 },
    { "RVAAE1NXS", 99 },
    { "RVAAE1OS", 114 },
    { "RVAAE1OSNXS", 115 },
    { "RVAALE1", 102 },
    { "RVAALE1IS", 110 },
    { "RVAALE1ISNXS", 111 },
    { "RVAALE1NXS", 103 },
    { "RVAALE1OS", 118 },
    { "RVAALE1OSNXS", 119 },
    { "RVAE1", 96 },
    { "RVAE1IS", 104 },
    { "RVAE1ISNXS", 105 },
    { "RVAE1NXS", 97 },
    { "RVAE1OS", 112 },
    { "RVAE1OSNXS", 113 },
    { "RVAE2", 132 },
    { "RVAE2IS", 136 },
    { "RVAE2ISNXS", 137 },
    { "RVAE2NXS", 133 },
    { "RVAE2OS", 140 },
    { "RVAE2OSNXS", 141 },
    { "RVAE3", 144 },
    { "RVAE3IS", 148 },
    { "RVAE3ISNXS", 149 },
    { "RVAE3NXS", 145 },
    { "RVAE3OS", 152 },
    { "RVAE3OSNXS", 153 },
    { "RVALE1", 100 },
    { "RVALE1IS", 108 },
    { "RVALE1ISNXS", 109 },
    { "RVALE1NXS", 101 },
    { "RVALE1OS", 116 },
    { "RVALE1OSNXS", 117 },
    { "RVALE2", 134 },
    { "RVALE2IS", 138 },
    { "RVALE2ISNXS", 139 },
    { "RVALE2NXS", 135 },
    { "RVALE2OS", 142 },
    { "RVALE2OSNXS", 143 },
    { "RVALE3", 146 },
    { "RVALE3IS", 150 },
    { "RVALE3ISNXS", 151 },
    { "RVALE3NXS", 147 },
    { "RVALE3OS", 154 },
    { "RVALE3OSNXS", 155 },
    { "VAAE1", 50 },
    { "VAAE1IS", 18 },
    { "VAAE1ISNXS", 19 },
    { "VAAE1NXS", 51 },
    { "VAAE1OS", 70 },
    { "VAAE1OSNXS", 71 },
    { "VAALE1", 62 },
    { "VAALE1IS", 30 },
    { "VAALE1ISNXS", 31 },
    { "VAALE1NXS", 63 },
    { "VAALE1OS", 74 },
    { "VAALE1OSNXS", 75 },
    { "VAE1", 42 },
    { "VAE1IS", 10 },
    { "VAE1ISNXS", 11 },
    { "VAE1NXS", 43 },
    { "VAE1OS", 66 },
    { "VAE1OSNXS", 67 },
    { "VAE2", 44 },
    { "VAE2IS", 12 },
    { "VAE2ISNXS", 13 },
    { "VAE2NXS", 45 },
    { "VAE2OS", 80 },
    { "VAE2OSNXS", 81 },
    { "VAE3", 46 },
    { "VAE3IS", 14 },
    { "VAE3ISNXS", 15 },
    { "VAE3NXS", 47 },
    { "VAE3OS", 86 },
    { "VAE3OSNXS", 87 },
    { "VALE1", 54 },
    { "VALE1IS", 22 },
    { "VALE1ISNXS", 23 },
    { "VALE1NXS", 55 },
    { "VALE1OS", 72 },
    { "VALE1OSNXS", 73 },
    { "VALE2", 56 },
    { "VALE2IS", 24 },
    { "VALE2ISNXS", 25 },
    { "VALE2NXS", 57 },
    { "VALE2OS", 82 },
    { "VALE2OSNXS", 83 },
    { "VALE3", 58 },
    { "VALE3IS", 26 },
    { "VALE3ISNXS", 27 },
    { "VALE3NXS", 59 },
    { "VALE3OS", 88 },
    { "VALE3OSNXS", 89 },
    { "VMALLE1", 36 },
    { "VMALLE1IS", 4 },
    { "VMALLE1ISNXS", 5 },
    { "VMALLE1NXS", 37 },
    { "VMALLE1OS", 64 },
    { "VMALLE1OSNXS", 65 },
    { "VMALLS12E1", 60 },
    { "VMALLS12E1IS", 28 },
    { "VMALLS12E1ISNXS", 29 },
    { "VMALLS12E1NXS", 61 },
    { "VMALLS12E1OS", 84 },
    { "VMALLS12E1OSNXS", 85 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &TLBITable[Idx->_index];
}
#endif

#ifdef GET_AT_DECL
const AT *lookupATByName(StringRef Name);
const AT *lookupATByEncoding(uint16_t Encoding);
#endif

#ifdef GET_AT_IMPL
constexpr AT ATsList[] = {
  { "S1E1R", 0x3C0,  {}  }, // 0
  { "S1E2R", 0x23C0,  {}  }, // 1
  { "S1E3R", 0x33C0,  {}  }, // 2
  { "S1E1W", 0x3C1,  {}  }, // 3
  { "S1E2W", 0x23C1,  {}  }, // 4
  { "S1E3W", 0x33C1,  {}  }, // 5
  { "S1E0R", 0x3C2,  {}  }, // 6
  { "S1E0W", 0x3C3,  {}  }, // 7
  { "S12E1R", 0x23C4,  {}  }, // 8
  { "S12E1W", 0x23C5,  {}  }, // 9
  { "S12E0R", 0x23C6,  {}  }, // 10
  { "S12E0W", 0x23C7,  {}  }, // 11
  { "S1E1RP", 0x3C8,  {AArch64::FeaturePAN_RWV}  }, // 12
  { "S1E1WP", 0x3C9,  {AArch64::FeaturePAN_RWV}  }, // 13
 };

const AT *lookupATByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "S12E0R", 10 },
    { "S12E0W", 11 },
    { "S12E1R", 8 },
    { "S12E1W", 9 },
    { "S1E0R", 6 },
    { "S1E0W", 7 },
    { "S1E1R", 0 },
    { "S1E1RP", 12 },
    { "S1E1W", 3 },
    { "S1E1WP", 13 },
    { "S1E2R", 1 },
    { "S1E2W", 4 },
    { "S1E3R", 2 },
    { "S1E3W", 5 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &ATsList[Idx->_index];
}

const AT *lookupATByEncoding(uint16_t Encoding) {
  struct IndexType {
    uint16_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x3C0, 0 },
    { 0x3C1, 3 },
    { 0x3C2, 6 },
    { 0x3C3, 7 },
    { 0x3C8, 12 },
    { 0x3C9, 13 },
    { 0x23C0, 1 },
    { 0x23C1, 4 },
    { 0x23C4, 8 },
    { 0x23C5, 9 },
    { 0x23C6, 10 },
    { 0x23C7, 11 },
    { 0x33C0, 2 },
    { 0x33C1, 5 },
  };

  struct KeyType {
    uint16_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &ATsList[Idx->_index];
}
#endif

#ifdef GET_BTI_DECL
const BTI *lookupBTIByName(StringRef Name);
const BTI *lookupBTIByEncoding(uint8_t Encoding);
#endif

#ifdef GET_BTI_IMPL
constexpr BTI BTIsList[] = {
  { "c", 0x2 }, // 0
  { "j", 0x4 }, // 1
  { "jc", 0x6 }, // 2
 };

const BTI *lookupBTIByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "C", 0 },
    { "J", 1 },
    { "JC", 2 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &BTIsList[Idx->_index];
}

const BTI *lookupBTIByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x2, 0 },
    { 0x4, 1 },
    { 0x6, 2 },
  };

  struct KeyType {
    uint8_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &BTIsList[Idx->_index];
}
#endif

#ifdef GET_DB_DECL
const DB *lookupDBByName(StringRef Name);
const DB *lookupDBByEncoding(uint8_t Encoding);
#endif

#ifdef GET_DB_IMPL
constexpr DB DBsList[] = {
  { "oshld", 0x1 }, // 0
  { "oshst", 0x2 }, // 1
  { "osh", 0x3 }, // 2
  { "nshld", 0x5 }, // 3
  { "nshst", 0x6 }, // 4
  { "nsh", 0x7 }, // 5
  { "ishld", 0x9 }, // 6
  { "ishst", 0xA }, // 7
  { "ish", 0xB }, // 8
  { "ld", 0xD }, // 9
  { "st", 0xE }, // 10
  { "sy", 0xF }, // 11
 };

const DB *lookupDBByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "ISH", 8 },
    { "ISHLD", 6 },
    { "ISHST", 7 },
    { "LD", 9 },
    { "NSH", 5 },
    { "NSHLD", 3 },
    { "NSHST", 4 },
    { "OSH", 2 },
    { "OSHLD", 0 },
    { "OSHST", 1 },
    { "ST", 10 },
    { "SY", 11 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &DBsList[Idx->_index];
}

const DB *lookupDBByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x1, 0 },
    { 0x2, 1 },
    { 0x3, 2 },
    { 0x5, 3 },
    { 0x6, 4 },
    { 0x7, 5 },
    { 0x9, 6 },
    { 0xA, 7 },
    { 0xB, 8 },
    { 0xD, 9 },
    { 0xE, 10 },
    { 0xF, 11 },
  };

  struct KeyType {
    uint8_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &DBsList[Idx->_index];
}
#endif

#ifdef GET_DBNXS_DECL
const DBnXS *lookupDBnXSByName(StringRef Name);
const DBnXS *lookupDBnXSByEncoding(uint8_t Encoding);
const DBnXS *lookupDBnXSByImmValue(uint8_t ImmValue);
#endif

#ifdef GET_DBNXS_IMPL
constexpr DBnXS DBnXSsList[] = {
  { "oshnxs", 0x3, 0x10,  {AArch64::FeatureXS}  }, // 0
  { "nshnxs", 0x7, 0x14,  {AArch64::FeatureXS}  }, // 1
  { "ishnxs", 0xB, 0x18,  {AArch64::FeatureXS}  }, // 2
  { "synxs", 0xF, 0x1C,  {AArch64::FeatureXS}  }, // 3
 };

const DBnXS *lookupDBnXSByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "ISHNXS", 2 },
    { "NSHNXS", 1 },
    { "OSHNXS", 0 },
    { "SYNXS", 3 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &DBnXSsList[Idx->_index];
}

const DBnXS *lookupDBnXSByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x3, 0 },
    { 0x7, 1 },
    { 0xB, 2 },
    { 0xF, 3 },
  };

  struct KeyType {
    uint8_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &DBnXSsList[Idx->_index];
}

const DBnXS *lookupDBnXSByImmValue(uint8_t ImmValue) {
  struct IndexType {
    uint8_t ImmValue;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x10, 0 },
    { 0x14, 1 },
    { 0x18, 2 },
    { 0x1C, 3 },
  };

  struct KeyType {
    uint8_t ImmValue;
  };
  KeyType Key = {ImmValue};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.ImmValue < RHS.ImmValue)
        return true;
      if (LHS.ImmValue > RHS.ImmValue)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.ImmValue != Idx->ImmValue)
    return nullptr;
  return &DBnXSsList[Idx->_index];
}
#endif

#ifdef GET_DC_DECL
const DC *lookupDCByName(StringRef Name);
const DC *lookupDCByEncoding(uint16_t Encoding);
#endif

#ifdef GET_DC_IMPL
constexpr DC DCsList[] = {
  { "ZVA", 0x1BA1,  {}  }, // 0
  { "IVAC", 0x3B1,  {}  }, // 1
  { "ISW", 0x3B2,  {}  }, // 2
  { "CVAC", 0x1BD1,  {}  }, // 3
  { "CSW", 0x3D2,  {}  }, // 4
  { "CVAU", 0x1BD9,  {}  }, // 5
  { "CIVAC", 0x1BF1,  {}  }, // 6
  { "CISW", 0x3F2,  {}  }, // 7
  { "CVAP", 0x1BE1,  {AArch64::FeatureCCPP}  }, // 8
  { "CVADP", 0x1BE9,  {AArch64::FeatureCacheDeepPersist}  }, // 9
  { "IGVAC", 0x3B3,  {AArch64::FeatureMTE}  }, // 10
  { "IGSW", 0x3B4,  {AArch64::FeatureMTE}  }, // 11
  { "CGSW", 0x3D4,  {AArch64::FeatureMTE}  }, // 12
  { "CIGSW", 0x3F4,  {AArch64::FeatureMTE}  }, // 13
  { "CGVAC", 0x1BD3,  {AArch64::FeatureMTE}  }, // 14
  { "CGVAP", 0x1BE3,  {AArch64::FeatureMTE}  }, // 15
  { "CGVADP", 0x1BEB,  {AArch64::FeatureMTE}  }, // 16
  { "CIGVAC", 0x1BF3,  {AArch64::FeatureMTE}  }, // 17
  { "GVA", 0x1BA3,  {AArch64::FeatureMTE}  }, // 18
  { "IGDVAC", 0x3B5,  {AArch64::FeatureMTE}  }, // 19
  { "IGDSW", 0x3B6,  {AArch64::FeatureMTE}  }, // 20
  { "CGDSW", 0x3D6,  {AArch64::FeatureMTE}  }, // 21
  { "CIGDSW", 0x3F6,  {AArch64::FeatureMTE}  }, // 22
  { "CGDVAC", 0x1BD5,  {AArch64::FeatureMTE}  }, // 23
  { "CGDVAP", 0x1BE5,  {AArch64::FeatureMTE}  }, // 24
  { "CGDVADP", 0x1BED,  {AArch64::FeatureMTE}  }, // 25
  { "CIGDVAC", 0x1BF5,  {AArch64::FeatureMTE}  }, // 26
  { "GZVA", 0x1BA4,  {AArch64::FeatureMTE}  }, // 27
 };

const DC *lookupDCByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "CGDSW", 21 },
    { "CGDVAC", 23 },
    { "CGDVADP", 25 },
    { "CGDVAP", 24 },
    { "CGSW", 12 },
    { "CGVAC", 14 },
    { "CGVADP", 16 },
    { "CGVAP", 15 },
    { "CIGDSW", 22 },
    { "CIGDVAC", 26 },
    { "CIGSW", 13 },
    { "CIGVAC", 17 },
    { "CISW", 7 },
    { "CIVAC", 6 },
    { "CSW", 4 },
    { "CVAC", 3 },
    { "CVADP", 9 },
    { "CVAP", 8 },
    { "CVAU", 5 },
    { "GVA", 18 },
    { "GZVA", 27 },
    { "IGDSW", 20 },
    { "IGDVAC", 19 },
    { "IGSW", 11 },
    { "IGVAC", 10 },
    { "ISW", 2 },
    { "IVAC", 1 },
    { "ZVA", 0 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &DCsList[Idx->_index];
}

const DC *lookupDCByEncoding(uint16_t Encoding) {
  struct IndexType {
    uint16_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x3B1, 1 },
    { 0x3B2, 2 },
    { 0x3B3, 10 },
    { 0x3B4, 11 },
    { 0x3B5, 19 },
    { 0x3B6, 20 },
    { 0x3D2, 4 },
    { 0x3D4, 12 },
    { 0x3D6, 21 },
    { 0x3F2, 7 },
    { 0x3F4, 13 },
    { 0x3F6, 22 },
    { 0x1BA1, 0 },
    { 0x1BA3, 18 },
    { 0x1BA4, 27 },
    { 0x1BD1, 3 },
    { 0x1BD3, 14 },
    { 0x1BD5, 23 },
    { 0x1BD9, 5 },
    { 0x1BE1, 8 },
    { 0x1BE3, 15 },
    { 0x1BE5, 24 },
    { 0x1BE9, 9 },
    { 0x1BEB, 16 },
    { 0x1BED, 25 },
    { 0x1BF1, 6 },
    { 0x1BF3, 17 },
    { 0x1BF5, 26 },
  };

  struct KeyType {
    uint16_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &DCsList[Idx->_index];
}
#endif

#ifdef GET_EXACTFPIMM_DECL
const ExactFPImm *lookupExactFPImmByEnum(uint8_t Enum);
const ExactFPImm *lookupExactFPImmByRepr(StringRef Repr);
#endif

#ifdef GET_EXACTFPIMM_IMPL
constexpr ExactFPImm ExactFPImmsList[] = {
  { "zero", 0x0, "0.0" }, // 0
  { "half", 0x1, "0.5" }, // 1
  { "one", 0x2, "1.0" }, // 2
  { "two", 0x3, "2.0" }, // 3
 };

const ExactFPImm *lookupExactFPImmByEnum(uint8_t Enum) {
  struct IndexType {
    uint8_t Enum;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x0, 0 },
    { 0x1, 1 },
    { 0x2, 2 },
    { 0x3, 3 },
  };

  auto Table = makeArrayRef(Index);
  size_t Idx = Enum;
  return Idx >= Table.size() ? nullptr : &ExactFPImmsList[Table[Idx]._index];
}

const ExactFPImm *lookupExactFPImmByRepr(StringRef Repr) {
  struct IndexType {
    const char * Repr;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "0.0", 0 },
    { "0.5", 1 },
    { "1.0", 2 },
    { "2.0", 3 },
  };

  struct KeyType {
    std::string Repr;
  };
  KeyType Key = {Repr.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpRepr = StringRef(LHS.Repr).compare(RHS.Repr);
      if (CmpRepr < 0) return true;
      if (CmpRepr > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Repr != Idx->Repr)
    return nullptr;
  return &ExactFPImmsList[Idx->_index];
}
#endif

#ifdef GET_IC_DECL
const IC *lookupICByName(StringRef Name);
const IC *lookupICByEncoding(uint16_t Encoding);
#endif

#ifdef GET_IC_IMPL
constexpr IC ICsList[] = {
  { "IALLUIS", 0x388, false }, // 0
  { "IALLU", 0x3A8, false }, // 1
  { "IVAU", 0x1BA9, true }, // 2
 };

const IC *lookupICByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "IALLU", 1 },
    { "IALLUIS", 0 },
    { "IVAU", 2 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &ICsList[Idx->_index];
}

const IC *lookupICByEncoding(uint16_t Encoding) {
  struct IndexType {
    uint16_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x388, 0 },
    { 0x3A8, 1 },
    { 0x1BA9, 2 },
  };

  struct KeyType {
    uint16_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &ICsList[Idx->_index];
}
#endif

#ifdef GET_ISB_DECL
const ISB *lookupISBByName(StringRef Name);
const ISB *lookupISBByEncoding(uint8_t Encoding);
#endif

#ifdef GET_ISB_IMPL
constexpr ISB ISBsList[] = {
  { "sy", 0xF }, // 0
 };

const ISB *lookupISBByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "SY", 0 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &ISBsList[Idx->_index];
}

const ISB *lookupISBByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0xF, 0 },
  };

  struct KeyType {
    uint8_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &ISBsList[Idx->_index];
}
#endif

#ifdef GET_PRCTX_DECL
const PRCTX *lookupPRCTXByName(StringRef Name);
const PRCTX *lookupPRCTXByEncoding(uint16_t Encoding);
#endif

#ifdef GET_PRCTX_IMPL
constexpr PRCTX PRCTXsList[] = {
  { "RCTX", 0x373, true,  {AArch64::FeaturePredRes}  }, // 0
 };

const PRCTX *lookupPRCTXByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "RCTX", 0 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &PRCTXsList[Idx->_index];
}

const PRCTX *lookupPRCTXByEncoding(uint16_t Encoding) {
  struct IndexType {
    uint16_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x373, 0 },
  };

  struct KeyType {
    uint16_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &PRCTXsList[Idx->_index];
}
#endif

#ifdef GET_PRFM_DECL
const PRFM *lookupPRFMByName(StringRef Name);
const PRFM *lookupPRFMByEncoding(uint8_t Encoding);
#endif

#ifdef GET_PRFM_IMPL
constexpr PRFM PRFMsList[] = {
  { "pldl1keep", 0x0 }, // 0
  { "pldl1strm", 0x1 }, // 1
  { "pldl2keep", 0x2 }, // 2
  { "pldl2strm", 0x3 }, // 3
  { "pldl3keep", 0x4 }, // 4
  { "pldl3strm", 0x5 }, // 5
  { "plil1keep", 0x8 }, // 6
  { "plil1strm", 0x9 }, // 7
  { "plil2keep", 0xA }, // 8
  { "plil2strm", 0xB }, // 9
  { "plil3keep", 0xC }, // 10
  { "plil3strm", 0xD }, // 11
  { "pstl1keep", 0x10 }, // 12
  { "pstl1strm", 0x11 }, // 13
  { "pstl2keep", 0x12 }, // 14
  { "pstl2strm", 0x13 }, // 15
  { "pstl3keep", 0x14 }, // 16
  { "pstl3strm", 0x15 }, // 17
 };

const PRFM *lookupPRFMByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "PLDL1KEEP", 0 },
    { "PLDL1STRM", 1 },
    { "PLDL2KEEP", 2 },
    { "PLDL2STRM", 3 },
    { "PLDL3KEEP", 4 },
    { "PLDL3STRM", 5 },
    { "PLIL1KEEP", 6 },
    { "PLIL1STRM", 7 },
    { "PLIL2KEEP", 8 },
    { "PLIL2STRM", 9 },
    { "PLIL3KEEP", 10 },
    { "PLIL3STRM", 11 },
    { "PSTL1KEEP", 12 },
    { "PSTL1STRM", 13 },
    { "PSTL2KEEP", 14 },
    { "PSTL2STRM", 15 },
    { "PSTL3KEEP", 16 },
    { "PSTL3STRM", 17 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &PRFMsList[Idx->_index];
}

const PRFM *lookupPRFMByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x0, 0 },
    { 0x1, 1 },
    { 0x2, 2 },
    { 0x3, 3 },
    { 0x4, 4 },
    { 0x5, 5 },
    { 0x8, 6 },
    { 0x9, 7 },
    { 0xA, 8 },
    { 0xB, 9 },
    { 0xC, 10 },
    { 0xD, 11 },
    { 0x10, 12 },
    { 0x11, 13 },
    { 0x12, 14 },
    { 0x13, 15 },
    { 0x14, 16 },
    { 0x15, 17 },
  };

  struct KeyType {
    uint8_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &PRFMsList[Idx->_index];
}
#endif

#ifdef GET_PSB_DECL
const PSB *lookupPSBByName(StringRef Name);
const PSB *lookupPSBByEncoding(uint8_t Encoding);
#endif

#ifdef GET_PSB_IMPL
constexpr PSB PSBsList[] = {
  { "csync", 0x11 }, // 0
 };

const PSB *lookupPSBByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "CSYNC", 0 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &PSBsList[Idx->_index];
}

const PSB *lookupPSBByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x11, 0 },
  };

  struct KeyType {
    uint8_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &PSBsList[Idx->_index];
}
#endif

#ifdef GET_PSTATE_DECL
const PState *lookupPStateByName(StringRef Name);
const PState *lookupPStateByEncoding(uint8_t Encoding);
#endif

#ifdef GET_PSTATE_IMPL
constexpr PState PStatesList[] = {
  { "SPSel", 0x5,  {}  }, // 0
  { "DAIFSet", 0x1E,  {}  }, // 1
  { "DAIFClr", 0x1F,  {}  }, // 2
  { "PAN", 0x4,  {AArch64::FeaturePAN}  }, // 3
  { "UAO", 0x3,  {AArch64::FeaturePsUAO}  }, // 4
  { "DIT", 0x1A,  {AArch64::FeatureDIT}  }, // 5
  { "SSBS", 0x19,  {AArch64::FeatureSSBS}  }, // 6
  { "TCO", 0x1C,  {AArch64::FeatureMTE}  }, // 7
 };

const PState *lookupPStateByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "DAIFCLR", 2 },
    { "DAIFSET", 1 },
    { "DIT", 5 },
    { "PAN", 3 },
    { "SPSEL", 0 },
    { "SSBS", 6 },
    { "TCO", 7 },
    { "UAO", 4 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &PStatesList[Idx->_index];
}

const PState *lookupPStateByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x3, 4 },
    { 0x4, 3 },
    { 0x5, 0 },
    { 0x19, 6 },
    { 0x1A, 5 },
    { 0x1C, 7 },
    { 0x1E, 1 },
    { 0x1F, 2 },
  };

  struct KeyType {
    uint8_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &PStatesList[Idx->_index];
}
#endif

#ifdef GET_SVCR_DECL
const SVCR *lookupSVCRByName(StringRef Name);
const SVCR *lookupSVCRByEncoding(uint8_t Encoding);
#endif

#ifdef GET_SVCR_IMPL
constexpr SVCR SVCRsList[] = {
  { "SVCRSM", 0x1,  {AArch64::FeatureSME}  }, // 0
  { "SVCRZA", 0x2,  {AArch64::FeatureSME}  }, // 1
  { "SVCRSMZA", 0x3,  {AArch64::FeatureSME}  }, // 2
 };

const SVCR *lookupSVCRByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "SVCRSM", 0 },
    { "SVCRSMZA", 2 },
    { "SVCRZA", 1 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &SVCRsList[Idx->_index];
}

const SVCR *lookupSVCRByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x1, 0 },
    { 0x2, 1 },
    { 0x3, 2 },
  };

  struct KeyType {
    uint8_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &SVCRsList[Idx->_index];
}
#endif

#ifdef GET_SVEPREDPAT_DECL
const SVEPREDPAT *lookupSVEPREDPATByName(StringRef Name);
const SVEPREDPAT *lookupSVEPREDPATByEncoding(uint8_t Encoding);
#endif

#ifdef GET_SVEPREDPAT_IMPL
constexpr SVEPREDPAT SVEPREDPATsList[] = {
  { "pow2", 0x0 }, // 0
  { "vl1", 0x1 }, // 1
  { "vl2", 0x2 }, // 2
  { "vl3", 0x3 }, // 3
  { "vl4", 0x4 }, // 4
  { "vl5", 0x5 }, // 5
  { "vl6", 0x6 }, // 6
  { "vl7", 0x7 }, // 7
  { "vl8", 0x8 }, // 8
  { "vl16", 0x9 }, // 9
  { "vl32", 0xA }, // 10
  { "vl64", 0xB }, // 11
  { "vl128", 0xC }, // 12
  { "vl256", 0xD }, // 13
  { "mul4", 0x1D }, // 14
  { "mul3", 0x1E }, // 15
  { "all", 0x1F }, // 16
 };

const SVEPREDPAT *lookupSVEPREDPATByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "ALL", 16 },
    { "MUL3", 15 },
    { "MUL4", 14 },
    { "POW2", 0 },
    { "VL1", 1 },
    { "VL128", 12 },
    { "VL16", 9 },
    { "VL2", 2 },
    { "VL256", 13 },
    { "VL3", 3 },
    { "VL32", 10 },
    { "VL4", 4 },
    { "VL5", 5 },
    { "VL6", 6 },
    { "VL64", 11 },
    { "VL7", 7 },
    { "VL8", 8 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &SVEPREDPATsList[Idx->_index];
}

const SVEPREDPAT *lookupSVEPREDPATByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x0, 0 },
    { 0x1, 1 },
    { 0x2, 2 },
    { 0x3, 3 },
    { 0x4, 4 },
    { 0x5, 5 },
    { 0x6, 6 },
    { 0x7, 7 },
    { 0x8, 8 },
    { 0x9, 9 },
    { 0xA, 10 },
    { 0xB, 11 },
    { 0xC, 12 },
    { 0xD, 13 },
    { 0x1D, 14 },
    { 0x1E, 15 },
    { 0x1F, 16 },
  };

  struct KeyType {
    uint8_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &SVEPREDPATsList[Idx->_index];
}
#endif

#ifdef GET_SVEPRFM_DECL
const SVEPRFM *lookupSVEPRFMByName(StringRef Name);
const SVEPRFM *lookupSVEPRFMByEncoding(uint8_t Encoding);
#endif

#ifdef GET_SVEPRFM_IMPL
constexpr SVEPRFM SVEPRFMsList[] = {
  { "pldl1keep", 0x0,  {AArch64::FeatureSVE}  }, // 0
  { "pldl1strm", 0x1,  {AArch64::FeatureSVE}  }, // 1
  { "pldl2keep", 0x2,  {AArch64::FeatureSVE}  }, // 2
  { "pldl2strm", 0x3,  {AArch64::FeatureSVE}  }, // 3
  { "pldl3keep", 0x4,  {AArch64::FeatureSVE}  }, // 4
  { "pldl3strm", 0x5,  {AArch64::FeatureSVE}  }, // 5
  { "pstl1keep", 0x8,  {AArch64::FeatureSVE}  }, // 6
  { "pstl1strm", 0x9,  {AArch64::FeatureSVE}  }, // 7
  { "pstl2keep", 0xA,  {AArch64::FeatureSVE}  }, // 8
  { "pstl2strm", 0xB,  {AArch64::FeatureSVE}  }, // 9
  { "pstl3keep", 0xC,  {AArch64::FeatureSVE}  }, // 10
  { "pstl3strm", 0xD,  {AArch64::FeatureSVE}  }, // 11
 };

const SVEPRFM *lookupSVEPRFMByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "PLDL1KEEP", 0 },
    { "PLDL1STRM", 1 },
    { "PLDL2KEEP", 2 },
    { "PLDL2STRM", 3 },
    { "PLDL3KEEP", 4 },
    { "PLDL3STRM", 5 },
    { "PSTL1KEEP", 6 },
    { "PSTL1STRM", 7 },
    { "PSTL2KEEP", 8 },
    { "PSTL2STRM", 9 },
    { "PSTL3KEEP", 10 },
    { "PSTL3STRM", 11 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &SVEPRFMsList[Idx->_index];
}

const SVEPRFM *lookupSVEPRFMByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x0, 0 },
    { 0x1, 1 },
    { 0x2, 2 },
    { 0x3, 3 },
    { 0x4, 4 },
    { 0x5, 5 },
    { 0x8, 6 },
    { 0x9, 7 },
    { 0xA, 8 },
    { 0xB, 9 },
    { 0xC, 10 },
    { 0xD, 11 },
  };

  struct KeyType {
    uint8_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &SVEPRFMsList[Idx->_index];
}
#endif

#ifdef GET_SYSREG_DECL
const SysReg *lookupSysRegByName(StringRef Name);
const SysReg *lookupSysRegByEncoding(uint16_t Encoding);
#endif

#ifdef GET_SYSREG_IMPL
constexpr SysReg SysRegsList[] = {
  { "MDCCSR_EL0", "MDCCSR_EL0", 0x9808, true, false,  {}  }, // 0
  { "DBGDTRRX_EL0", "DBGDTRRX_EL0", 0x9828, true, false,  {}  }, // 1
  { "MDRAR_EL1", "MDRAR_EL1", 0x8080, true, false,  {}  }, // 2
  { "OSLSR_EL1", "OSLSR_EL1", 0x808C, true, false,  {}  }, // 3
  { "DBGAUTHSTATUS_EL1", "DBGAUTHSTATUS_EL1", 0x83F6, true, false,  {}  }, // 4
  { "PMCEID0_EL0", "PMCEID0_EL0", 0xDCE6, true, false,  {}  }, // 5
  { "PMCEID1_EL0", "PMCEID1_EL0", 0xDCE7, true, false,  {}  }, // 6
  { "MIDR_EL1", "MIDR_EL1", 0xC000, true, false,  {}  }, // 7
  { "CCSIDR_EL1", "CCSIDR_EL1", 0xC800, true, false,  {}  }, // 8
  { "CCSIDR2_EL1", "CCSIDR2_EL1", 0xC802, true, false,  {AArch64::FeatureCCIDX}  }, // 9
  { "CLIDR_EL1", "CLIDR_EL1", 0xC801, true, false,  {}  }, // 10
  { "CTR_EL0", "CTR_EL0", 0xD801, true, false,  {}  }, // 11
  { "MPIDR_EL1", "MPIDR_EL1", 0xC005, true, false,  {}  }, // 12
  { "REVIDR_EL1", "REVIDR_EL1", 0xC006, true, false,  {}  }, // 13
  { "AIDR_EL1", "AIDR_EL1", 0xC807, true, false,  {}  }, // 14
  { "DCZID_EL0", "DCZID_EL0", 0xD807, true, false,  {}  }, // 15
  { "ID_PFR0_EL1", "ID_PFR0_EL1", 0xC008, true, false,  {}  }, // 16
  { "ID_PFR1_EL1", "ID_PFR1_EL1", 0xC009, true, false,  {}  }, // 17
  { "ID_PFR2_EL1", "ID_PFR2_EL1", 0xC01C, true, false,  {AArch64::FeatureSpecRestrict}  }, // 18
  { "ID_DFR0_EL1", "ID_DFR0_EL1", 0xC00A, true, false,  {}  }, // 19
  { "ID_AFR0_EL1", "ID_AFR0_EL1", 0xC00B, true, false,  {}  }, // 20
  { "ID_MMFR0_EL1", "ID_MMFR0_EL1", 0xC00C, true, false,  {}  }, // 21
  { "ID_MMFR1_EL1", "ID_MMFR1_EL1", 0xC00D, true, false,  {}  }, // 22
  { "ID_MMFR2_EL1", "ID_MMFR2_EL1", 0xC00E, true, false,  {}  }, // 23
  { "ID_MMFR3_EL1", "ID_MMFR3_EL1", 0xC00F, true, false,  {}  }, // 24
  { "ID_ISAR0_EL1", "ID_ISAR0_EL1", 0xC010, true, false,  {}  }, // 25
  { "ID_ISAR1_EL1", "ID_ISAR1_EL1", 0xC011, true, false,  {}  }, // 26
  { "ID_ISAR2_EL1", "ID_ISAR2_EL1", 0xC012, true, false,  {}  }, // 27
  { "ID_ISAR3_EL1", "ID_ISAR3_EL1", 0xC013, true, false,  {}  }, // 28
  { "ID_ISAR4_EL1", "ID_ISAR4_EL1", 0xC014, true, false,  {}  }, // 29
  { "ID_ISAR5_EL1", "ID_ISAR5_EL1", 0xC015, true, false,  {}  }, // 30
  { "ID_ISAR6_EL1", "ID_ISAR6_EL1", 0xC017, true, false,  {AArch64::HasV8_2aOps}  }, // 31
  { "ID_AA64PFR0_EL1", "ID_AA64PFR0_EL1", 0xC020, true, false,  {}  }, // 32
  { "ID_AA64PFR1_EL1", "ID_AA64PFR1_EL1", 0xC021, true, false,  {}  }, // 33
  { "ID_AA64DFR0_EL1", "ID_AA64DFR0_EL1", 0xC028, true, false,  {}  }, // 34
  { "ID_AA64DFR1_EL1", "ID_AA64DFR1_EL1", 0xC029, true, false,  {}  }, // 35
  { "ID_AA64AFR0_EL1", "ID_AA64AFR0_EL1", 0xC02C, true, false,  {}  }, // 36
  { "ID_AA64AFR1_EL1", "ID_AA64AFR1_EL1", 0xC02D, true, false,  {}  }, // 37
  { "ID_AA64ISAR0_EL1", "ID_AA64ISAR0_EL1", 0xC030, true, false,  {}  }, // 38
  { "ID_AA64ISAR1_EL1", "ID_AA64ISAR1_EL1", 0xC031, true, false,  {}  }, // 39
  { "ID_AA64ISAR2_EL1", "ID_AA64ISAR2_EL1", 0xC032, true, false,  {}  }, // 40
  { "ID_AA64MMFR0_EL1", "ID_AA64MMFR0_EL1", 0xC038, true, false,  {}  }, // 41
  { "ID_AA64MMFR1_EL1", "ID_AA64MMFR1_EL1", 0xC039, true, false,  {}  }, // 42
  { "ID_AA64MMFR2_EL1", "ID_AA64MMFR2_EL1", 0xC03A, true, false,  {}  }, // 43
  { "MVFR0_EL1", "MVFR0_EL1", 0xC018, true, false,  {}  }, // 44
  { "MVFR1_EL1", "MVFR1_EL1", 0xC019, true, false,  {}  }, // 45
  { "MVFR2_EL1", "MVFR2_EL1", 0xC01A, true, false,  {}  }, // 46
  { "RVBAR_EL1", "RVBAR_EL1", 0xC601, true, false,  {}  }, // 47
  { "RVBAR_EL2", "RVBAR_EL2", 0xE601, true, false,  {}  }, // 48
  { "RVBAR_EL3", "RVBAR_EL3", 0xF601, true, false,  {}  }, // 49
  { "ISR_EL1", "ISR_EL1", 0xC608, true, false,  {}  }, // 50
  { "CNTPCT_EL0", "CNTPCT_EL0", 0xDF01, true, false,  {}  }, // 51
  { "CNTVCT_EL0", "CNTVCT_EL0", 0xDF02, true, false,  {}  }, // 52
  { "ID_MMFR4_EL1", "ID_MMFR4_EL1", 0xC016, true, false,  {}  }, // 53
  { "ID_MMFR5_EL1", "ID_MMFR5_EL1", 0xC01E, true, false,  {}  }, // 54
  { "TRCSTATR", "TRCSTATR", 0x8818, true, false,  {}  }, // 55
  { "TRCIDR8", "TRCIDR8", 0x8806, true, false,  {}  }, // 56
  { "TRCIDR9", "TRCIDR9", 0x880E, true, false,  {}  }, // 57
  { "TRCIDR10", "TRCIDR10", 0x8816, true, false,  {}  }, // 58
  { "TRCIDR11", "TRCIDR11", 0x881E, true, false,  {}  }, // 59
  { "TRCIDR12", "TRCIDR12", 0x8826, true, false,  {}  }, // 60
  { "TRCIDR13", "TRCIDR13", 0x882E, true, false,  {}  }, // 61
  { "TRCIDR0", "TRCIDR0", 0x8847, true, false,  {}  }, // 62
  { "TRCIDR1", "TRCIDR1", 0x884F, true, false,  {}  }, // 63
  { "TRCIDR2", "TRCIDR2", 0x8857, true, false,  {}  }, // 64
  { "TRCIDR3", "TRCIDR3", 0x885F, true, false,  {}  }, // 65
  { "TRCIDR4", "TRCIDR4", 0x8867, true, false,  {}  }, // 66
  { "TRCIDR5", "TRCIDR5", 0x886F, true, false,  {}  }, // 67
  { "TRCIDR6", "TRCIDR6", 0x8877, true, false,  {}  }, // 68
  { "TRCIDR7", "TRCIDR7", 0x887F, true, false,  {}  }, // 69
  { "TRCOSLSR", "TRCOSLSR", 0x888C, true, false,  {}  }, // 70
  { "TRCPDSR", "TRCPDSR", 0x88AC, true, false,  {}  }, // 71
  { "TRCDEVAFF0", "TRCDEVAFF0", 0x8BD6, true, false,  {}  }, // 72
  { "TRCDEVAFF1", "TRCDEVAFF1", 0x8BDE, true, false,  {}  }, // 73
  { "TRCLSR", "TRCLSR", 0x8BEE, true, false,  {}  }, // 74
  { "TRCAUTHSTATUS", "TRCAUTHSTATUS", 0x8BF6, true, false,  {}  }, // 75
  { "TRCDEVARCH", "TRCDEVARCH", 0x8BFE, true, false,  {}  }, // 76
  { "TRCDEVID", "TRCDEVID", 0x8B97, true, false,  {}  }, // 77
  { "TRCDEVTYPE", "TRCDEVTYPE", 0x8B9F, true, false,  {}  }, // 78
  { "TRCPIDR4", "TRCPIDR4", 0x8BA7, true, false,  {}  }, // 79
  { "TRCPIDR5", "TRCPIDR5", 0x8BAF, true, false,  {}  }, // 80
  { "TRCPIDR6", "TRCPIDR6", 0x8BB7, true, false,  {}  }, // 81
  { "TRCPIDR7", "TRCPIDR7", 0x8BBF, true, false,  {}  }, // 82
  { "TRCPIDR0", "TRCPIDR0", 0x8BC7, true, false,  {}  }, // 83
  { "TRCPIDR1", "TRCPIDR1", 0x8BCF, true, false,  {}  }, // 84
  { "TRCPIDR2", "TRCPIDR2", 0x8BD7, true, false,  {}  }, // 85
  { "TRCPIDR3", "TRCPIDR3", 0x8BDF, true, false,  {}  }, // 86
  { "TRCCIDR0", "TRCCIDR0", 0x8BE7, true, false,  {}  }, // 87
  { "TRCCIDR1", "TRCCIDR1", 0x8BEF, true, false,  {}  }, // 88
  { "TRCCIDR2", "TRCCIDR2", 0x8BF7, true, false,  {}  }, // 89
  { "TRCCIDR3", "TRCCIDR3", 0x8BFF, true, false,  {}  }, // 90
  { "ICC_IAR1_EL1", "ICC_IAR1_EL1", 0xC660, true, false,  {}  }, // 91
  { "ICC_IAR0_EL1", "ICC_IAR0_EL1", 0xC640, true, false,  {}  }, // 92
  { "ICC_HPPIR1_EL1", "ICC_HPPIR1_EL1", 0xC662, true, false,  {}  }, // 93
  { "ICC_HPPIR0_EL1", "ICC_HPPIR0_EL1", 0xC642, true, false,  {}  }, // 94
  { "ICC_RPR_EL1", "ICC_RPR_EL1", 0xC65B, true, false,  {}  }, // 95
  { "ICH_VTR_EL2", "ICH_VTR_EL2", 0xE659, true, false,  {}  }, // 96
  { "ICH_EISR_EL2", "ICH_EISR_EL2", 0xE65B, true, false,  {}  }, // 97
  { "ICH_ELRSR_EL2", "ICH_ELRSR_EL2", 0xE65D, true, false,  {}  }, // 98
  { "ID_AA64ZFR0_EL1", "ID_AA64ZFR0_EL1", 0xC024, true, false,  {AArch64::FeatureSVE}  }, // 99
  { "LORID_EL1", "LORID_EL1", 0xC527, true, false,  {AArch64::FeatureLOR}  }, // 100
  { "ERRIDR_EL1", "ERRIDR_EL1", 0xC298, true, false,  {AArch64::FeatureRAS}  }, // 101
  { "ERXFR_EL1", "ERXFR_EL1", 0xC2A0, true, false,  {AArch64::FeatureRAS}  }, // 102
  { "RNDR", "RNDR", 0xD920, true, false,  {AArch64::FeatureRandGen}  }, // 103
  { "RNDRRS", "RNDRRS", 0xD921, true, false,  {AArch64::FeatureRandGen}  }, // 104
  { "SCXTNUM_EL0", "SCXTNUM_EL0", 0xDE87, true, true,  {AArch64::FeatureSpecRestrict}  }, // 105
  { "SCXTNUM_EL1", "SCXTNUM_EL1", 0xC687, true, true,  {AArch64::FeatureSpecRestrict}  }, // 106
  { "SCXTNUM_EL2", "SCXTNUM_EL2", 0xE687, true, true,  {AArch64::FeatureSpecRestrict}  }, // 107
  { "SCXTNUM_EL3", "SCXTNUM_EL3", 0xF687, true, true,  {AArch64::FeatureSpecRestrict}  }, // 108
  { "SCXTNUM_EL12", "SCXTNUM_EL12", 0xEE87, true, true,  {AArch64::FeatureSpecRestrict}  }, // 109
  { "MFAR_EL3", "MFAR_EL3", 0xF305, true, true,  {AArch64::FeatureRME}  }, // 110
  { "GPCCR_EL3", "GPCCR_EL3", 0xF10E, true, true,  {AArch64::FeatureRME}  }, // 111
  { "GPTBR_EL3", "GPTBR_EL3", 0xF10C, true, true,  {AArch64::FeatureRME}  }, // 112
  { "ID_AA64SMFR0_EL1", "ID_AA64SMFR0_EL1", 0xC025, true, false,  {AArch64::FeatureSME}  }, // 113
  { "DBGDTRTX_EL0", "DBGDTRTX_EL0", 0x9828, false, true,  {}  }, // 114
  { "OSLAR_EL1", "OSLAR_EL1", 0x8084, false, true,  {}  }, // 115
  { "PMSWINC_EL0", "PMSWINC_EL0", 0xDCE4, false, true,  {}  }, // 116
  { "TRCOSLAR", "TRCOSLAR", 0x8884, false, true,  {}  }, // 117
  { "TRCLAR", "TRCLAR", 0x8BE6, false, true,  {}  }, // 118
  { "ICC_EOIR1_EL1", "ICC_EOIR1_EL1", 0xC661, false, true,  {}  }, // 119
  { "ICC_EOIR0_EL1", "ICC_EOIR0_EL1", 0xC641, false, true,  {}  }, // 120
  { "ICC_DIR_EL1", "ICC_DIR_EL1", 0xC659, false, true,  {}  }, // 121
  { "ICC_SGI1R_EL1", "ICC_SGI1R_EL1", 0xC65D, false, true,  {}  }, // 122
  { "ICC_ASGI1R_EL1", "ICC_ASGI1R_EL1", 0xC65E, false, true,  {}  }, // 123
  { "ICC_SGI0R_EL1", "ICC_SGI0R_EL1", 0xC65F, false, true,  {}  }, // 124
  { "OSDTRRX_EL1", "OSDTRRX_EL1", 0x8002, true, true,  {}  }, // 125
  { "OSDTRTX_EL1", "OSDTRTX_EL1", 0x801A, true, true,  {}  }, // 126
  { "TEECR32_EL1", "TEECR32_EL1", 0x9000, true, true,  {}  }, // 127
  { "MDCCINT_EL1", "MDCCINT_EL1", 0x8010, true, true,  {}  }, // 128
  { "MDSCR_EL1", "MDSCR_EL1", 0x8012, true, true,  {}  }, // 129
  { "DBGDTR_EL0", "DBGDTR_EL0", 0x9820, true, true,  {}  }, // 130
  { "OSECCR_EL1", "OSECCR_EL1", 0x8032, true, true,  {}  }, // 131
  { "DBGVCR32_EL2", "DBGVCR32_EL2", 0xA038, true, true,  {}  }, // 132
  { "DBGBVR0_EL1", "DBGBVR0_EL1", 0x8004, true, true,  {}  }, // 133
  { "DBGBVR1_EL1", "DBGBVR1_EL1", 0x800C, true, true,  {}  }, // 134
  { "DBGBVR2_EL1", "DBGBVR2_EL1", 0x8014, true, true,  {}  }, // 135
  { "DBGBVR3_EL1", "DBGBVR3_EL1", 0x801C, true, true,  {}  }, // 136
  { "DBGBVR4_EL1", "DBGBVR4_EL1", 0x8024, true, true,  {}  }, // 137
  { "DBGBVR5_EL1", "DBGBVR5_EL1", 0x802C, true, true,  {}  }, // 138
  { "DBGBVR6_EL1", "DBGBVR6_EL1", 0x8034, true, true,  {}  }, // 139
  { "DBGBVR7_EL1", "DBGBVR7_EL1", 0x803C, true, true,  {}  }, // 140
  { "DBGBVR8_EL1", "DBGBVR8_EL1", 0x8044, true, true,  {}  }, // 141
  { "DBGBVR9_EL1", "DBGBVR9_EL1", 0x804C, true, true,  {}  }, // 142
  { "DBGBVR10_EL1", "DBGBVR10_EL1", 0x8054, true, true,  {}  }, // 143
  { "DBGBVR11_EL1", "DBGBVR11_EL1", 0x805C, true, true,  {}  }, // 144
  { "DBGBVR12_EL1", "DBGBVR12_EL1", 0x8064, true, true,  {}  }, // 145
  { "DBGBVR13_EL1", "DBGBVR13_EL1", 0x806C, true, true,  {}  }, // 146
  { "DBGBVR14_EL1", "DBGBVR14_EL1", 0x8074, true, true,  {}  }, // 147
  { "DBGBVR15_EL1", "DBGBVR15_EL1", 0x807C, true, true,  {}  }, // 148
  { "DBGBCR0_EL1", "DBGBCR0_EL1", 0x8005, true, true,  {}  }, // 149
  { "DBGBCR1_EL1", "DBGBCR1_EL1", 0x800D, true, true,  {}  }, // 150
  { "DBGBCR2_EL1", "DBGBCR2_EL1", 0x8015, true, true,  {}  }, // 151
  { "DBGBCR3_EL1", "DBGBCR3_EL1", 0x801D, true, true,  {}  }, // 152
  { "DBGBCR4_EL1", "DBGBCR4_EL1", 0x8025, true, true,  {}  }, // 153
  { "DBGBCR5_EL1", "DBGBCR5_EL1", 0x802D, true, true,  {}  }, // 154
  { "DBGBCR6_EL1", "DBGBCR6_EL1", 0x8035, true, true,  {}  }, // 155
  { "DBGBCR7_EL1", "DBGBCR7_EL1", 0x803D, true, true,  {}  }, // 156
  { "DBGBCR8_EL1", "DBGBCR8_EL1", 0x8045, true, true,  {}  }, // 157
  { "DBGBCR9_EL1", "DBGBCR9_EL1", 0x804D, true, true,  {}  }, // 158
  { "DBGBCR10_EL1", "DBGBCR10_EL1", 0x8055, true, true,  {}  }, // 159
  { "DBGBCR11_EL1", "DBGBCR11_EL1", 0x805D, true, true,  {}  }, // 160
  { "DBGBCR12_EL1", "DBGBCR12_EL1", 0x8065, true, true,  {}  }, // 161
  { "DBGBCR13_EL1", "DBGBCR13_EL1", 0x806D, true, true,  {}  }, // 162
  { "DBGBCR14_EL1", "DBGBCR14_EL1", 0x8075, true, true,  {}  }, // 163
  { "DBGBCR15_EL1", "DBGBCR15_EL1", 0x807D, true, true,  {}  }, // 164
  { "DBGWVR0_EL1", "DBGWVR0_EL1", 0x8006, true, true,  {}  }, // 165
  { "DBGWVR1_EL1", "DBGWVR1_EL1", 0x800E, true, true,  {}  }, // 166
  { "DBGWVR2_EL1", "DBGWVR2_EL1", 0x8016, true, true,  {}  }, // 167
  { "DBGWVR3_EL1", "DBGWVR3_EL1", 0x801E, true, true,  {}  }, // 168
  { "DBGWVR4_EL1", "DBGWVR4_EL1", 0x8026, true, true,  {}  }, // 169
  { "DBGWVR5_EL1", "DBGWVR5_EL1", 0x802E, true, true,  {}  }, // 170
  { "DBGWVR6_EL1", "DBGWVR6_EL1", 0x8036, true, true,  {}  }, // 171
  { "DBGWVR7_EL1", "DBGWVR7_EL1", 0x803E, true, true,  {}  }, // 172
  { "DBGWVR8_EL1", "DBGWVR8_EL1", 0x8046, true, true,  {}  }, // 173
  { "DBGWVR9_EL1", "DBGWVR9_EL1", 0x804E, true, true,  {}  }, // 174
  { "DBGWVR10_EL1", "DBGWVR10_EL1", 0x8056, true, true,  {}  }, // 175
  { "DBGWVR11_EL1", "DBGWVR11_EL1", 0x805E, true, true,  {}  }, // 176
  { "DBGWVR12_EL1", "DBGWVR12_EL1", 0x8066, true, true,  {}  }, // 177
  { "DBGWVR13_EL1", "DBGWVR13_EL1", 0x806E, true, true,  {}  }, // 178
  { "DBGWVR14_EL1", "DBGWVR14_EL1", 0x8076, true, true,  {}  }, // 179
  { "DBGWVR15_EL1", "DBGWVR15_EL1", 0x807E, true, true,  {}  }, // 180
  { "DBGWCR0_EL1", "DBGWCR0_EL1", 0x8007, true, true,  {}  }, // 181
  { "DBGWCR1_EL1", "DBGWCR1_EL1", 0x800F, true, true,  {}  }, // 182
  { "DBGWCR2_EL1", "DBGWCR2_EL1", 0x8017, true, true,  {}  }, // 183
  { "DBGWCR3_EL1", "DBGWCR3_EL1", 0x801F, true, true,  {}  }, // 184
  { "DBGWCR4_EL1", "DBGWCR4_EL1", 0x8027, true, true,  {}  }, // 185
  { "DBGWCR5_EL1", "DBGWCR5_EL1", 0x802F, true, true,  {}  }, // 186
  { "DBGWCR6_EL1", "DBGWCR6_EL1", 0x8037, true, true,  {}  }, // 187
  { "DBGWCR7_EL1", "DBGWCR7_EL1", 0x803F, true, true,  {}  }, // 188
  { "DBGWCR8_EL1", "DBGWCR8_EL1", 0x8047, true, true,  {}  }, // 189
  { "DBGWCR9_EL1", "DBGWCR9_EL1", 0x804F, true, true,  {}  }, // 190
  { "DBGWCR10_EL1", "DBGWCR10_EL1", 0x8057, true, true,  {}  }, // 191
  { "DBGWCR11_EL1", "DBGWCR11_EL1", 0x805F, true, true,  {}  }, // 192
  { "DBGWCR12_EL1", "DBGWCR12_EL1", 0x8067, true, true,  {}  }, // 193
  { "DBGWCR13_EL1", "DBGWCR13_EL1", 0x806F, true, true,  {}  }, // 194
  { "DBGWCR14_EL1", "DBGWCR14_EL1", 0x8077, true, true,  {}  }, // 195
  { "DBGWCR15_EL1", "DBGWCR15_EL1", 0x807F, true, true,  {}  }, // 196
  { "TEEHBR32_EL1", "TEEHBR32_EL1", 0x9080, true, true,  {}  }, // 197
  { "OSDLR_EL1", "OSDLR_EL1", 0x809C, true, true,  {}  }, // 198
  { "DBGPRCR_EL1", "DBGPRCR_EL1", 0x80A4, true, true,  {}  }, // 199
  { "DBGCLAIMSET_EL1", "DBGCLAIMSET_EL1", 0x83C6, true, true,  {}  }, // 200
  { "DBGCLAIMCLR_EL1", "DBGCLAIMCLR_EL1", 0x83CE, true, true,  {}  }, // 201
  { "CSSELR_EL1", "CSSELR_EL1", 0xD000, true, true,  {}  }, // 202
  { "VPIDR_EL2", "VPIDR_EL2", 0xE000, true, true,  {}  }, // 203
  { "VMPIDR_EL2", "VMPIDR_EL2", 0xE005, true, true,  {}  }, // 204
  { "CPACR_EL1", "CPACR_EL1", 0xC082, true, true,  {}  }, // 205
  { "SCTLR_EL1", "SCTLR_EL1", 0xC080, true, true,  {}  }, // 206
  { "SCTLR_EL2", "SCTLR_EL2", 0xE080, true, true,  {}  }, // 207
  { "SCTLR_EL3", "SCTLR_EL3", 0xF080, true, true,  {}  }, // 208
  { "ACTLR_EL1", "ACTLR_EL1", 0xC081, true, true,  {}  }, // 209
  { "ACTLR_EL2", "ACTLR_EL2", 0xE081, true, true,  {}  }, // 210
  { "ACTLR_EL3", "ACTLR_EL3", 0xF081, true, true,  {}  }, // 211
  { "HCR_EL2", "HCR_EL2", 0xE088, true, true,  {}  }, // 212
  { "HCRX_EL2", "HCRX_EL2", 0xE092, true, true,  {AArch64::FeatureHCX}  }, // 213
  { "SCR_EL3", "SCR_EL3", 0xF088, true, true,  {}  }, // 214
  { "MDCR_EL2", "MDCR_EL2", 0xE089, true, true,  {}  }, // 215
  { "SDER32_EL3", "SDER32_EL3", 0xF089, true, true,  {}  }, // 216
  { "CPTR_EL2", "CPTR_EL2", 0xE08A, true, true,  {}  }, // 217
  { "CPTR_EL3", "CPTR_EL3", 0xF08A, true, true,  {}  }, // 218
  { "HSTR_EL2", "HSTR_EL2", 0xE08B, true, true,  {}  }, // 219
  { "HACR_EL2", "HACR_EL2", 0xE08F, true, true,  {}  }, // 220
  { "MDCR_EL3", "MDCR_EL3", 0xF099, true, true,  {}  }, // 221
  { "TTBR0_EL1", "TTBR0_EL1", 0xC100, true, true,  {}  }, // 222
  { "TTBR0_EL3", "TTBR0_EL3", 0xF100, true, true,  {}  }, // 223
  { "TTBR0_EL2", "VSCTLR_EL2", 0xE100, true, true,  {AArch64::FeatureEL2VMSA}  }, // 224
  { "VTTBR_EL2", "VTTBR_EL2", 0xE108, true, true,  {AArch64::FeatureEL2VMSA}  }, // 225
  { "TTBR1_EL1", "TTBR1_EL1", 0xC101, true, true,  {}  }, // 226
  { "TCR_EL1", "TCR_EL1", 0xC102, true, true,  {}  }, // 227
  { "TCR_EL2", "TCR_EL2", 0xE102, true, true,  {}  }, // 228
  { "TCR_EL3", "TCR_EL3", 0xF102, true, true,  {}  }, // 229
  { "VTCR_EL2", "VTCR_EL2", 0xE10A, true, true,  {}  }, // 230
  { "DACR32_EL2", "DACR32_EL2", 0xE180, true, true,  {}  }, // 231
  { "SPSR_EL1", "SPSR_EL1", 0xC200, true, true,  {}  }, // 232
  { "SPSR_EL2", "SPSR_EL2", 0xE200, true, true,  {}  }, // 233
  { "SPSR_EL3", "SPSR_EL3", 0xF200, true, true,  {}  }, // 234
  { "ELR_EL1", "ELR_EL1", 0xC201, true, true,  {}  }, // 235
  { "ELR_EL2", "ELR_EL2", 0xE201, true, true,  {}  }, // 236
  { "ELR_EL3", "ELR_EL3", 0xF201, true, true,  {}  }, // 237
  { "SP_EL0", "SP_EL0", 0xC208, true, true,  {}  }, // 238
  { "SP_EL1", "SP_EL1", 0xE208, true, true,  {}  }, // 239
  { "SP_EL2", "SP_EL2", 0xF208, true, true,  {}  }, // 240
  { "SPSel", "SPSel", 0xC210, true, true,  {}  }, // 241
  { "NZCV", "NZCV", 0xDA10, true, true,  {}  }, // 242
  { "DAIF", "DAIF", 0xDA11, true, true,  {}  }, // 243
  { "CurrentEL", "CurrentEL", 0xC212, true, false,  {}  }, // 244
  { "SPSR_irq", "SPSR_irq", 0xE218, true, true,  {}  }, // 245
  { "SPSR_abt", "SPSR_abt", 0xE219, true, true,  {}  }, // 246
  { "SPSR_und", "SPSR_und", 0xE21A, true, true,  {}  }, // 247
  { "SPSR_fiq", "SPSR_fiq", 0xE21B, true, true,  {}  }, // 248
  { "FPCR", "FPCR", 0xDA20, true, true,  {}  }, // 249
  { "FPSR", "FPSR", 0xDA21, true, true,  {}  }, // 250
  { "DSPSR_EL0", "DSPSR_EL0", 0xDA28, true, true,  {}  }, // 251
  { "DLR_EL0", "DLR_EL0", 0xDA29, true, true,  {}  }, // 252
  { "IFSR32_EL2", "IFSR32_EL2", 0xE281, true, true,  {}  }, // 253
  { "AFSR0_EL1", "AFSR0_EL1", 0xC288, true, true,  {}  }, // 254
  { "AFSR0_EL2", "AFSR0_EL2", 0xE288, true, true,  {}  }, // 255
  { "AFSR0_EL3", "AFSR0_EL3", 0xF288, true, true,  {}  }, // 256
  { "AFSR1_EL1", "AFSR1_EL1", 0xC289, true, true,  {}  }, // 257
  { "AFSR1_EL2", "AFSR1_EL2", 0xE289, true, true,  {}  }, // 258
  { "AFSR1_EL3", "AFSR1_EL3", 0xF289, true, true,  {}  }, // 259
  { "ESR_EL1", "ESR_EL1", 0xC290, true, true,  {}  }, // 260
  { "ESR_EL2", "ESR_EL2", 0xE290, true, true,  {}  }, // 261
  { "ESR_EL3", "ESR_EL3", 0xF290, true, true,  {}  }, // 262
  { "FPEXC32_EL2", "FPEXC32_EL2", 0xE298, true, true,  {}  }, // 263
  { "FAR_EL1", "FAR_EL1", 0xC300, true, true,  {}  }, // 264
  { "FAR_EL2", "FAR_EL2", 0xE300, true, true,  {}  }, // 265
  { "FAR_EL3", "FAR_EL3", 0xF300, true, true,  {}  }, // 266
  { "HPFAR_EL2", "HPFAR_EL2", 0xE304, true, true,  {}  }, // 267
  { "PAR_EL1", "PAR_EL1", 0xC3A0, true, true,  {}  }, // 268
  { "PMCR_EL0", "PMCR_EL0", 0xDCE0, true, true,  {}  }, // 269
  { "PMCNTENSET_EL0", "PMCNTENSET_EL0", 0xDCE1, true, true,  {}  }, // 270
  { "PMCNTENCLR_EL0", "PMCNTENCLR_EL0", 0xDCE2, true, true,  {}  }, // 271
  { "PMOVSCLR_EL0", "PMOVSCLR_EL0", 0xDCE3, true, true,  {}  }, // 272
  { "PMSELR_EL0", "PMSELR_EL0", 0xDCE5, true, true,  {}  }, // 273
  { "PMCCNTR_EL0", "PMCCNTR_EL0", 0xDCE8, true, true,  {}  }, // 274
  { "PMXEVTYPER_EL0", "PMXEVTYPER_EL0", 0xDCE9, true, true,  {}  }, // 275
  { "PMXEVCNTR_EL0", "PMXEVCNTR_EL0", 0xDCEA, true, true,  {}  }, // 276
  { "PMUSERENR_EL0", "PMUSERENR_EL0", 0xDCF0, true, true,  {}  }, // 277
  { "PMINTENSET_EL1", "PMINTENSET_EL1", 0xC4F1, true, true,  {}  }, // 278
  { "PMINTENCLR_EL1", "PMINTENCLR_EL1", 0xC4F2, true, true,  {}  }, // 279
  { "PMOVSSET_EL0", "PMOVSSET_EL0", 0xDCF3, true, true,  {}  }, // 280
  { "PMMIR_EL1", "PMMIR_EL1", 0xC4F6, true, true,  {}  }, // 281
  { "MAIR_EL1", "MAIR_EL1", 0xC510, true, true,  {}  }, // 282
  { "MAIR_EL2", "MAIR_EL2", 0xE510, true, true,  {}  }, // 283
  { "MAIR_EL3", "MAIR_EL3", 0xF510, true, true,  {}  }, // 284
  { "AMAIR_EL1", "AMAIR_EL1", 0xC518, true, true,  {}  }, // 285
  { "AMAIR_EL2", "AMAIR_EL2", 0xE518, true, true,  {}  }, // 286
  { "AMAIR_EL3", "AMAIR_EL3", 0xF518, true, true,  {}  }, // 287
  { "VBAR_EL1", "VBAR_EL1", 0xC600, true, true,  {}  }, // 288
  { "VBAR_EL2", "VBAR_EL2", 0xE600, true, true,  {}  }, // 289
  { "VBAR_EL3", "VBAR_EL3", 0xF600, true, true,  {}  }, // 290
  { "RMR_EL1", "RMR_EL1", 0xC602, true, true,  {}  }, // 291
  { "RMR_EL2", "RMR_EL2", 0xE602, true, true,  {}  }, // 292
  { "RMR_EL3", "RMR_EL3", 0xF602, true, true,  {}  }, // 293
  { "CONTEXTIDR_EL1", "CONTEXTIDR_EL1", 0xC681, true, true,  {}  }, // 294
  { "TPIDR_EL0", "TPIDR_EL0", 0xDE82, true, true,  {}  }, // 295
  { "TPIDR_EL2", "TPIDR_EL2", 0xE682, true, true,  {}  }, // 296
  { "TPIDR_EL3", "TPIDR_EL3", 0xF682, true, true,  {}  }, // 297
  { "TPIDRRO_EL0", "TPIDRRO_EL0", 0xDE83, true, true,  {}  }, // 298
  { "TPIDR_EL1", "TPIDR_EL1", 0xC684, true, true,  {}  }, // 299
  { "CNTFRQ_EL0", "CNTFRQ_EL0", 0xDF00, true, true,  {}  }, // 300
  { "CNTVOFF_EL2", "CNTVOFF_EL2", 0xE703, true, true,  {}  }, // 301
  { "CNTKCTL_EL1", "CNTKCTL_EL1", 0xC708, true, true,  {}  }, // 302
  { "CNTHCTL_EL2", "CNTHCTL_EL2", 0xE708, true, true,  {}  }, // 303
  { "CNTP_TVAL_EL0", "CNTP_TVAL_EL0", 0xDF10, true, true,  {}  }, // 304
  { "CNTHP_TVAL_EL2", "CNTHP_TVAL_EL2", 0xE710, true, true,  {}  }, // 305
  { "CNTPS_TVAL_EL1", "CNTPS_TVAL_EL1", 0xFF10, true, true,  {}  }, // 306
  { "CNTP_CTL_EL0", "CNTP_CTL_EL0", 0xDF11, true, true,  {}  }, // 307
  { "CNTHP_CTL_EL2", "CNTHP_CTL_EL2", 0xE711, true, true,  {}  }, // 308
  { "CNTPS_CTL_EL1", "CNTPS_CTL_EL1", 0xFF11, true, true,  {}  }, // 309
  { "CNTP_CVAL_EL0", "CNTP_CVAL_EL0", 0xDF12, true, true,  {}  }, // 310
  { "CNTHP_CVAL_EL2", "CNTHP_CVAL_EL2", 0xE712, true, true,  {}  }, // 311
  { "CNTPS_CVAL_EL1", "CNTPS_CVAL_EL1", 0xFF12, true, true,  {}  }, // 312
  { "CNTV_TVAL_EL0", "CNTV_TVAL_EL0", 0xDF18, true, true,  {}  }, // 313
  { "CNTV_CTL_EL0", "CNTV_CTL_EL0", 0xDF19, true, true,  {}  }, // 314
  { "CNTV_CVAL_EL0", "CNTV_CVAL_EL0", 0xDF1A, true, true,  {}  }, // 315
  { "PMEVCNTR0_EL0", "PMEVCNTR0_EL0", 0xDF40, true, true,  {}  }, // 316
  { "PMEVCNTR1_EL0", "PMEVCNTR1_EL0", 0xDF41, true, true,  {}  }, // 317
  { "PMEVCNTR2_EL0", "PMEVCNTR2_EL0", 0xDF42, true, true,  {}  }, // 318
  { "PMEVCNTR3_EL0", "PMEVCNTR3_EL0", 0xDF43, true, true,  {}  }, // 319
  { "PMEVCNTR4_EL0", "PMEVCNTR4_EL0", 0xDF44, true, true,  {}  }, // 320
  { "PMEVCNTR5_EL0", "PMEVCNTR5_EL0", 0xDF45, true, true,  {}  }, // 321
  { "PMEVCNTR6_EL0", "PMEVCNTR6_EL0", 0xDF46, true, true,  {}  }, // 322
  { "PMEVCNTR7_EL0", "PMEVCNTR7_EL0", 0xDF47, true, true,  {}  }, // 323
  { "PMEVCNTR8_EL0", "PMEVCNTR8_EL0", 0xDF48, true, true,  {}  }, // 324
  { "PMEVCNTR9_EL0", "PMEVCNTR9_EL0", 0xDF49, true, true,  {}  }, // 325
  { "PMEVCNTR10_EL0", "PMEVCNTR10_EL0", 0xDF4A, true, true,  {}  }, // 326
  { "PMEVCNTR11_EL0", "PMEVCNTR11_EL0", 0xDF4B, true, true,  {}  }, // 327
  { "PMEVCNTR12_EL0", "PMEVCNTR12_EL0", 0xDF4C, true, true,  {}  }, // 328
  { "PMEVCNTR13_EL0", "PMEVCNTR13_EL0", 0xDF4D, true, true,  {}  }, // 329
  { "PMEVCNTR14_EL0", "PMEVCNTR14_EL0", 0xDF4E, true, true,  {}  }, // 330
  { "PMEVCNTR15_EL0", "PMEVCNTR15_EL0", 0xDF4F, true, true,  {}  }, // 331
  { "PMEVCNTR16_EL0", "PMEVCNTR16_EL0", 0xDF50, true, true,  {}  }, // 332
  { "PMEVCNTR17_EL0", "PMEVCNTR17_EL0", 0xDF51, true, true,  {}  }, // 333
  { "PMEVCNTR18_EL0", "PMEVCNTR18_EL0", 0xDF52, true, true,  {}  }, // 334
  { "PMEVCNTR19_EL0", "PMEVCNTR19_EL0", 0xDF53, true, true,  {}  }, // 335
  { "PMEVCNTR20_EL0", "PMEVCNTR20_EL0", 0xDF54, true, true,  {}  }, // 336
  { "PMEVCNTR21_EL0", "PMEVCNTR21_EL0", 0xDF55, true, true,  {}  }, // 337
  { "PMEVCNTR22_EL0", "PMEVCNTR22_EL0", 0xDF56, true, true,  {}  }, // 338
  { "PMEVCNTR23_EL0", "PMEVCNTR23_EL0", 0xDF57, true, true,  {}  }, // 339
  { "PMEVCNTR24_EL0", "PMEVCNTR24_EL0", 0xDF58, true, true,  {}  }, // 340
  { "PMEVCNTR25_EL0", "PMEVCNTR25_EL0", 0xDF59, true, true,  {}  }, // 341
  { "PMEVCNTR26_EL0", "PMEVCNTR26_EL0", 0xDF5A, true, true,  {}  }, // 342
  { "PMEVCNTR27_EL0", "PMEVCNTR27_EL0", 0xDF5B, true, true,  {}  }, // 343
  { "PMEVCNTR28_EL0", "PMEVCNTR28_EL0", 0xDF5C, true, true,  {}  }, // 344
  { "PMEVCNTR29_EL0", "PMEVCNTR29_EL0", 0xDF5D, true, true,  {}  }, // 345
  { "PMEVCNTR30_EL0", "PMEVCNTR30_EL0", 0xDF5E, true, true,  {}  }, // 346
  { "PMCCFILTR_EL0", "PMCCFILTR_EL0", 0xDF7F, true, true,  {}  }, // 347
  { "PMEVTYPER0_EL0", "PMEVTYPER0_EL0", 0xDF60, true, true,  {}  }, // 348
  { "PMEVTYPER1_EL0", "PMEVTYPER1_EL0", 0xDF61, true, true,  {}  }, // 349
  { "PMEVTYPER2_EL0", "PMEVTYPER2_EL0", 0xDF62, true, true,  {}  }, // 350
  { "PMEVTYPER3_EL0", "PMEVTYPER3_EL0", 0xDF63, true, true,  {}  }, // 351
  { "PMEVTYPER4_EL0", "PMEVTYPER4_EL0", 0xDF64, true, true,  {}  }, // 352
  { "PMEVTYPER5_EL0", "PMEVTYPER5_EL0", 0xDF65, true, true,  {}  }, // 353
  { "PMEVTYPER6_EL0", "PMEVTYPER6_EL0", 0xDF66, true, true,  {}  }, // 354
  { "PMEVTYPER7_EL0", "PMEVTYPER7_EL0", 0xDF67, true, true,  {}  }, // 355
  { "PMEVTYPER8_EL0", "PMEVTYPER8_EL0", 0xDF68, true, true,  {}  }, // 356
  { "PMEVTYPER9_EL0", "PMEVTYPER9_EL0", 0xDF69, true, true,  {}  }, // 357
  { "PMEVTYPER10_EL0", "PMEVTYPER10_EL0", 0xDF6A, true, true,  {}  }, // 358
  { "PMEVTYPER11_EL0", "PMEVTYPER11_EL0", 0xDF6B, true, true,  {}  }, // 359
  { "PMEVTYPER12_EL0", "PMEVTYPER12_EL0", 0xDF6C, true, true,  {}  }, // 360
  { "PMEVTYPER13_EL0", "PMEVTYPER13_EL0", 0xDF6D, true, true,  {}  }, // 361
  { "PMEVTYPER14_EL0", "PMEVTYPER14_EL0", 0xDF6E, true, true,  {}  }, // 362
  { "PMEVTYPER15_EL0", "PMEVTYPER15_EL0", 0xDF6F, true, true,  {}  }, // 363
  { "PMEVTYPER16_EL0", "PMEVTYPER16_EL0", 0xDF70, true, true,  {}  }, // 364
  { "PMEVTYPER17_EL0", "PMEVTYPER17_EL0", 0xDF71, true, true,  {}  }, // 365
  { "PMEVTYPER18_EL0", "PMEVTYPER18_EL0", 0xDF72, true, true,  {}  }, // 366
  { "PMEVTYPER19_EL0", "PMEVTYPER19_EL0", 0xDF73, true, true,  {}  }, // 367
  { "PMEVTYPER20_EL0", "PMEVTYPER20_EL0", 0xDF74, true, true,  {}  }, // 368
  { "PMEVTYPER21_EL0", "PMEVTYPER21_EL0", 0xDF75, true, true,  {}  }, // 369
  { "PMEVTYPER22_EL0", "PMEVTYPER22_EL0", 0xDF76, true, true,  {}  }, // 370
  { "PMEVTYPER23_EL0", "PMEVTYPER23_EL0", 0xDF77, true, true,  {}  }, // 371
  { "PMEVTYPER24_EL0", "PMEVTYPER24_EL0", 0xDF78, true, true,  {}  }, // 372
  { "PMEVTYPER25_EL0", "PMEVTYPER25_EL0", 0xDF79, true, true,  {}  }, // 373
  { "PMEVTYPER26_EL0", "PMEVTYPER26_EL0", 0xDF7A, true, true,  {}  }, // 374
  { "PMEVTYPER27_EL0", "PMEVTYPER27_EL0", 0xDF7B, true, true,  {}  }, // 375
  { "PMEVTYPER28_EL0", "PMEVTYPER28_EL0", 0xDF7C, true, true,  {}  }, // 376
  { "PMEVTYPER29_EL0", "PMEVTYPER29_EL0", 0xDF7D, true, true,  {}  }, // 377
  { "PMEVTYPER30_EL0", "PMEVTYPER30_EL0", 0xDF7E, true, true,  {}  }, // 378
  { "TRCPRGCTLR", "TRCPRGCTLR", 0x8808, true, true,  {}  }, // 379
  { "TRCPROCSELR", "TRCPROCSELR", 0x8810, true, true,  {}  }, // 380
  { "TRCCONFIGR", "TRCCONFIGR", 0x8820, true, true,  {}  }, // 381
  { "TRCAUXCTLR", "TRCAUXCTLR", 0x8830, true, true,  {}  }, // 382
  { "TRCEVENTCTL0R", "TRCEVENTCTL0R", 0x8840, true, true,  {}  }, // 383
  { "TRCEVENTCTL1R", "TRCEVENTCTL1R", 0x8848, true, true,  {}  }, // 384
  { "TRCSTALLCTLR", "TRCSTALLCTLR", 0x8858, true, true,  {}  }, // 385
  { "TRCTSCTLR", "TRCTSCTLR", 0x8860, true, true,  {}  }, // 386
  { "TRCSYNCPR", "TRCSYNCPR", 0x8868, true, true,  {}  }, // 387
  { "TRCCCCTLR", "TRCCCCTLR", 0x8870, true, true,  {}  }, // 388
  { "TRCBBCTLR", "TRCBBCTLR", 0x8878, true, true,  {}  }, // 389
  { "TRCTRACEIDR", "TRCTRACEIDR", 0x8801, true, true,  {}  }, // 390
  { "TRCQCTLR", "TRCQCTLR", 0x8809, true, true,  {}  }, // 391
  { "TRCVICTLR", "TRCVICTLR", 0x8802, true, true,  {}  }, // 392
  { "TRCVIIECTLR", "TRCVIIECTLR", 0x880A, true, true,  {}  }, // 393
  { "TRCVISSCTLR", "TRCVISSCTLR", 0x8812, true, true,  {}  }, // 394
  { "TRCVIPCSSCTLR", "TRCVIPCSSCTLR", 0x881A, true, true,  {}  }, // 395
  { "TRCVDCTLR", "TRCVDCTLR", 0x8842, true, true,  {}  }, // 396
  { "TRCVDSACCTLR", "TRCVDSACCTLR", 0x884A, true, true,  {}  }, // 397
  { "TRCVDARCCTLR", "TRCVDARCCTLR", 0x8852, true, true,  {}  }, // 398
  { "TRCSEQEVR0", "TRCSEQEVR0", 0x8804, true, true,  {}  }, // 399
  { "TRCSEQEVR1", "TRCSEQEVR1", 0x880C, true, true,  {}  }, // 400
  { "TRCSEQEVR2", "TRCSEQEVR2", 0x8814, true, true,  {}  }, // 401
  { "TRCSEQRSTEVR", "TRCSEQRSTEVR", 0x8834, true, true,  {}  }, // 402
  { "TRCSEQSTR", "TRCSEQSTR", 0x883C, true, true,  {}  }, // 403
  { "TRCEXTINSELR", "TRCEXTINSELR", 0x8844, true, true,  {}  }, // 404
  { "TRCCNTRLDVR0", "TRCCNTRLDVR0", 0x8805, true, true,  {}  }, // 405
  { "TRCCNTRLDVR1", "TRCCNTRLDVR1", 0x880D, true, true,  {}  }, // 406
  { "TRCCNTRLDVR2", "TRCCNTRLDVR2", 0x8815, true, true,  {}  }, // 407
  { "TRCCNTRLDVR3", "TRCCNTRLDVR3", 0x881D, true, true,  {}  }, // 408
  { "TRCCNTCTLR0", "TRCCNTCTLR0", 0x8825, true, true,  {}  }, // 409
  { "TRCCNTCTLR1", "TRCCNTCTLR1", 0x882D, true, true,  {}  }, // 410
  { "TRCCNTCTLR2", "TRCCNTCTLR2", 0x8835, true, true,  {}  }, // 411
  { "TRCCNTCTLR3", "TRCCNTCTLR3", 0x883D, true, true,  {}  }, // 412
  { "TRCCNTVR0", "TRCCNTVR0", 0x8845, true, true,  {}  }, // 413
  { "TRCCNTVR1", "TRCCNTVR1", 0x884D, true, true,  {}  }, // 414
  { "TRCCNTVR2", "TRCCNTVR2", 0x8855, true, true,  {}  }, // 415
  { "TRCCNTVR3", "TRCCNTVR3", 0x885D, true, true,  {}  }, // 416
  { "TRCIMSPEC0", "TRCIMSPEC0", 0x8807, true, true,  {}  }, // 417
  { "TRCIMSPEC1", "TRCIMSPEC1", 0x880F, true, true,  {}  }, // 418
  { "TRCIMSPEC2", "TRCIMSPEC2", 0x8817, true, true,  {}  }, // 419
  { "TRCIMSPEC3", "TRCIMSPEC3", 0x881F, true, true,  {}  }, // 420
  { "TRCIMSPEC4", "TRCIMSPEC4", 0x8827, true, true,  {}  }, // 421
  { "TRCIMSPEC5", "TRCIMSPEC5", 0x882F, true, true,  {}  }, // 422
  { "TRCIMSPEC6", "TRCIMSPEC6", 0x8837, true, true,  {}  }, // 423
  { "TRCIMSPEC7", "TRCIMSPEC7", 0x883F, true, true,  {}  }, // 424
  { "TRCRSCTLR2", "TRCRSCTLR2", 0x8890, true, true,  {}  }, // 425
  { "TRCRSCTLR3", "TRCRSCTLR3", 0x8898, true, true,  {}  }, // 426
  { "TRCRSCTLR4", "TRCRSCTLR4", 0x88A0, true, true,  {}  }, // 427
  { "TRCRSCTLR5", "TRCRSCTLR5", 0x88A8, true, true,  {}  }, // 428
  { "TRCRSCTLR6", "TRCRSCTLR6", 0x88B0, true, true,  {}  }, // 429
  { "TRCRSCTLR7", "TRCRSCTLR7", 0x88B8, true, true,  {}  }, // 430
  { "TRCRSCTLR8", "TRCRSCTLR8", 0x88C0, true, true,  {}  }, // 431
  { "TRCRSCTLR9", "TRCRSCTLR9", 0x88C8, true, true,  {}  }, // 432
  { "TRCRSCTLR10", "TRCRSCTLR10", 0x88D0, true, true,  {}  }, // 433
  { "TRCRSCTLR11", "TRCRSCTLR11", 0x88D8, true, true,  {}  }, // 434
  { "TRCRSCTLR12", "TRCRSCTLR12", 0x88E0, true, true,  {}  }, // 435
  { "TRCRSCTLR13", "TRCRSCTLR13", 0x88E8, true, true,  {}  }, // 436
  { "TRCRSCTLR14", "TRCRSCTLR14", 0x88F0, true, true,  {}  }, // 437
  { "TRCRSCTLR15", "TRCRSCTLR15", 0x88F8, true, true,  {}  }, // 438
  { "TRCRSCTLR16", "TRCRSCTLR16", 0x8881, true, true,  {}  }, // 439
  { "TRCRSCTLR17", "TRCRSCTLR17", 0x8889, true, true,  {}  }, // 440
  { "TRCRSCTLR18", "TRCRSCTLR18", 0x8891, true, true,  {}  }, // 441
  { "TRCRSCTLR19", "TRCRSCTLR19", 0x8899, true, true,  {}  }, // 442
  { "TRCRSCTLR20", "TRCRSCTLR20", 0x88A1, true, true,  {}  }, // 443
  { "TRCRSCTLR21", "TRCRSCTLR21", 0x88A9, true, true,  {}  }, // 444
  { "TRCRSCTLR22", "TRCRSCTLR22", 0x88B1, true, true,  {}  }, // 445
  { "TRCRSCTLR23", "TRCRSCTLR23", 0x88B9, true, true,  {}  }, // 446
  { "TRCRSCTLR24", "TRCRSCTLR24", 0x88C1, true, true,  {}  }, // 447
  { "TRCRSCTLR25", "TRCRSCTLR25", 0x88C9, true, true,  {}  }, // 448
  { "TRCRSCTLR26", "TRCRSCTLR26", 0x88D1, true, true,  {}  }, // 449
  { "TRCRSCTLR27", "TRCRSCTLR27", 0x88D9, true, true,  {}  }, // 450
  { "TRCRSCTLR28", "TRCRSCTLR28", 0x88E1, true, true,  {}  }, // 451
  { "TRCRSCTLR29", "TRCRSCTLR29", 0x88E9, true, true,  {}  }, // 452
  { "TRCRSCTLR30", "TRCRSCTLR30", 0x88F1, true, true,  {}  }, // 453
  { "TRCRSCTLR31", "TRCRSCTLR31", 0x88F9, true, true,  {}  }, // 454
  { "TRCSSCCR0", "TRCSSCCR0", 0x8882, true, true,  {}  }, // 455
  { "TRCSSCCR1", "TRCSSCCR1", 0x888A, true, true,  {}  }, // 456
  { "TRCSSCCR2", "TRCSSCCR2", 0x8892, true, true,  {}  }, // 457
  { "TRCSSCCR3", "TRCSSCCR3", 0x889A, true, true,  {}  }, // 458
  { "TRCSSCCR4", "TRCSSCCR4", 0x88A2, true, true,  {}  }, // 459
  { "TRCSSCCR5", "TRCSSCCR5", 0x88AA, true, true,  {}  }, // 460
  { "TRCSSCCR6", "TRCSSCCR6", 0x88B2, true, true,  {}  }, // 461
  { "TRCSSCCR7", "TRCSSCCR7", 0x88BA, true, true,  {}  }, // 462
  { "TRCSSCSR0", "TRCSSCSR0", 0x88C2, true, true,  {}  }, // 463
  { "TRCSSCSR1", "TRCSSCSR1", 0x88CA, true, true,  {}  }, // 464
  { "TRCSSCSR2", "TRCSSCSR2", 0x88D2, true, true,  {}  }, // 465
  { "TRCSSCSR3", "TRCSSCSR3", 0x88DA, true, true,  {}  }, // 466
  { "TRCSSCSR4", "TRCSSCSR4", 0x88E2, true, true,  {}  }, // 467
  { "TRCSSCSR5", "TRCSSCSR5", 0x88EA, true, true,  {}  }, // 468
  { "TRCSSCSR6", "TRCSSCSR6", 0x88F2, true, true,  {}  }, // 469
  { "TRCSSCSR7", "TRCSSCSR7", 0x88FA, true, true,  {}  }, // 470
  { "TRCSSPCICR0", "TRCSSPCICR0", 0x8883, true, true,  {}  }, // 471
  { "TRCSSPCICR1", "TRCSSPCICR1", 0x888B, true, true,  {}  }, // 472
  { "TRCSSPCICR2", "TRCSSPCICR2", 0x8893, true, true,  {}  }, // 473
  { "TRCSSPCICR3", "TRCSSPCICR3", 0x889B, true, true,  {}  }, // 474
  { "TRCSSPCICR4", "TRCSSPCICR4", 0x88A3, true, true,  {}  }, // 475
  { "TRCSSPCICR5", "TRCSSPCICR5", 0x88AB, true, true,  {}  }, // 476
  { "TRCSSPCICR6", "TRCSSPCICR6", 0x88B3, true, true,  {}  }, // 477
  { "TRCSSPCICR7", "TRCSSPCICR7", 0x88BB, true, true,  {}  }, // 478
  { "TRCPDCR", "TRCPDCR", 0x88A4, true, true,  {}  }, // 479
  { "TRCACVR0", "TRCACVR0", 0x8900, true, true,  {}  }, // 480
  { "TRCACVR1", "TRCACVR1", 0x8910, true, true,  {}  }, // 481
  { "TRCACVR2", "TRCACVR2", 0x8920, true, true,  {}  }, // 482
  { "TRCACVR3", "TRCACVR3", 0x8930, true, true,  {}  }, // 483
  { "TRCACVR4", "TRCACVR4", 0x8940, true, true,  {}  }, // 484
  { "TRCACVR5", "TRCACVR5", 0x8950, true, true,  {}  }, // 485
  { "TRCACVR6", "TRCACVR6", 0x8960, true, true,  {}  }, // 486
  { "TRCACVR7", "TRCACVR7", 0x8970, true, true,  {}  }, // 487
  { "TRCACVR8", "TRCACVR8", 0x8901, true, true,  {}  }, // 488
  { "TRCACVR9", "TRCACVR9", 0x8911, true, true,  {}  }, // 489
  { "TRCACVR10", "TRCACVR10", 0x8921, true, true,  {}  }, // 490
  { "TRCACVR11", "TRCACVR11", 0x8931, true, true,  {}  }, // 491
  { "TRCACVR12", "TRCACVR12", 0x8941, true, true,  {}  }, // 492
  { "TRCACVR13", "TRCACVR13", 0x8951, true, true,  {}  }, // 493
  { "TRCACVR14", "TRCACVR14", 0x8961, true, true,  {}  }, // 494
  { "TRCACVR15", "TRCACVR15", 0x8971, true, true,  {}  }, // 495
  { "TRCACATR0", "TRCACATR0", 0x8902, true, true,  {}  }, // 496
  { "TRCACATR1", "TRCACATR1", 0x8912, true, true,  {}  }, // 497
  { "TRCACATR2", "TRCACATR2", 0x8922, true, true,  {}  }, // 498
  { "TRCACATR3", "TRCACATR3", 0x8932, true, true,  {}  }, // 499
  { "TRCACATR4", "TRCACATR4", 0x8942, true, true,  {}  }, // 500
  { "TRCACATR5", "TRCACATR5", 0x8952, true, true,  {}  }, // 501
  { "TRCACATR6", "TRCACATR6", 0x8962, true, true,  {}  }, // 502
  { "TRCACATR7", "TRCACATR7", 0x8972, true, true,  {}  }, // 503
  { "TRCACATR8", "TRCACATR8", 0x8903, true, true,  {}  }, // 504
  { "TRCACATR9", "TRCACATR9", 0x8913, true, true,  {}  }, // 505
  { "TRCACATR10", "TRCACATR10", 0x8923, true, true,  {}  }, // 506
  { "TRCACATR11", "TRCACATR11", 0x8933, true, true,  {}  }, // 507
  { "TRCACATR12", "TRCACATR12", 0x8943, true, true,  {}  }, // 508
  { "TRCACATR13", "TRCACATR13", 0x8953, true, true,  {}  }, // 509
  { "TRCACATR14", "TRCACATR14", 0x8963, true, true,  {}  }, // 510
  { "TRCACATR15", "TRCACATR15", 0x8973, true, true,  {}  }, // 511
  { "TRCDVCVR0", "TRCDVCVR0", 0x8904, true, true,  {}  }, // 512
  { "TRCDVCVR1", "TRCDVCVR1", 0x8924, true, true,  {}  }, // 513
  { "TRCDVCVR2", "TRCDVCVR2", 0x8944, true, true,  {}  }, // 514
  { "TRCDVCVR3", "TRCDVCVR3", 0x8964, true, true,  {}  }, // 515
  { "TRCDVCVR4", "TRCDVCVR4", 0x8905, true, true,  {}  }, // 516
  { "TRCDVCVR5", "TRCDVCVR5", 0x8925, true, true,  {}  }, // 517
  { "TRCDVCVR6", "TRCDVCVR6", 0x8945, true, true,  {}  }, // 518
  { "TRCDVCVR7", "TRCDVCVR7", 0x8965, true, true,  {}  }, // 519
  { "TRCDVCMR0", "TRCDVCMR0", 0x8906, true, true,  {}  }, // 520
  { "TRCDVCMR1", "TRCDVCMR1", 0x8926, true, true,  {}  }, // 521
  { "TRCDVCMR2", "TRCDVCMR2", 0x8946, true, true,  {}  }, // 522
  { "TRCDVCMR3", "TRCDVCMR3", 0x8966, true, true,  {}  }, // 523
  { "TRCDVCMR4", "TRCDVCMR4", 0x8907, true, true,  {}  }, // 524
  { "TRCDVCMR5", "TRCDVCMR5", 0x8927, true, true,  {}  }, // 525
  { "TRCDVCMR6", "TRCDVCMR6", 0x8947, true, true,  {}  }, // 526
  { "TRCDVCMR7", "TRCDVCMR7", 0x8967, true, true,  {}  }, // 527
  { "TRCCIDCVR0", "TRCCIDCVR0", 0x8980, true, true,  {}  }, // 528
  { "TRCCIDCVR1", "TRCCIDCVR1", 0x8990, true, true,  {}  }, // 529
  { "TRCCIDCVR2", "TRCCIDCVR2", 0x89A0, true, true,  {}  }, // 530
  { "TRCCIDCVR3", "TRCCIDCVR3", 0x89B0, true, true,  {}  }, // 531
  { "TRCCIDCVR4", "TRCCIDCVR4", 0x89C0, true, true,  {}  }, // 532
  { "TRCCIDCVR5", "TRCCIDCVR5", 0x89D0, true, true,  {}  }, // 533
  { "TRCCIDCVR6", "TRCCIDCVR6", 0x89E0, true, true,  {}  }, // 534
  { "TRCCIDCVR7", "TRCCIDCVR7", 0x89F0, true, true,  {}  }, // 535
  { "TRCVMIDCVR0", "TRCVMIDCVR0", 0x8981, true, true,  {}  }, // 536
  { "TRCVMIDCVR1", "TRCVMIDCVR1", 0x8991, true, true,  {}  }, // 537
  { "TRCVMIDCVR2", "TRCVMIDCVR2", 0x89A1, true, true,  {}  }, // 538
  { "TRCVMIDCVR3", "TRCVMIDCVR3", 0x89B1, true, true,  {}  }, // 539
  { "TRCVMIDCVR4", "TRCVMIDCVR4", 0x89C1, true, true,  {}  }, // 540
  { "TRCVMIDCVR5", "TRCVMIDCVR5", 0x89D1, true, true,  {}  }, // 541
  { "TRCVMIDCVR6", "TRCVMIDCVR6", 0x89E1, true, true,  {}  }, // 542
  { "TRCVMIDCVR7", "TRCVMIDCVR7", 0x89F1, true, true,  {}  }, // 543
  { "TRCCIDCCTLR0", "TRCCIDCCTLR0", 0x8982, true, true,  {}  }, // 544
  { "TRCCIDCCTLR1", "TRCCIDCCTLR1", 0x898A, true, true,  {}  }, // 545
  { "TRCVMIDCCTLR0", "TRCVMIDCCTLR0", 0x8992, true, true,  {}  }, // 546
  { "TRCVMIDCCTLR1", "TRCVMIDCCTLR1", 0x899A, true, true,  {}  }, // 547
  { "TRCITCTRL", "TRCITCTRL", 0x8B84, true, true,  {}  }, // 548
  { "TRCCLAIMSET", "TRCCLAIMSET", 0x8BC6, true, true,  {}  }, // 549
  { "TRCCLAIMCLR", "TRCCLAIMCLR", 0x8BCE, true, true,  {}  }, // 550
  { "ICC_BPR1_EL1", "ICC_BPR1_EL1", 0xC663, true, true,  {}  }, // 551
  { "ICC_BPR0_EL1", "ICC_BPR0_EL1", 0xC643, true, true,  {}  }, // 552
  { "ICC_PMR_EL1", "ICC_PMR_EL1", 0xC230, true, true,  {}  }, // 553
  { "ICC_CTLR_EL1", "ICC_CTLR_EL1", 0xC664, true, true,  {}  }, // 554
  { "ICC_CTLR_EL3", "ICC_CTLR_EL3", 0xF664, true, true,  {}  }, // 555
  { "ICC_SRE_EL1", "ICC_SRE_EL1", 0xC665, true, true,  {}  }, // 556
  { "ICC_SRE_EL2", "ICC_SRE_EL2", 0xE64D, true, true,  {}  }, // 557
  { "ICC_SRE_EL3", "ICC_SRE_EL3", 0xF665, true, true,  {}  }, // 558
  { "ICC_IGRPEN0_EL1", "ICC_IGRPEN0_EL1", 0xC666, true, true,  {}  }, // 559
  { "ICC_IGRPEN1_EL1", "ICC_IGRPEN1_EL1", 0xC667, true, true,  {}  }, // 560
  { "ICC_IGRPEN1_EL3", "ICC_IGRPEN1_EL3", 0xF667, true, true,  {}  }, // 561
  { "ICC_AP0R0_EL1", "ICC_AP0R0_EL1", 0xC644, true, true,  {}  }, // 562
  { "ICC_AP0R1_EL1", "ICC_AP0R1_EL1", 0xC645, true, true,  {}  }, // 563
  { "ICC_AP0R2_EL1", "ICC_AP0R2_EL1", 0xC646, true, true,  {}  }, // 564
  { "ICC_AP0R3_EL1", "ICC_AP0R3_EL1", 0xC647, true, true,  {}  }, // 565
  { "ICC_AP1R0_EL1", "ICC_AP1R0_EL1", 0xC648, true, true,  {}  }, // 566
  { "ICC_AP1R1_EL1", "ICC_AP1R1_EL1", 0xC649, true, true,  {}  }, // 567
  { "ICC_AP1R2_EL1", "ICC_AP1R2_EL1", 0xC64A, true, true,  {}  }, // 568
  { "ICC_AP1R3_EL1", "ICC_AP1R3_EL1", 0xC64B, true, true,  {}  }, // 569
  { "ICH_AP0R0_EL2", "ICH_AP0R0_EL2", 0xE640, true, true,  {}  }, // 570
  { "ICH_AP0R1_EL2", "ICH_AP0R1_EL2", 0xE641, true, true,  {}  }, // 571
  { "ICH_AP0R2_EL2", "ICH_AP0R2_EL2", 0xE642, true, true,  {}  }, // 572
  { "ICH_AP0R3_EL2", "ICH_AP0R3_EL2", 0xE643, true, true,  {}  }, // 573
  { "ICH_AP1R0_EL2", "ICH_AP1R0_EL2", 0xE648, true, true,  {}  }, // 574
  { "ICH_AP1R1_EL2", "ICH_AP1R1_EL2", 0xE649, true, true,  {}  }, // 575
  { "ICH_AP1R2_EL2", "ICH_AP1R2_EL2", 0xE64A, true, true,  {}  }, // 576
  { "ICH_AP1R3_EL2", "ICH_AP1R3_EL2", 0xE64B, true, true,  {}  }, // 577
  { "ICH_HCR_EL2", "ICH_HCR_EL2", 0xE658, true, true,  {}  }, // 578
  { "ICH_MISR_EL2", "ICH_MISR_EL2", 0xE65A, true, false,  {}  }, // 579
  { "ICH_VMCR_EL2", "ICH_VMCR_EL2", 0xE65F, true, true,  {}  }, // 580
  { "ICH_LR0_EL2", "ICH_LR0_EL2", 0xE660, true, true,  {}  }, // 581
  { "ICH_LR1_EL2", "ICH_LR1_EL2", 0xE661, true, true,  {}  }, // 582
  { "ICH_LR2_EL2", "ICH_LR2_EL2", 0xE662, true, true,  {}  }, // 583
  { "ICH_LR3_EL2", "ICH_LR3_EL2", 0xE663, true, true,  {}  }, // 584
  { "ICH_LR4_EL2", "ICH_LR4_EL2", 0xE664, true, true,  {}  }, // 585
  { "ICH_LR5_EL2", "ICH_LR5_EL2", 0xE665, true, true,  {}  }, // 586
  { "ICH_LR6_EL2", "ICH_LR6_EL2", 0xE666, true, true,  {}  }, // 587
  { "ICH_LR7_EL2", "ICH_LR7_EL2", 0xE667, true, true,  {}  }, // 588
  { "ICH_LR8_EL2", "ICH_LR8_EL2", 0xE668, true, true,  {}  }, // 589
  { "ICH_LR9_EL2", "ICH_LR9_EL2", 0xE669, true, true,  {}  }, // 590
  { "ICH_LR10_EL2", "ICH_LR10_EL2", 0xE66A, true, true,  {}  }, // 591
  { "ICH_LR11_EL2", "ICH_LR11_EL2", 0xE66B, true, true,  {}  }, // 592
  { "ICH_LR12_EL2", "ICH_LR12_EL2", 0xE66C, true, true,  {}  }, // 593
  { "ICH_LR13_EL2", "ICH_LR13_EL2", 0xE66D, true, true,  {}  }, // 594
  { "ICH_LR14_EL2", "ICH_LR14_EL2", 0xE66E, true, true,  {}  }, // 595
  { "ICH_LR15_EL2", "ICH_LR15_EL2", 0xE66F, true, true,  {}  }, // 596
  { "VSCTLR_EL2", "TTBR0_EL2", 0xE100, true, true,  {AArch64::HasV8_0rOps}  }, // 597
  { "MPUIR_EL1", "MPUIR_EL1", 0xC004, true, true,  {AArch64::HasV8_0rOps}  }, // 598
  { "MPUIR_EL2", "MPUIR_EL2", 0xE004, true, true,  {AArch64::HasV8_0rOps}  }, // 599
  { "PRENR_EL1", "PRENR_EL1", 0xC309, true, true,  {AArch64::HasV8_0rOps}  }, // 600
  { "PRENR_EL2", "PRENR_EL2", 0xE309, true, true,  {AArch64::HasV8_0rOps}  }, // 601
  { "PRSELR_EL1", "PRSELR_EL1", 0xC311, true, true,  {AArch64::HasV8_0rOps}  }, // 602
  { "PRSELR_EL2", "PRSELR_EL2", 0xE311, true, true,  {AArch64::HasV8_0rOps}  }, // 603
  { "PRBAR_EL1", "PRBAR_EL1", 0xC340, true, true,  {AArch64::HasV8_0rOps}  }, // 604
  { "PRBAR_EL2", "PRBAR_EL2", 0xE340, true, true,  {AArch64::HasV8_0rOps}  }, // 605
  { "PRLAR_EL1", "PRLAR_EL1", 0xC341, true, true,  {AArch64::HasV8_0rOps}  }, // 606
  { "PRLAR_EL2", "PRLAR_EL2", 0xE341, true, true,  {AArch64::HasV8_0rOps}  }, // 607
  { "PRBAR0_EL1", "PRBAR0_EL1", 0xC340, true, true,  {AArch64::HasV8_0rOps}  }, // 608
  { "PRLAR0_EL1", "PRLAR0_EL1", 0xC341, true, true,  {AArch64::HasV8_0rOps}  }, // 609
  { "PRBAR0_EL2", "PRBAR0_EL2", 0xE340, true, true,  {AArch64::HasV8_0rOps}  }, // 610
  { "PRLAR0_EL2", "PRLAR0_EL2", 0xE341, true, true,  {AArch64::HasV8_0rOps}  }, // 611
  { "PRBAR1_EL1", "PRBAR1_EL1", 0xC344, true, true,  {AArch64::HasV8_0rOps}  }, // 612
  { "PRLAR1_EL1", "PRLAR1_EL1", 0xC345, true, true,  {AArch64::HasV8_0rOps}  }, // 613
  { "PRBAR1_EL2", "PRBAR1_EL2", 0xE344, true, true,  {AArch64::HasV8_0rOps}  }, // 614
  { "PRLAR1_EL2", "PRLAR1_EL2", 0xE345, true, true,  {AArch64::HasV8_0rOps}  }, // 615
  { "PRBAR2_EL1", "PRBAR2_EL1", 0xC348, true, true,  {AArch64::HasV8_0rOps}  }, // 616
  { "PRLAR2_EL1", "PRLAR2_EL1", 0xC349, true, true,  {AArch64::HasV8_0rOps}  }, // 617
  { "PRBAR2_EL2", "PRBAR2_EL2", 0xE348, true, true,  {AArch64::HasV8_0rOps}  }, // 618
  { "PRLAR2_EL2", "PRLAR2_EL2", 0xE349, true, true,  {AArch64::HasV8_0rOps}  }, // 619
  { "PRBAR3_EL1", "PRBAR3_EL1", 0xC34C, true, true,  {AArch64::HasV8_0rOps}  }, // 620
  { "PRLAR3_EL1", "PRLAR3_EL1", 0xC34D, true, true,  {AArch64::HasV8_0rOps}  }, // 621
  { "PRBAR3_EL2", "PRBAR3_EL2", 0xE34C, true, true,  {AArch64::HasV8_0rOps}  }, // 622
  { "PRLAR3_EL2", "PRLAR3_EL2", 0xE34D, true, true,  {AArch64::HasV8_0rOps}  }, // 623
  { "PRBAR4_EL1", "PRBAR4_EL1", 0xC350, true, true,  {AArch64::HasV8_0rOps}  }, // 624
  { "PRLAR4_EL1", "PRLAR4_EL1", 0xC351, true, true,  {AArch64::HasV8_0rOps}  }, // 625
  { "PRBAR4_EL2", "PRBAR4_EL2", 0xE350, true, true,  {AArch64::HasV8_0rOps}  }, // 626
  { "PRLAR4_EL2", "PRLAR4_EL2", 0xE351, true, true,  {AArch64::HasV8_0rOps}  }, // 627
  { "PRBAR5_EL1", "PRBAR5_EL1", 0xC354, true, true,  {AArch64::HasV8_0rOps}  }, // 628
  { "PRLAR5_EL1", "PRLAR5_EL1", 0xC355, true, true,  {AArch64::HasV8_0rOps}  }, // 629
  { "PRBAR5_EL2", "PRBAR5_EL2", 0xE354, true, true,  {AArch64::HasV8_0rOps}  }, // 630
  { "PRLAR5_EL2", "PRLAR5_EL2", 0xE355, true, true,  {AArch64::HasV8_0rOps}  }, // 631
  { "PRBAR6_EL1", "PRBAR6_EL1", 0xC358, true, true,  {AArch64::HasV8_0rOps}  }, // 632
  { "PRLAR6_EL1", "PRLAR6_EL1", 0xC359, true, true,  {AArch64::HasV8_0rOps}  }, // 633
  { "PRBAR6_EL2", "PRBAR6_EL2", 0xE358, true, true,  {AArch64::HasV8_0rOps}  }, // 634
  { "PRLAR6_EL2", "PRLAR6_EL2", 0xE359, true, true,  {AArch64::HasV8_0rOps}  }, // 635
  { "PRBAR7_EL1", "PRBAR7_EL1", 0xC35C, true, true,  {AArch64::HasV8_0rOps}  }, // 636
  { "PRLAR7_EL1", "PRLAR7_EL1", 0xC35D, true, true,  {AArch64::HasV8_0rOps}  }, // 637
  { "PRBAR7_EL2", "PRBAR7_EL2", 0xE35C, true, true,  {AArch64::HasV8_0rOps}  }, // 638
  { "PRLAR7_EL2", "PRLAR7_EL2", 0xE35D, true, true,  {AArch64::HasV8_0rOps}  }, // 639
  { "PRBAR8_EL1", "PRBAR8_EL1", 0xC360, true, true,  {AArch64::HasV8_0rOps}  }, // 640
  { "PRLAR8_EL1", "PRLAR8_EL1", 0xC361, true, true,  {AArch64::HasV8_0rOps}  }, // 641
  { "PRBAR8_EL2", "PRBAR8_EL2", 0xE360, true, true,  {AArch64::HasV8_0rOps}  }, // 642
  { "PRLAR8_EL2", "PRLAR8_EL2", 0xE361, true, true,  {AArch64::HasV8_0rOps}  }, // 643
  { "PRBAR9_EL1", "PRBAR9_EL1", 0xC364, true, true,  {AArch64::HasV8_0rOps}  }, // 644
  { "PRLAR9_EL1", "PRLAR9_EL1", 0xC365, true, true,  {AArch64::HasV8_0rOps}  }, // 645
  { "PRBAR9_EL2", "PRBAR9_EL2", 0xE364, true, true,  {AArch64::HasV8_0rOps}  }, // 646
  { "PRLAR9_EL2", "PRLAR9_EL2", 0xE365, true, true,  {AArch64::HasV8_0rOps}  }, // 647
  { "PRBAR10_EL1", "PRBAR10_EL1", 0xC368, true, true,  {AArch64::HasV8_0rOps}  }, // 648
  { "PRLAR10_EL1", "PRLAR10_EL1", 0xC369, true, true,  {AArch64::HasV8_0rOps}  }, // 649
  { "PRBAR10_EL2", "PRBAR10_EL2", 0xE368, true, true,  {AArch64::HasV8_0rOps}  }, // 650
  { "PRLAR10_EL2", "PRLAR10_EL2", 0xE369, true, true,  {AArch64::HasV8_0rOps}  }, // 651
  { "PRBAR11_EL1", "PRBAR11_EL1", 0xC36C, true, true,  {AArch64::HasV8_0rOps}  }, // 652
  { "PRLAR11_EL1", "PRLAR11_EL1", 0xC36D, true, true,  {AArch64::HasV8_0rOps}  }, // 653
  { "PRBAR11_EL2", "PRBAR11_EL2", 0xE36C, true, true,  {AArch64::HasV8_0rOps}  }, // 654
  { "PRLAR11_EL2", "PRLAR11_EL2", 0xE36D, true, true,  {AArch64::HasV8_0rOps}  }, // 655
  { "PRBAR12_EL1", "PRBAR12_EL1", 0xC370, true, true,  {AArch64::HasV8_0rOps}  }, // 656
  { "PRLAR12_EL1", "PRLAR12_EL1", 0xC371, true, true,  {AArch64::HasV8_0rOps}  }, // 657
  { "PRBAR12_EL2", "PRBAR12_EL2", 0xE370, true, true,  {AArch64::HasV8_0rOps}  }, // 658
  { "PRLAR12_EL2", "PRLAR12_EL2", 0xE371, true, true,  {AArch64::HasV8_0rOps}  }, // 659
  { "PRBAR13_EL1", "PRBAR13_EL1", 0xC374, true, true,  {AArch64::HasV8_0rOps}  }, // 660
  { "PRLAR13_EL1", "PRLAR13_EL1", 0xC375, true, true,  {AArch64::HasV8_0rOps}  }, // 661
  { "PRBAR13_EL2", "PRBAR13_EL2", 0xE374, true, true,  {AArch64::HasV8_0rOps}  }, // 662
  { "PRLAR13_EL2", "PRLAR13_EL2", 0xE375, true, true,  {AArch64::HasV8_0rOps}  }, // 663
  { "PRBAR14_EL1", "PRBAR14_EL1", 0xC378, true, true,  {AArch64::HasV8_0rOps}  }, // 664
  { "PRLAR14_EL1", "PRLAR14_EL1", 0xC379, true, true,  {AArch64::HasV8_0rOps}  }, // 665
  { "PRBAR14_EL2", "PRBAR14_EL2", 0xE378, true, true,  {AArch64::HasV8_0rOps}  }, // 666
  { "PRLAR14_EL2", "PRLAR14_EL2", 0xE379, true, true,  {AArch64::HasV8_0rOps}  }, // 667
  { "PRBAR15_EL1", "PRBAR15_EL1", 0xC37C, true, true,  {AArch64::HasV8_0rOps}  }, // 668
  { "PRLAR15_EL1", "PRLAR15_EL1", 0xC37D, true, true,  {AArch64::HasV8_0rOps}  }, // 669
  { "PRBAR15_EL2", "PRBAR15_EL2", 0xE37C, true, true,  {AArch64::HasV8_0rOps}  }, // 670
  { "PRLAR15_EL2", "PRLAR15_EL2", 0xE37D, true, true,  {AArch64::HasV8_0rOps}  }, // 671
  { "PAN", "PAN", 0xC213, true, true,  {AArch64::FeaturePAN}  }, // 672
  { "LORSA_EL1", "LORSA_EL1", 0xC520, true, true,  {AArch64::FeatureLOR}  }, // 673
  { "LOREA_EL1", "LOREA_EL1", 0xC521, true, true,  {AArch64::FeatureLOR}  }, // 674
  { "LORN_EL1", "LORN_EL1", 0xC522, true, true,  {AArch64::FeatureLOR}  }, // 675
  { "LORC_EL1", "LORC_EL1", 0xC523, true, true,  {AArch64::FeatureLOR}  }, // 676
  { "TTBR1_EL2", "TTBR1_EL2", 0xE101, true, true,  {AArch64::FeatureVH}  }, // 677
  { "CNTHV_TVAL_EL2", "CNTHV_TVAL_EL2", 0xE718, true, true,  {AArch64::FeatureVH}  }, // 678
  { "CNTHV_CVAL_EL2", "CNTHV_CVAL_EL2", 0xE71A, true, true,  {AArch64::FeatureVH}  }, // 679
  { "CNTHV_CTL_EL2", "CNTHV_CTL_EL2", 0xE719, true, true,  {AArch64::FeatureVH}  }, // 680
  { "SCTLR_EL12", "SCTLR_EL12", 0xE880, true, true,  {AArch64::FeatureVH}  }, // 681
  { "CPACR_EL12", "CPACR_EL12", 0xE882, true, true,  {AArch64::FeatureVH}  }, // 682
  { "TTBR0_EL12", "TTBR0_EL12", 0xE900, true, true,  {AArch64::FeatureVH}  }, // 683
  { "TTBR1_EL12", "TTBR1_EL12", 0xE901, true, true,  {AArch64::FeatureVH}  }, // 684
  { "TCR_EL12", "TCR_EL12", 0xE902, true, true,  {AArch64::FeatureVH}  }, // 685
  { "AFSR0_EL12", "AFSR0_EL12", 0xEA88, true, true,  {AArch64::FeatureVH}  }, // 686
  { "AFSR1_EL12", "AFSR1_EL12", 0xEA89, true, true,  {AArch64::FeatureVH}  }, // 687
  { "ESR_EL12", "ESR_EL12", 0xEA90, true, true,  {AArch64::FeatureVH}  }, // 688
  { "FAR_EL12", "FAR_EL12", 0xEB00, true, true,  {AArch64::FeatureVH}  }, // 689
  { "MAIR_EL12", "MAIR_EL12", 0xED10, true, true,  {AArch64::FeatureVH}  }, // 690
  { "AMAIR_EL12", "AMAIR_EL12", 0xED18, true, true,  {AArch64::FeatureVH}  }, // 691
  { "VBAR_EL12", "VBAR_EL12", 0xEE00, true, true,  {AArch64::FeatureVH}  }, // 692
  { "CONTEXTIDR_EL12", "CONTEXTIDR_EL12", 0xEE81, true, true,  {AArch64::FeatureVH}  }, // 693
  { "CNTKCTL_EL12", "CNTKCTL_EL12", 0xEF08, true, true,  {AArch64::FeatureVH}  }, // 694
  { "CNTP_TVAL_EL02", "CNTP_TVAL_EL02", 0xEF10, true, true,  {AArch64::FeatureVH}  }, // 695
  { "CNTP_CTL_EL02", "CNTP_CTL_EL02", 0xEF11, true, true,  {AArch64::FeatureVH}  }, // 696
  { "CNTP_CVAL_EL02", "CNTP_CVAL_EL02", 0xEF12, true, true,  {AArch64::FeatureVH}  }, // 697
  { "CNTV_TVAL_EL02", "CNTV_TVAL_EL02", 0xEF18, true, true,  {AArch64::FeatureVH}  }, // 698
  { "CNTV_CTL_EL02", "CNTV_CTL_EL02", 0xEF19, true, true,  {AArch64::FeatureVH}  }, // 699
  { "CNTV_CVAL_EL02", "CNTV_CVAL_EL02", 0xEF1A, true, true,  {AArch64::FeatureVH}  }, // 700
  { "SPSR_EL12", "SPSR_EL12", 0xEA00, true, true,  {AArch64::FeatureVH}  }, // 701
  { "ELR_EL12", "ELR_EL12", 0xEA01, true, true,  {AArch64::FeatureVH}  }, // 702
  { "CONTEXTIDR_EL2", "CONTEXTIDR_EL2", 0xE681, true, true,  {AArch64::FeatureCONTEXTIDREL2}  }, // 703
  { "UAO", "UAO", 0xC214, true, true,  {AArch64::FeaturePsUAO}  }, // 704
  { "PMBLIMITR_EL1", "PMBLIMITR_EL1", 0xC4D0, true, true,  {AArch64::FeatureSPE}  }, // 705
  { "PMBPTR_EL1", "PMBPTR_EL1", 0xC4D1, true, true,  {AArch64::FeatureSPE}  }, // 706
  { "PMBSR_EL1", "PMBSR_EL1", 0xC4D3, true, true,  {AArch64::FeatureSPE}  }, // 707
  { "PMBIDR_EL1", "PMBIDR_EL1", 0xC4D7, true, false,  {AArch64::FeatureSPE}  }, // 708
  { "PMSCR_EL2", "PMSCR_EL2", 0xE4C8, true, true,  {AArch64::FeatureSPE}  }, // 709
  { "PMSCR_EL12", "PMSCR_EL12", 0xECC8, true, true,  {AArch64::FeatureSPE}  }, // 710
  { "PMSCR_EL1", "PMSCR_EL1", 0xC4C8, true, true,  {AArch64::FeatureSPE}  }, // 711
  { "PMSICR_EL1", "PMSICR_EL1", 0xC4CA, true, true,  {AArch64::FeatureSPE}  }, // 712
  { "PMSIRR_EL1", "PMSIRR_EL1", 0xC4CB, true, true,  {AArch64::FeatureSPE}  }, // 713
  { "PMSFCR_EL1", "PMSFCR_EL1", 0xC4CC, true, true,  {AArch64::FeatureSPE}  }, // 714
  { "PMSEVFR_EL1", "PMSEVFR_EL1", 0xC4CD, true, true,  {AArch64::FeatureSPE}  }, // 715
  { "PMSLATFR_EL1", "PMSLATFR_EL1", 0xC4CE, true, true,  {AArch64::FeatureSPE}  }, // 716
  { "PMSIDR_EL1", "PMSIDR_EL1", 0xC4CF, true, false,  {AArch64::FeatureSPE}  }, // 717
  { "ERRSELR_EL1", "ERRSELR_EL1", 0xC299, true, true,  {AArch64::FeatureRAS}  }, // 718
  { "ERXCTLR_EL1", "ERXCTLR_EL1", 0xC2A1, true, true,  {AArch64::FeatureRAS}  }, // 719
  { "ERXSTATUS_EL1", "ERXSTATUS_EL1", 0xC2A2, true, true,  {AArch64::FeatureRAS}  }, // 720
  { "ERXADDR_EL1", "ERXADDR_EL1", 0xC2A3, true, true,  {AArch64::FeatureRAS}  }, // 721
  { "ERXMISC0_EL1", "ERXMISC0_EL1", 0xC2A8, true, true,  {AArch64::FeatureRAS}  }, // 722
  { "ERXMISC1_EL1", "ERXMISC1_EL1", 0xC2A9, true, true,  {AArch64::FeatureRAS}  }, // 723
  { "DISR_EL1", "DISR_EL1", 0xC609, true, true,  {AArch64::FeatureRAS}  }, // 724
  { "VDISR_EL2", "VDISR_EL2", 0xE609, true, true,  {AArch64::FeatureRAS}  }, // 725
  { "VSESR_EL2", "VSESR_EL2", 0xE293, true, true,  {AArch64::FeatureRAS}  }, // 726
  { "APIAKeyLo_EL1", "APIAKeyLo_EL1", 0xC108, true, true,  {AArch64::FeaturePAuth}  }, // 727
  { "APIAKeyHi_EL1", "APIAKeyHi_EL1", 0xC109, true, true,  {AArch64::FeaturePAuth}  }, // 728
  { "APIBKeyLo_EL1", "APIBKeyLo_EL1", 0xC10A, true, true,  {AArch64::FeaturePAuth}  }, // 729
  { "APIBKeyHi_EL1", "APIBKeyHi_EL1", 0xC10B, true, true,  {AArch64::FeaturePAuth}  }, // 730
  { "APDAKeyLo_EL1", "APDAKeyLo_EL1", 0xC110, true, true,  {AArch64::FeaturePAuth}  }, // 731
  { "APDAKeyHi_EL1", "APDAKeyHi_EL1", 0xC111, true, true,  {AArch64::FeaturePAuth}  }, // 732
  { "APDBKeyLo_EL1", "APDBKeyLo_EL1", 0xC112, true, true,  {AArch64::FeaturePAuth}  }, // 733
  { "APDBKeyHi_EL1", "APDBKeyHi_EL1", 0xC113, true, true,  {AArch64::FeaturePAuth}  }, // 734
  { "APGAKeyLo_EL1", "APGAKeyLo_EL1", 0xC118, true, true,  {AArch64::FeaturePAuth}  }, // 735
  { "APGAKeyHi_EL1", "APGAKeyHi_EL1", 0xC119, true, true,  {AArch64::FeaturePAuth}  }, // 736
  { "VSTCR_EL2", "VSTCR_EL2", 0xE132, true, true,  {AArch64::FeatureSEL2}  }, // 737
  { "VSTTBR_EL2", "VSTTBR_EL2", 0xE130, true, true,  {AArch64::HasV8_0aOps}  }, // 738
  { "CNTHVS_TVAL_EL2", "CNTHVS_TVAL_EL2", 0xE720, true, true,  {AArch64::FeatureSEL2}  }, // 739
  { "CNTHVS_CVAL_EL2", "CNTHVS_CVAL_EL2", 0xE722, true, true,  {AArch64::FeatureSEL2}  }, // 740
  { "CNTHVS_CTL_EL2", "CNTHVS_CTL_EL2", 0xE721, true, true,  {AArch64::FeatureSEL2}  }, // 741
  { "CNTHPS_TVAL_EL2", "CNTHPS_TVAL_EL2", 0xE728, true, true,  {AArch64::FeatureSEL2}  }, // 742
  { "CNTHPS_CVAL_EL2", "CNTHPS_CVAL_EL2", 0xE72A, true, true,  {AArch64::FeatureSEL2}  }, // 743
  { "CNTHPS_CTL_EL2", "CNTHPS_CTL_EL2", 0xE729, true, true,  {AArch64::FeatureSEL2}  }, // 744
  { "SDER32_EL2", "SDER32_EL2", 0xE099, true, true,  {AArch64::FeatureSEL2}  }, // 745
  { "ERXPFGCTL_EL1", "ERXPFGCTL_EL1", 0xC2A5, true, true,  {}  }, // 746
  { "ERXPFGCDN_EL1", "ERXPFGCDN_EL1", 0xC2A6, true, true,  {}  }, // 747
  { "ERXMISC2_EL1", "ERXMISC2_EL1", 0xC2AA, true, true,  {}  }, // 748
  { "ERXMISC3_EL1", "ERXMISC3_EL1", 0xC2AB, true, true,  {}  }, // 749
  { "ERXPFGF_EL1", "ERXPFGF_EL1", 0xC2A4, true, false,  {}  }, // 750
  { "MPAM0_EL1", "MPAM0_EL1", 0xC529, true, true,  {AArch64::FeatureMPAM}  }, // 751
  { "MPAM1_EL1", "MPAM1_EL1", 0xC528, true, true,  {AArch64::FeatureMPAM}  }, // 752
  { "MPAM2_EL2", "MPAM2_EL2", 0xE528, true, true,  {AArch64::FeatureMPAM}  }, // 753
  { "MPAM3_EL3", "MPAM3_EL3", 0xF528, true, true,  {AArch64::FeatureMPAM}  }, // 754
  { "MPAM1_EL12", "MPAM1_EL12", 0xED28, true, true,  {AArch64::FeatureMPAM}  }, // 755
  { "MPAMHCR_EL2", "MPAMHCR_EL2", 0xE520, true, true,  {AArch64::FeatureMPAM}  }, // 756
  { "MPAMVPMV_EL2", "MPAMVPMV_EL2", 0xE521, true, true,  {AArch64::FeatureMPAM}  }, // 757
  { "MPAMVPM0_EL2", "MPAMVPM0_EL2", 0xE530, true, true,  {AArch64::FeatureMPAM}  }, // 758
  { "MPAMVPM1_EL2", "MPAMVPM1_EL2", 0xE531, true, true,  {AArch64::FeatureMPAM}  }, // 759
  { "MPAMVPM2_EL2", "MPAMVPM2_EL2", 0xE532, true, true,  {AArch64::FeatureMPAM}  }, // 760
  { "MPAMVPM3_EL2", "MPAMVPM3_EL2", 0xE533, true, true,  {AArch64::FeatureMPAM}  }, // 761
  { "MPAMVPM4_EL2", "MPAMVPM4_EL2", 0xE534, true, true,  {AArch64::FeatureMPAM}  }, // 762
  { "MPAMVPM5_EL2", "MPAMVPM5_EL2", 0xE535, true, true,  {AArch64::FeatureMPAM}  }, // 763
  { "MPAMVPM6_EL2", "MPAMVPM6_EL2", 0xE536, true, true,  {AArch64::FeatureMPAM}  }, // 764
  { "MPAMVPM7_EL2", "MPAMVPM7_EL2", 0xE537, true, true,  {AArch64::FeatureMPAM}  }, // 765
  { "MPAMIDR_EL1", "MPAMIDR_EL1", 0xC524, true, false,  {AArch64::FeatureMPAM}  }, // 766
  { "AMCR_EL0", "AMCR_EL0", 0xDE90, true, true,  {AArch64::FeatureAM}  }, // 767
  { "AMCFGR_EL0", "AMCFGR_EL0", 0xDE91, true, false,  {AArch64::FeatureAM}  }, // 768
  { "AMCGCR_EL0", "AMCGCR_EL0", 0xDE92, true, false,  {AArch64::FeatureAM}  }, // 769
  { "AMUSERENR_EL0", "AMUSERENR_EL0", 0xDE93, true, true,  {AArch64::FeatureAM}  }, // 770
  { "AMCNTENCLR0_EL0", "AMCNTENCLR0_EL0", 0xDE94, true, true,  {AArch64::FeatureAM}  }, // 771
  { "AMCNTENSET0_EL0", "AMCNTENSET0_EL0", 0xDE95, true, true,  {AArch64::FeatureAM}  }, // 772
  { "AMEVCNTR00_EL0", "AMEVCNTR00_EL0", 0xDEA0, true, true,  {AArch64::FeatureAM}  }, // 773
  { "AMEVCNTR01_EL0", "AMEVCNTR01_EL0", 0xDEA1, true, true,  {AArch64::FeatureAM}  }, // 774
  { "AMEVCNTR02_EL0", "AMEVCNTR02_EL0", 0xDEA2, true, true,  {AArch64::FeatureAM}  }, // 775
  { "AMEVCNTR03_EL0", "AMEVCNTR03_EL0", 0xDEA3, true, true,  {AArch64::FeatureAM}  }, // 776
  { "AMEVTYPER00_EL0", "AMEVTYPER00_EL0", 0xDEB0, true, false,  {AArch64::FeatureAM}  }, // 777
  { "AMEVTYPER01_EL0", "AMEVTYPER01_EL0", 0xDEB1, true, false,  {AArch64::FeatureAM}  }, // 778
  { "AMEVTYPER02_EL0", "AMEVTYPER02_EL0", 0xDEB2, true, false,  {AArch64::FeatureAM}  }, // 779
  { "AMEVTYPER03_EL0", "AMEVTYPER03_EL0", 0xDEB3, true, false,  {AArch64::FeatureAM}  }, // 780
  { "AMCNTENCLR1_EL0", "AMCNTENCLR1_EL0", 0xDE98, true, true,  {AArch64::FeatureAM}  }, // 781
  { "AMCNTENSET1_EL0", "AMCNTENSET1_EL0", 0xDE99, true, true,  {AArch64::FeatureAM}  }, // 782
  { "AMEVCNTR10_EL0", "AMEVCNTR10_EL0", 0xDEE0, true, true,  {AArch64::FeatureAM}  }, // 783
  { "AMEVCNTR11_EL0", "AMEVCNTR11_EL0", 0xDEE1, true, true,  {AArch64::FeatureAM}  }, // 784
  { "AMEVCNTR12_EL0", "AMEVCNTR12_EL0", 0xDEE2, true, true,  {AArch64::FeatureAM}  }, // 785
  { "AMEVCNTR13_EL0", "AMEVCNTR13_EL0", 0xDEE3, true, true,  {AArch64::FeatureAM}  }, // 786
  { "AMEVCNTR14_EL0", "AMEVCNTR14_EL0", 0xDEE4, true, true,  {AArch64::FeatureAM}  }, // 787
  { "AMEVCNTR15_EL0", "AMEVCNTR15_EL0", 0xDEE5, true, true,  {AArch64::FeatureAM}  }, // 788
  { "AMEVCNTR16_EL0", "AMEVCNTR16_EL0", 0xDEE6, true, true,  {AArch64::FeatureAM}  }, // 789
  { "AMEVCNTR17_EL0", "AMEVCNTR17_EL0", 0xDEE7, true, true,  {AArch64::FeatureAM}  }, // 790
  { "AMEVCNTR18_EL0", "AMEVCNTR18_EL0", 0xDEE8, true, true,  {AArch64::FeatureAM}  }, // 791
  { "AMEVCNTR19_EL0", "AMEVCNTR19_EL0", 0xDEE9, true, true,  {AArch64::FeatureAM}  }, // 792
  { "AMEVCNTR110_EL0", "AMEVCNTR110_EL0", 0xDEEA, true, true,  {AArch64::FeatureAM}  }, // 793
  { "AMEVCNTR111_EL0", "AMEVCNTR111_EL0", 0xDEEB, true, true,  {AArch64::FeatureAM}  }, // 794
  { "AMEVCNTR112_EL0", "AMEVCNTR112_EL0", 0xDEEC, true, true,  {AArch64::FeatureAM}  }, // 795
  { "AMEVCNTR113_EL0", "AMEVCNTR113_EL0", 0xDEED, true, true,  {AArch64::FeatureAM}  }, // 796
  { "AMEVCNTR114_EL0", "AMEVCNTR114_EL0", 0xDEEE, true, true,  {AArch64::FeatureAM}  }, // 797
  { "AMEVCNTR115_EL0", "AMEVCNTR115_EL0", 0xDEEF, true, true,  {AArch64::FeatureAM}  }, // 798
  { "AMEVTYPER10_EL0", "AMEVTYPER10_EL0", 0xDEF0, true, true,  {AArch64::FeatureAM}  }, // 799
  { "AMEVTYPER11_EL0", "AMEVTYPER11_EL0", 0xDEF1, true, true,  {AArch64::FeatureAM}  }, // 800
  { "AMEVTYPER12_EL0", "AMEVTYPER12_EL0", 0xDEF2, true, true,  {AArch64::FeatureAM}  }, // 801
  { "AMEVTYPER13_EL0", "AMEVTYPER13_EL0", 0xDEF3, true, true,  {AArch64::FeatureAM}  }, // 802
  { "AMEVTYPER14_EL0", "AMEVTYPER14_EL0", 0xDEF4, true, true,  {AArch64::FeatureAM}  }, // 803
  { "AMEVTYPER15_EL0", "AMEVTYPER15_EL0", 0xDEF5, true, true,  {AArch64::FeatureAM}  }, // 804
  { "AMEVTYPER16_EL0", "AMEVTYPER16_EL0", 0xDEF6, true, true,  {AArch64::FeatureAM}  }, // 805
  { "AMEVTYPER17_EL0", "AMEVTYPER17_EL0", 0xDEF7, true, true,  {AArch64::FeatureAM}  }, // 806
  { "AMEVTYPER18_EL0", "AMEVTYPER18_EL0", 0xDEF8, true, true,  {AArch64::FeatureAM}  }, // 807
  { "AMEVTYPER19_EL0", "AMEVTYPER19_EL0", 0xDEF9, true, true,  {AArch64::FeatureAM}  }, // 808
  { "AMEVTYPER110_EL0", "AMEVTYPER110_EL0", 0xDEFA, true, true,  {AArch64::FeatureAM}  }, // 809
  { "AMEVTYPER111_EL0", "AMEVTYPER111_EL0", 0xDEFB, true, true,  {AArch64::FeatureAM}  }, // 810
  { "AMEVTYPER112_EL0", "AMEVTYPER112_EL0", 0xDEFC, true, true,  {AArch64::FeatureAM}  }, // 811
  { "AMEVTYPER113_EL0", "AMEVTYPER113_EL0", 0xDEFD, true, true,  {AArch64::FeatureAM}  }, // 812
  { "AMEVTYPER114_EL0", "AMEVTYPER114_EL0", 0xDEFE, true, true,  {AArch64::FeatureAM}  }, // 813
  { "AMEVTYPER115_EL0", "AMEVTYPER115_EL0", 0xDEFF, true, true,  {AArch64::FeatureAM}  }, // 814
  { "TRFCR_EL1", "TRFCR_EL1", 0xC091, true, true,  {AArch64::FeatureTRACEV8_4}  }, // 815
  { "TRFCR_EL2", "TRFCR_EL2", 0xE091, true, true,  {AArch64::FeatureTRACEV8_4}  }, // 816
  { "TRFCR_EL12", "TRFCR_EL12", 0xE891, true, true,  {AArch64::FeatureTRACEV8_4}  }, // 817
  { "DIT", "DIT", 0xDA15, true, true,  {AArch64::FeatureDIT}  }, // 818
  { "VNCR_EL2", "VNCR_EL2", 0xE110, true, true,  {AArch64::FeatureNV}  }, // 819
  { "ZCR_EL1", "ZCR_EL1", 0xC090, true, true,  {AArch64::FeatureSVE}  }, // 820
  { "ZCR_EL2", "ZCR_EL2", 0xE090, true, true,  {AArch64::FeatureSVE}  }, // 821
  { "ZCR_EL3", "ZCR_EL3", 0xF090, true, true,  {AArch64::FeatureSVE}  }, // 822
  { "ZCR_EL12", "ZCR_EL12", 0xE890, true, true,  {AArch64::FeatureSVE}  }, // 823
  { "SSBS", "SSBS", 0xDA16, true, true,  {AArch64::FeatureSSBS}  }, // 824
  { "TCO", "TCO", 0xDA17, true, true,  {AArch64::FeatureMTE}  }, // 825
  { "GCR_EL1", "GCR_EL1", 0xC086, true, true,  {AArch64::FeatureMTE}  }, // 826
  { "RGSR_EL1", "RGSR_EL1", 0xC085, true, true,  {AArch64::FeatureMTE}  }, // 827
  { "TFSR_EL1", "TFSR_EL1", 0xC2B0, true, true,  {AArch64::FeatureMTE}  }, // 828
  { "TFSR_EL2", "TFSR_EL2", 0xE2B0, true, true,  {AArch64::FeatureMTE}  }, // 829
  { "TFSR_EL3", "TFSR_EL3", 0xF2B0, true, true,  {AArch64::FeatureMTE}  }, // 830
  { "TFSR_EL12", "TFSR_EL12", 0xEAB0, true, true,  {AArch64::FeatureMTE}  }, // 831
  { "TFSRE0_EL1", "TFSRE0_EL1", 0xC2B1, true, true,  {AArch64::FeatureMTE}  }, // 832
  { "GMID_EL1", "GMID_EL1", 0xC804, true, false,  {AArch64::FeatureMTE}  }, // 833
  { "TRCRSR", "TRCRSR", 0x8850, true, true,  {AArch64::FeatureETE}  }, // 834
  { "TRCEXTINSELR0", "TRCEXTINSELR0", 0x8844, true, true,  {AArch64::FeatureETE}  }, // 835
  { "TRCEXTINSELR1", "TRCEXTINSELR1", 0x884C, true, true,  {AArch64::FeatureETE}  }, // 836
  { "TRCEXTINSELR2", "TRCEXTINSELR2", 0x8854, true, true,  {AArch64::FeatureETE}  }, // 837
  { "TRCEXTINSELR3", "TRCEXTINSELR3", 0x885C, true, true,  {AArch64::FeatureETE}  }, // 838
  { "TRBLIMITR_EL1", "TRBLIMITR_EL1", 0xC4D8, true, true,  {AArch64::FeatureTRBE}  }, // 839
  { "TRBPTR_EL1", "TRBPTR_EL1", 0xC4D9, true, true,  {AArch64::FeatureTRBE}  }, // 840
  { "TRBBASER_EL1", "TRBBASER_EL1", 0xC4DA, true, true,  {AArch64::FeatureTRBE}  }, // 841
  { "TRBSR_EL1", "TRBSR_EL1", 0xC4DB, true, true,  {AArch64::FeatureTRBE}  }, // 842
  { "TRBMAR_EL1", "TRBMAR_EL1", 0xC4DC, true, true,  {AArch64::FeatureTRBE}  }, // 843
  { "TRBTRG_EL1", "TRBTRG_EL1", 0xC4DE, true, true,  {AArch64::FeatureTRBE}  }, // 844
  { "TRBIDR_EL1", "TRBIDR_EL1", 0xC4DF, true, false,  {AArch64::FeatureTRBE}  }, // 845
  { "AMEVCNTVOFF00_EL2", "AMEVCNTVOFF00_EL2", 0xE6C0, true, true,  {AArch64::FeatureAMVS}  }, // 846
  { "AMEVCNTVOFF10_EL2", "AMEVCNTVOFF10_EL2", 0xE6D0, true, true,  {AArch64::FeatureAMVS}  }, // 847
  { "AMEVCNTVOFF01_EL2", "AMEVCNTVOFF01_EL2", 0xE6C1, true, true,  {AArch64::FeatureAMVS}  }, // 848
  { "AMEVCNTVOFF11_EL2", "AMEVCNTVOFF11_EL2", 0xE6D1, true, true,  {AArch64::FeatureAMVS}  }, // 849
  { "AMEVCNTVOFF02_EL2", "AMEVCNTVOFF02_EL2", 0xE6C2, true, true,  {AArch64::FeatureAMVS}  }, // 850
  { "AMEVCNTVOFF12_EL2", "AMEVCNTVOFF12_EL2", 0xE6D2, true, true,  {AArch64::FeatureAMVS}  }, // 851
  { "AMEVCNTVOFF03_EL2", "AMEVCNTVOFF03_EL2", 0xE6C3, true, true,  {AArch64::FeatureAMVS}  }, // 852
  { "AMEVCNTVOFF13_EL2", "AMEVCNTVOFF13_EL2", 0xE6D3, true, true,  {AArch64::FeatureAMVS}  }, // 853
  { "AMEVCNTVOFF04_EL2", "AMEVCNTVOFF04_EL2", 0xE6C4, true, true,  {AArch64::FeatureAMVS}  }, // 854
  { "AMEVCNTVOFF14_EL2", "AMEVCNTVOFF14_EL2", 0xE6D4, true, true,  {AArch64::FeatureAMVS}  }, // 855
  { "AMEVCNTVOFF05_EL2", "AMEVCNTVOFF05_EL2", 0xE6C5, true, true,  {AArch64::FeatureAMVS}  }, // 856
  { "AMEVCNTVOFF15_EL2", "AMEVCNTVOFF15_EL2", 0xE6D5, true, true,  {AArch64::FeatureAMVS}  }, // 857
  { "AMEVCNTVOFF06_EL2", "AMEVCNTVOFF06_EL2", 0xE6C6, true, true,  {AArch64::FeatureAMVS}  }, // 858
  { "AMEVCNTVOFF16_EL2", "AMEVCNTVOFF16_EL2", 0xE6D6, true, true,  {AArch64::FeatureAMVS}  }, // 859
  { "AMEVCNTVOFF07_EL2", "AMEVCNTVOFF07_EL2", 0xE6C7, true, true,  {AArch64::FeatureAMVS}  }, // 860
  { "AMEVCNTVOFF17_EL2", "AMEVCNTVOFF17_EL2", 0xE6D7, true, true,  {AArch64::FeatureAMVS}  }, // 861
  { "AMEVCNTVOFF08_EL2", "AMEVCNTVOFF08_EL2", 0xE6C8, true, true,  {AArch64::FeatureAMVS}  }, // 862
  { "AMEVCNTVOFF18_EL2", "AMEVCNTVOFF18_EL2", 0xE6D8, true, true,  {AArch64::FeatureAMVS}  }, // 863
  { "AMEVCNTVOFF09_EL2", "AMEVCNTVOFF09_EL2", 0xE6C9, true, true,  {AArch64::FeatureAMVS}  }, // 864
  { "AMEVCNTVOFF19_EL2", "AMEVCNTVOFF19_EL2", 0xE6D9, true, true,  {AArch64::FeatureAMVS}  }, // 865
  { "AMEVCNTVOFF010_EL2", "AMEVCNTVOFF010_EL2", 0xE6CA, true, true,  {AArch64::FeatureAMVS}  }, // 866
  { "AMEVCNTVOFF110_EL2", "AMEVCNTVOFF110_EL2", 0xE6DA, true, true,  {AArch64::FeatureAMVS}  }, // 867
  { "AMEVCNTVOFF011_EL2", "AMEVCNTVOFF011_EL2", 0xE6CB, true, true,  {AArch64::FeatureAMVS}  }, // 868
  { "AMEVCNTVOFF111_EL2", "AMEVCNTVOFF111_EL2", 0xE6DB, true, true,  {AArch64::FeatureAMVS}  }, // 869
  { "AMEVCNTVOFF012_EL2", "AMEVCNTVOFF012_EL2", 0xE6CC, true, true,  {AArch64::FeatureAMVS}  }, // 870
  { "AMEVCNTVOFF112_EL2", "AMEVCNTVOFF112_EL2", 0xE6DC, true, true,  {AArch64::FeatureAMVS}  }, // 871
  { "AMEVCNTVOFF013_EL2", "AMEVCNTVOFF013_EL2", 0xE6CD, true, true,  {AArch64::FeatureAMVS}  }, // 872
  { "AMEVCNTVOFF113_EL2", "AMEVCNTVOFF113_EL2", 0xE6DD, true, true,  {AArch64::FeatureAMVS}  }, // 873
  { "AMEVCNTVOFF014_EL2", "AMEVCNTVOFF014_EL2", 0xE6CE, true, true,  {AArch64::FeatureAMVS}  }, // 874
  { "AMEVCNTVOFF114_EL2", "AMEVCNTVOFF114_EL2", 0xE6DE, true, true,  {AArch64::FeatureAMVS}  }, // 875
  { "AMEVCNTVOFF015_EL2", "AMEVCNTVOFF015_EL2", 0xE6CF, true, true,  {AArch64::FeatureAMVS}  }, // 876
  { "AMEVCNTVOFF115_EL2", "AMEVCNTVOFF115_EL2", 0xE6DF, true, true,  {AArch64::FeatureAMVS}  }, // 877
  { "HFGRTR_EL2", "HFGRTR_EL2", 0xE08C, true, true,  {AArch64::FeatureFineGrainedTraps}  }, // 878
  { "HFGWTR_EL2", "HFGWTR_EL2", 0xE08D, true, true,  {AArch64::FeatureFineGrainedTraps}  }, // 879
  { "HFGITR_EL2", "HFGITR_EL2", 0xE08E, true, true,  {AArch64::FeatureFineGrainedTraps}  }, // 880
  { "HDFGRTR_EL2", "HDFGRTR_EL2", 0xE18C, true, true,  {AArch64::FeatureFineGrainedTraps}  }, // 881
  { "HDFGWTR_EL2", "HDFGWTR_EL2", 0xE18D, true, true,  {AArch64::FeatureFineGrainedTraps}  }, // 882
  { "CNTSCALE_EL2", "CNTSCALE_EL2", 0xE704, true, true,  {AArch64::FeatureEnhancedCounterVirtualization}  }, // 883
  { "CNTISCALE_EL2", "CNTISCALE_EL2", 0xE705, true, true,  {AArch64::FeatureEnhancedCounterVirtualization}  }, // 884
  { "CNTPOFF_EL2", "CNTPOFF_EL2", 0xE706, true, true,  {AArch64::FeatureEnhancedCounterVirtualization}  }, // 885
  { "CNTVFRQ_EL2", "CNTVFRQ_EL2", 0xE707, true, true,  {AArch64::FeatureEnhancedCounterVirtualization}  }, // 886
  { "CNTPCTSS_EL0", "CNTPCTSS_EL0", 0xDF05, true, true,  {AArch64::FeatureEnhancedCounterVirtualization}  }, // 887
  { "CNTVCTSS_EL0", "CNTVCTSS_EL0", 0xDF06, true, true,  {AArch64::FeatureEnhancedCounterVirtualization}  }, // 888
  { "ACCDATA_EL1", "ACCDATA_EL1", 0xC685, true, true,  {AArch64::FeatureLS64}  }, // 889
  { "BRBCR_EL1", "BRBCR_EL1", 0x8C80, true, true,  {AArch64::FeatureBRBE}  }, // 890
  { "BRBCR_EL12", "BRBCR_EL12", 0xAC80, true, true,  {AArch64::FeatureBRBE}  }, // 891
  { "BRBCR_EL2", "BRBCR_EL2", 0xA480, true, true,  {AArch64::FeatureBRBE}  }, // 892
  { "BRBFCR_EL1", "BRBFCR_EL1", 0x8C81, true, true,  {AArch64::FeatureBRBE}  }, // 893
  { "BRBIDR0_EL1", "BRBIDR0_EL1", 0x8C90, true, false,  {AArch64::FeatureBRBE}  }, // 894
  { "BRBINFINJ_EL1", "BRBINFINJ_EL1", 0x8C88, true, true,  {AArch64::FeatureBRBE}  }, // 895
  { "BRBSRCINJ_EL1", "BRBSRCINJ_EL1", 0x8C89, true, true,  {AArch64::FeatureBRBE}  }, // 896
  { "BRBTGTINJ_EL1", "BRBTGTINJ_EL1", 0x8C8A, true, true,  {AArch64::FeatureBRBE}  }, // 897
  { "BRBTS_EL1", "BRBTS_EL1", 0x8C82, true, true,  {AArch64::FeatureBRBE}  }, // 898
  { "BRBINF0_EL1", "BRBINF0_EL1", 0x8C00, true, false,  {AArch64::FeatureBRBE}  }, // 899
  { "BRBSRC0_EL1", "BRBSRC0_EL1", 0x8C01, true, false,  {AArch64::FeatureBRBE}  }, // 900
  { "BRBTGT0_EL1", "BRBTGT0_EL1", 0x8C02, true, false,  {AArch64::FeatureBRBE}  }, // 901
  { "BRBINF1_EL1", "BRBINF1_EL1", 0x8C08, true, false,  {AArch64::FeatureBRBE}  }, // 902
  { "BRBSRC1_EL1", "BRBSRC1_EL1", 0x8C09, true, false,  {AArch64::FeatureBRBE}  }, // 903
  { "BRBTGT1_EL1", "BRBTGT1_EL1", 0x8C0A, true, false,  {AArch64::FeatureBRBE}  }, // 904
  { "BRBINF2_EL1", "BRBINF2_EL1", 0x8C10, true, false,  {AArch64::FeatureBRBE}  }, // 905
  { "BRBSRC2_EL1", "BRBSRC2_EL1", 0x8C11, true, false,  {AArch64::FeatureBRBE}  }, // 906
  { "BRBTGT2_EL1", "BRBTGT2_EL1", 0x8C12, true, false,  {AArch64::FeatureBRBE}  }, // 907
  { "BRBINF3_EL1", "BRBINF3_EL1", 0x8C18, true, false,  {AArch64::FeatureBRBE}  }, // 908
  { "BRBSRC3_EL1", "BRBSRC3_EL1", 0x8C19, true, false,  {AArch64::FeatureBRBE}  }, // 909
  { "BRBTGT3_EL1", "BRBTGT3_EL1", 0x8C1A, true, false,  {AArch64::FeatureBRBE}  }, // 910
  { "BRBINF4_EL1", "BRBINF4_EL1", 0x8C20, true, false,  {AArch64::FeatureBRBE}  }, // 911
  { "BRBSRC4_EL1", "BRBSRC4_EL1", 0x8C21, true, false,  {AArch64::FeatureBRBE}  }, // 912
  { "BRBTGT4_EL1", "BRBTGT4_EL1", 0x8C22, true, false,  {AArch64::FeatureBRBE}  }, // 913
  { "BRBINF5_EL1", "BRBINF5_EL1", 0x8C28, true, false,  {AArch64::FeatureBRBE}  }, // 914
  { "BRBSRC5_EL1", "BRBSRC5_EL1", 0x8C29, true, false,  {AArch64::FeatureBRBE}  }, // 915
  { "BRBTGT5_EL1", "BRBTGT5_EL1", 0x8C2A, true, false,  {AArch64::FeatureBRBE}  }, // 916
  { "BRBINF6_EL1", "BRBINF6_EL1", 0x8C30, true, false,  {AArch64::FeatureBRBE}  }, // 917
  { "BRBSRC6_EL1", "BRBSRC6_EL1", 0x8C31, true, false,  {AArch64::FeatureBRBE}  }, // 918
  { "BRBTGT6_EL1", "BRBTGT6_EL1", 0x8C32, true, false,  {AArch64::FeatureBRBE}  }, // 919
  { "BRBINF7_EL1", "BRBINF7_EL1", 0x8C38, true, false,  {AArch64::FeatureBRBE}  }, // 920
  { "BRBSRC7_EL1", "BRBSRC7_EL1", 0x8C39, true, false,  {AArch64::FeatureBRBE}  }, // 921
  { "BRBTGT7_EL1", "BRBTGT7_EL1", 0x8C3A, true, false,  {AArch64::FeatureBRBE}  }, // 922
  { "BRBINF8_EL1", "BRBINF8_EL1", 0x8C40, true, false,  {AArch64::FeatureBRBE}  }, // 923
  { "BRBSRC8_EL1", "BRBSRC8_EL1", 0x8C41, true, false,  {AArch64::FeatureBRBE}  }, // 924
  { "BRBTGT8_EL1", "BRBTGT8_EL1", 0x8C42, true, false,  {AArch64::FeatureBRBE}  }, // 925
  { "BRBINF9_EL1", "BRBINF9_EL1", 0x8C48, true, false,  {AArch64::FeatureBRBE}  }, // 926
  { "BRBSRC9_EL1", "BRBSRC9_EL1", 0x8C49, true, false,  {AArch64::FeatureBRBE}  }, // 927
  { "BRBTGT9_EL1", "BRBTGT9_EL1", 0x8C4A, true, false,  {AArch64::FeatureBRBE}  }, // 928
  { "BRBINF10_EL1", "BRBINF10_EL1", 0x8C50, true, false,  {AArch64::FeatureBRBE}  }, // 929
  { "BRBSRC10_EL1", "BRBSRC10_EL1", 0x8C51, true, false,  {AArch64::FeatureBRBE}  }, // 930
  { "BRBTGT10_EL1", "BRBTGT10_EL1", 0x8C52, true, false,  {AArch64::FeatureBRBE}  }, // 931
  { "BRBINF11_EL1", "BRBINF11_EL1", 0x8C58, true, false,  {AArch64::FeatureBRBE}  }, // 932
  { "BRBSRC11_EL1", "BRBSRC11_EL1", 0x8C59, true, false,  {AArch64::FeatureBRBE}  }, // 933
  { "BRBTGT11_EL1", "BRBTGT11_EL1", 0x8C5A, true, false,  {AArch64::FeatureBRBE}  }, // 934
  { "BRBINF12_EL1", "BRBINF12_EL1", 0x8C60, true, false,  {AArch64::FeatureBRBE}  }, // 935
  { "BRBSRC12_EL1", "BRBSRC12_EL1", 0x8C61, true, false,  {AArch64::FeatureBRBE}  }, // 936
  { "BRBTGT12_EL1", "BRBTGT12_EL1", 0x8C62, true, false,  {AArch64::FeatureBRBE}  }, // 937
  { "BRBINF13_EL1", "BRBINF13_EL1", 0x8C68, true, false,  {AArch64::FeatureBRBE}  }, // 938
  { "BRBSRC13_EL1", "BRBSRC13_EL1", 0x8C69, true, false,  {AArch64::FeatureBRBE}  }, // 939
  { "BRBTGT13_EL1", "BRBTGT13_EL1", 0x8C6A, true, false,  {AArch64::FeatureBRBE}  }, // 940
  { "BRBINF14_EL1", "BRBINF14_EL1", 0x8C70, true, false,  {AArch64::FeatureBRBE}  }, // 941
  { "BRBSRC14_EL1", "BRBSRC14_EL1", 0x8C71, true, false,  {AArch64::FeatureBRBE}  }, // 942
  { "BRBTGT14_EL1", "BRBTGT14_EL1", 0x8C72, true, false,  {AArch64::FeatureBRBE}  }, // 943
  { "BRBINF15_EL1", "BRBINF15_EL1", 0x8C78, true, false,  {AArch64::FeatureBRBE}  }, // 944
  { "BRBSRC15_EL1", "BRBSRC15_EL1", 0x8C79, true, false,  {AArch64::FeatureBRBE}  }, // 945
  { "BRBTGT15_EL1", "BRBTGT15_EL1", 0x8C7A, true, false,  {AArch64::FeatureBRBE}  }, // 946
  { "BRBINF16_EL1", "BRBINF16_EL1", 0x8C04, true, false,  {AArch64::FeatureBRBE}  }, // 947
  { "BRBSRC16_EL1", "BRBSRC16_EL1", 0x8C05, true, false,  {AArch64::FeatureBRBE}  }, // 948
  { "BRBTGT16_EL1", "BRBTGT16_EL1", 0x8C06, true, false,  {AArch64::FeatureBRBE}  }, // 949
  { "BRBINF17_EL1", "BRBINF17_EL1", 0x8C0C, true, false,  {AArch64::FeatureBRBE}  }, // 950
  { "BRBSRC17_EL1", "BRBSRC17_EL1", 0x8C0D, true, false,  {AArch64::FeatureBRBE}  }, // 951
  { "BRBTGT17_EL1", "BRBTGT17_EL1", 0x8C0E, true, false,  {AArch64::FeatureBRBE}  }, // 952
  { "BRBINF18_EL1", "BRBINF18_EL1", 0x8C14, true, false,  {AArch64::FeatureBRBE}  }, // 953
  { "BRBSRC18_EL1", "BRBSRC18_EL1", 0x8C15, true, false,  {AArch64::FeatureBRBE}  }, // 954
  { "BRBTGT18_EL1", "BRBTGT18_EL1", 0x8C16, true, false,  {AArch64::FeatureBRBE}  }, // 955
  { "BRBINF19_EL1", "BRBINF19_EL1", 0x8C1C, true, false,  {AArch64::FeatureBRBE}  }, // 956
  { "BRBSRC19_EL1", "BRBSRC19_EL1", 0x8C1D, true, false,  {AArch64::FeatureBRBE}  }, // 957
  { "BRBTGT19_EL1", "BRBTGT19_EL1", 0x8C1E, true, false,  {AArch64::FeatureBRBE}  }, // 958
  { "BRBINF20_EL1", "BRBINF20_EL1", 0x8C24, true, false,  {AArch64::FeatureBRBE}  }, // 959
  { "BRBSRC20_EL1", "BRBSRC20_EL1", 0x8C25, true, false,  {AArch64::FeatureBRBE}  }, // 960
  { "BRBTGT20_EL1", "BRBTGT20_EL1", 0x8C26, true, false,  {AArch64::FeatureBRBE}  }, // 961
  { "BRBINF21_EL1", "BRBINF21_EL1", 0x8C2C, true, false,  {AArch64::FeatureBRBE}  }, // 962
  { "BRBSRC21_EL1", "BRBSRC21_EL1", 0x8C2D, true, false,  {AArch64::FeatureBRBE}  }, // 963
  { "BRBTGT21_EL1", "BRBTGT21_EL1", 0x8C2E, true, false,  {AArch64::FeatureBRBE}  }, // 964
  { "BRBINF22_EL1", "BRBINF22_EL1", 0x8C34, true, false,  {AArch64::FeatureBRBE}  }, // 965
  { "BRBSRC22_EL1", "BRBSRC22_EL1", 0x8C35, true, false,  {AArch64::FeatureBRBE}  }, // 966
  { "BRBTGT22_EL1", "BRBTGT22_EL1", 0x8C36, true, false,  {AArch64::FeatureBRBE}  }, // 967
  { "BRBINF23_EL1", "BRBINF23_EL1", 0x8C3C, true, false,  {AArch64::FeatureBRBE}  }, // 968
  { "BRBSRC23_EL1", "BRBSRC23_EL1", 0x8C3D, true, false,  {AArch64::FeatureBRBE}  }, // 969
  { "BRBTGT23_EL1", "BRBTGT23_EL1", 0x8C3E, true, false,  {AArch64::FeatureBRBE}  }, // 970
  { "BRBINF24_EL1", "BRBINF24_EL1", 0x8C44, true, false,  {AArch64::FeatureBRBE}  }, // 971
  { "BRBSRC24_EL1", "BRBSRC24_EL1", 0x8C45, true, false,  {AArch64::FeatureBRBE}  }, // 972
  { "BRBTGT24_EL1", "BRBTGT24_EL1", 0x8C46, true, false,  {AArch64::FeatureBRBE}  }, // 973
  { "BRBINF25_EL1", "BRBINF25_EL1", 0x8C4C, true, false,  {AArch64::FeatureBRBE}  }, // 974
  { "BRBSRC25_EL1", "BRBSRC25_EL1", 0x8C4D, true, false,  {AArch64::FeatureBRBE}  }, // 975
  { "BRBTGT25_EL1", "BRBTGT25_EL1", 0x8C4E, true, false,  {AArch64::FeatureBRBE}  }, // 976
  { "BRBINF26_EL1", "BRBINF26_EL1", 0x8C54, true, false,  {AArch64::FeatureBRBE}  }, // 977
  { "BRBSRC26_EL1", "BRBSRC26_EL1", 0x8C55, true, false,  {AArch64::FeatureBRBE}  }, // 978
  { "BRBTGT26_EL1", "BRBTGT26_EL1", 0x8C56, true, false,  {AArch64::FeatureBRBE}  }, // 979
  { "BRBINF27_EL1", "BRBINF27_EL1", 0x8C5C, true, false,  {AArch64::FeatureBRBE}  }, // 980
  { "BRBSRC27_EL1", "BRBSRC27_EL1", 0x8C5D, true, false,  {AArch64::FeatureBRBE}  }, // 981
  { "BRBTGT27_EL1", "BRBTGT27_EL1", 0x8C5E, true, false,  {AArch64::FeatureBRBE}  }, // 982
  { "BRBINF28_EL1", "BRBINF28_EL1", 0x8C64, true, false,  {AArch64::FeatureBRBE}  }, // 983
  { "BRBSRC28_EL1", "BRBSRC28_EL1", 0x8C65, true, false,  {AArch64::FeatureBRBE}  }, // 984
  { "BRBTGT28_EL1", "BRBTGT28_EL1", 0x8C66, true, false,  {AArch64::FeatureBRBE}  }, // 985
  { "BRBINF29_EL1", "BRBINF29_EL1", 0x8C6C, true, false,  {AArch64::FeatureBRBE}  }, // 986
  { "BRBSRC29_EL1", "BRBSRC29_EL1", 0x8C6D, true, false,  {AArch64::FeatureBRBE}  }, // 987
  { "BRBTGT29_EL1", "BRBTGT29_EL1", 0x8C6E, true, false,  {AArch64::FeatureBRBE}  }, // 988
  { "BRBINF30_EL1", "BRBINF30_EL1", 0x8C74, true, false,  {AArch64::FeatureBRBE}  }, // 989
  { "BRBSRC30_EL1", "BRBSRC30_EL1", 0x8C75, true, false,  {AArch64::FeatureBRBE}  }, // 990
  { "BRBTGT30_EL1", "BRBTGT30_EL1", 0x8C76, true, false,  {AArch64::FeatureBRBE}  }, // 991
  { "BRBINF31_EL1", "BRBINF31_EL1", 0x8C7C, true, false,  {AArch64::FeatureBRBE}  }, // 992
  { "BRBSRC31_EL1", "BRBSRC31_EL1", 0x8C7D, true, false,  {AArch64::FeatureBRBE}  }, // 993
  { "BRBTGT31_EL1", "BRBTGT31_EL1", 0x8C7E, true, false,  {AArch64::FeatureBRBE}  }, // 994
  { "PMSNEVFR_EL1", "PMSNEVFR_EL1", 0xC4C9, true, true,  {AArch64::FeatureSPE_EEF}  }, // 995
  { "CPM_IOACC_CTL_EL3", "CPM_IOACC_CTL_EL3", 0xFF90, true, true,  {AArch64::FeatureAppleA7SysReg}  }, // 996
  { "SMCR_EL1", "SMCR_EL1", 0xC096, true, true,  {AArch64::FeatureSME}  }, // 997
  { "SMCR_EL2", "SMCR_EL2", 0xE096, true, true,  {AArch64::FeatureSME}  }, // 998
  { "SMCR_EL3", "SMCR_EL3", 0xF096, true, true,  {AArch64::FeatureSME}  }, // 999
  { "SMCR_EL12", "SMCR_EL12", 0xE896, true, true,  {AArch64::FeatureSME}  }, // 1000
  { "SVCR", "SVCR", 0xDA12, true, true,  {AArch64::FeatureSME}  }, // 1001
  { "SMPRI_EL1", "SMPRI_EL1", 0xC094, true, true,  {AArch64::FeatureSME}  }, // 1002
  { "SMPRIMAP_EL2", "SMPRIMAP_EL2", 0xE095, true, true,  {AArch64::FeatureSME}  }, // 1003
  { "SMIDR_EL1", "SMIDR_EL1", 0xC806, true, false,  {AArch64::FeatureSME}  }, // 1004
  { "TPIDR2_EL0", "TPIDR2_EL0", 0xDE85, true, true,  {AArch64::FeatureSME}  }, // 1005
  { "MPAMSM_EL1", "MPAMSM_EL1", 0xC52B, true, true,  {AArch64::FeatureMPAM, AArch64::FeatureSME}  }, // 1006
 };

const SysReg *lookupSysRegByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "ACCDATA_EL1", 889 },
    { "ACTLR_EL1", 209 },
    { "ACTLR_EL2", 210 },
    { "ACTLR_EL3", 211 },
    { "AFSR0_EL1", 254 },
    { "AFSR0_EL12", 686 },
    { "AFSR0_EL2", 255 },
    { "AFSR0_EL3", 256 },
    { "AFSR1_EL1", 257 },
    { "AFSR1_EL12", 687 },
    { "AFSR1_EL2", 258 },
    { "AFSR1_EL3", 259 },
    { "AIDR_EL1", 14 },
    { "AMAIR_EL1", 285 },
    { "AMAIR_EL12", 691 },
    { "AMAIR_EL2", 286 },
    { "AMAIR_EL3", 287 },
    { "AMCFGR_EL0", 768 },
    { "AMCGCR_EL0", 769 },
    { "AMCNTENCLR0_EL0", 771 },
    { "AMCNTENCLR1_EL0", 781 },
    { "AMCNTENSET0_EL0", 772 },
    { "AMCNTENSET1_EL0", 782 },
    { "AMCR_EL0", 767 },
    { "AMEVCNTR00_EL0", 773 },
    { "AMEVCNTR01_EL0", 774 },
    { "AMEVCNTR02_EL0", 775 },
    { "AMEVCNTR03_EL0", 776 },
    { "AMEVCNTR10_EL0", 783 },
    { "AMEVCNTR110_EL0", 793 },
    { "AMEVCNTR111_EL0", 794 },
    { "AMEVCNTR112_EL0", 795 },
    { "AMEVCNTR113_EL0", 796 },
    { "AMEVCNTR114_EL0", 797 },
    { "AMEVCNTR115_EL0", 798 },
    { "AMEVCNTR11_EL0", 784 },
    { "AMEVCNTR12_EL0", 785 },
    { "AMEVCNTR13_EL0", 786 },
    { "AMEVCNTR14_EL0", 787 },
    { "AMEVCNTR15_EL0", 788 },
    { "AMEVCNTR16_EL0", 789 },
    { "AMEVCNTR17_EL0", 790 },
    { "AMEVCNTR18_EL0", 791 },
    { "AMEVCNTR19_EL0", 792 },
    { "AMEVCNTVOFF00_EL2", 846 },
    { "AMEVCNTVOFF010_EL2", 866 },
    { "AMEVCNTVOFF011_EL2", 868 },
    { "AMEVCNTVOFF012_EL2", 870 },
    { "AMEVCNTVOFF013_EL2", 872 },
    { "AMEVCNTVOFF014_EL2", 874 },
    { "AMEVCNTVOFF015_EL2", 876 },
    { "AMEVCNTVOFF01_EL2", 848 },
    { "AMEVCNTVOFF02_EL2", 850 },
    { "AMEVCNTVOFF03_EL2", 852 },
    { "AMEVCNTVOFF04_EL2", 854 },
    { "AMEVCNTVOFF05_EL2", 856 },
    { "AMEVCNTVOFF06_EL2", 858 },
    { "AMEVCNTVOFF07_EL2", 860 },
    { "AMEVCNTVOFF08_EL2", 862 },
    { "AMEVCNTVOFF09_EL2", 864 },
    { "AMEVCNTVOFF10_EL2", 847 },
    { "AMEVCNTVOFF110_EL2", 867 },
    { "AMEVCNTVOFF111_EL2", 869 },
    { "AMEVCNTVOFF112_EL2", 871 },
    { "AMEVCNTVOFF113_EL2", 873 },
    { "AMEVCNTVOFF114_EL2", 875 },
    { "AMEVCNTVOFF115_EL2", 877 },
    { "AMEVCNTVOFF11_EL2", 849 },
    { "AMEVCNTVOFF12_EL2", 851 },
    { "AMEVCNTVOFF13_EL2", 853 },
    { "AMEVCNTVOFF14_EL2", 855 },
    { "AMEVCNTVOFF15_EL2", 857 },
    { "AMEVCNTVOFF16_EL2", 859 },
    { "AMEVCNTVOFF17_EL2", 861 },
    { "AMEVCNTVOFF18_EL2", 863 },
    { "AMEVCNTVOFF19_EL2", 865 },
    { "AMEVTYPER00_EL0", 777 },
    { "AMEVTYPER01_EL0", 778 },
    { "AMEVTYPER02_EL0", 779 },
    { "AMEVTYPER03_EL0", 780 },
    { "AMEVTYPER10_EL0", 799 },
    { "AMEVTYPER110_EL0", 809 },
    { "AMEVTYPER111_EL0", 810 },
    { "AMEVTYPER112_EL0", 811 },
    { "AMEVTYPER113_EL0", 812 },
    { "AMEVTYPER114_EL0", 813 },
    { "AMEVTYPER115_EL0", 814 },
    { "AMEVTYPER11_EL0", 800 },
    { "AMEVTYPER12_EL0", 801 },
    { "AMEVTYPER13_EL0", 802 },
    { "AMEVTYPER14_EL0", 803 },
    { "AMEVTYPER15_EL0", 804 },
    { "AMEVTYPER16_EL0", 805 },
    { "AMEVTYPER17_EL0", 806 },
    { "AMEVTYPER18_EL0", 807 },
    { "AMEVTYPER19_EL0", 808 },
    { "AMUSERENR_EL0", 770 },
    { "APDAKEYHI_EL1", 732 },
    { "APDAKEYLO_EL1", 731 },
    { "APDBKEYHI_EL1", 734 },
    { "APDBKEYLO_EL1", 733 },
    { "APGAKEYHI_EL1", 736 },
    { "APGAKEYLO_EL1", 735 },
    { "APIAKEYHI_EL1", 728 },
    { "APIAKEYLO_EL1", 727 },
    { "APIBKEYHI_EL1", 730 },
    { "APIBKEYLO_EL1", 729 },
    { "BRBCR_EL1", 890 },
    { "BRBCR_EL12", 891 },
    { "BRBCR_EL2", 892 },
    { "BRBFCR_EL1", 893 },
    { "BRBIDR0_EL1", 894 },
    { "BRBINF0_EL1", 899 },
    { "BRBINF10_EL1", 929 },
    { "BRBINF11_EL1", 932 },
    { "BRBINF12_EL1", 935 },
    { "BRBINF13_EL1", 938 },
    { "BRBINF14_EL1", 941 },
    { "BRBINF15_EL1", 944 },
    { "BRBINF16_EL1", 947 },
    { "BRBINF17_EL1", 950 },
    { "BRBINF18_EL1", 953 },
    { "BRBINF19_EL1", 956 },
    { "BRBINF1_EL1", 902 },
    { "BRBINF20_EL1", 959 },
    { "BRBINF21_EL1", 962 },
    { "BRBINF22_EL1", 965 },
    { "BRBINF23_EL1", 968 },
    { "BRBINF24_EL1", 971 },
    { "BRBINF25_EL1", 974 },
    { "BRBINF26_EL1", 977 },
    { "BRBINF27_EL1", 980 },
    { "BRBINF28_EL1", 983 },
    { "BRBINF29_EL1", 986 },
    { "BRBINF2_EL1", 905 },
    { "BRBINF30_EL1", 989 },
    { "BRBINF31_EL1", 992 },
    { "BRBINF3_EL1", 908 },
    { "BRBINF4_EL1", 911 },
    { "BRBINF5_EL1", 914 },
    { "BRBINF6_EL1", 917 },
    { "BRBINF7_EL1", 920 },
    { "BRBINF8_EL1", 923 },
    { "BRBINF9_EL1", 926 },
    { "BRBINFINJ_EL1", 895 },
    { "BRBSRC0_EL1", 900 },
    { "BRBSRC10_EL1", 930 },
    { "BRBSRC11_EL1", 933 },
    { "BRBSRC12_EL1", 936 },
    { "BRBSRC13_EL1", 939 },
    { "BRBSRC14_EL1", 942 },
    { "BRBSRC15_EL1", 945 },
    { "BRBSRC16_EL1", 948 },
    { "BRBSRC17_EL1", 951 },
    { "BRBSRC18_EL1", 954 },
    { "BRBSRC19_EL1", 957 },
    { "BRBSRC1_EL1", 903 },
    { "BRBSRC20_EL1", 960 },
    { "BRBSRC21_EL1", 963 },
    { "BRBSRC22_EL1", 966 },
    { "BRBSRC23_EL1", 969 },
    { "BRBSRC24_EL1", 972 },
    { "BRBSRC25_EL1", 975 },
    { "BRBSRC26_EL1", 978 },
    { "BRBSRC27_EL1", 981 },
    { "BRBSRC28_EL1", 984 },
    { "BRBSRC29_EL1", 987 },
    { "BRBSRC2_EL1", 906 },
    { "BRBSRC30_EL1", 990 },
    { "BRBSRC31_EL1", 993 },
    { "BRBSRC3_EL1", 909 },
    { "BRBSRC4_EL1", 912 },
    { "BRBSRC5_EL1", 915 },
    { "BRBSRC6_EL1", 918 },
    { "BRBSRC7_EL1", 921 },
    { "BRBSRC8_EL1", 924 },
    { "BRBSRC9_EL1", 927 },
    { "BRBSRCINJ_EL1", 896 },
    { "BRBTGT0_EL1", 901 },
    { "BRBTGT10_EL1", 931 },
    { "BRBTGT11_EL1", 934 },
    { "BRBTGT12_EL1", 937 },
    { "BRBTGT13_EL1", 940 },
    { "BRBTGT14_EL1", 943 },
    { "BRBTGT15_EL1", 946 },
    { "BRBTGT16_EL1", 949 },
    { "BRBTGT17_EL1", 952 },
    { "BRBTGT18_EL1", 955 },
    { "BRBTGT19_EL1", 958 },
    { "BRBTGT1_EL1", 904 },
    { "BRBTGT20_EL1", 961 },
    { "BRBTGT21_EL1", 964 },
    { "BRBTGT22_EL1", 967 },
    { "BRBTGT23_EL1", 970 },
    { "BRBTGT24_EL1", 973 },
    { "BRBTGT25_EL1", 976 },
    { "BRBTGT26_EL1", 979 },
    { "BRBTGT27_EL1", 982 },
    { "BRBTGT28_EL1", 985 },
    { "BRBTGT29_EL1", 988 },
    { "BRBTGT2_EL1", 907 },
    { "BRBTGT30_EL1", 991 },
    { "BRBTGT31_EL1", 994 },
    { "BRBTGT3_EL1", 910 },
    { "BRBTGT4_EL1", 913 },
    { "BRBTGT5_EL1", 916 },
    { "BRBTGT6_EL1", 919 },
    { "BRBTGT7_EL1", 922 },
    { "BRBTGT8_EL1", 925 },
    { "BRBTGT9_EL1", 928 },
    { "BRBTGTINJ_EL1", 897 },
    { "BRBTS_EL1", 898 },
    { "CCSIDR2_EL1", 9 },
    { "CCSIDR_EL1", 8 },
    { "CLIDR_EL1", 10 },
    { "CNTFRQ_EL0", 300 },
    { "CNTHCTL_EL2", 303 },
    { "CNTHPS_CTL_EL2", 744 },
    { "CNTHPS_CVAL_EL2", 743 },
    { "CNTHPS_TVAL_EL2", 742 },
    { "CNTHP_CTL_EL2", 308 },
    { "CNTHP_CVAL_EL2", 311 },
    { "CNTHP_TVAL_EL2", 305 },
    { "CNTHVS_CTL_EL2", 741 },
    { "CNTHVS_CVAL_EL2", 740 },
    { "CNTHVS_TVAL_EL2", 739 },
    { "CNTHV_CTL_EL2", 680 },
    { "CNTHV_CVAL_EL2", 679 },
    { "CNTHV_TVAL_EL2", 678 },
    { "CNTISCALE_EL2", 884 },
    { "CNTKCTL_EL1", 302 },
    { "CNTKCTL_EL12", 694 },
    { "CNTPCTSS_EL0", 887 },
    { "CNTPCT_EL0", 51 },
    { "CNTPOFF_EL2", 885 },
    { "CNTPS_CTL_EL1", 309 },
    { "CNTPS_CVAL_EL1", 312 },
    { "CNTPS_TVAL_EL1", 306 },
    { "CNTP_CTL_EL0", 307 },
    { "CNTP_CTL_EL02", 696 },
    { "CNTP_CVAL_EL0", 310 },
    { "CNTP_CVAL_EL02", 697 },
    { "CNTP_TVAL_EL0", 304 },
    { "CNTP_TVAL_EL02", 695 },
    { "CNTSCALE_EL2", 883 },
    { "CNTVCTSS_EL0", 888 },
    { "CNTVCT_EL0", 52 },
    { "CNTVFRQ_EL2", 886 },
    { "CNTVOFF_EL2", 301 },
    { "CNTV_CTL_EL0", 314 },
    { "CNTV_CTL_EL02", 699 },
    { "CNTV_CVAL_EL0", 315 },
    { "CNTV_CVAL_EL02", 700 },
    { "CNTV_TVAL_EL0", 313 },
    { "CNTV_TVAL_EL02", 698 },
    { "CONTEXTIDR_EL1", 294 },
    { "CONTEXTIDR_EL12", 693 },
    { "CONTEXTIDR_EL2", 703 },
    { "CPACR_EL1", 205 },
    { "CPACR_EL12", 682 },
    { "CPM_IOACC_CTL_EL3", 996 },
    { "CPTR_EL2", 217 },
    { "CPTR_EL3", 218 },
    { "CSSELR_EL1", 202 },
    { "CTR_EL0", 11 },
    { "CURRENTEL", 244 },
    { "DACR32_EL2", 231 },
    { "DAIF", 243 },
    { "DBGAUTHSTATUS_EL1", 4 },
    { "DBGBCR0_EL1", 149 },
    { "DBGBCR10_EL1", 159 },
    { "DBGBCR11_EL1", 160 },
    { "DBGBCR12_EL1", 161 },
    { "DBGBCR13_EL1", 162 },
    { "DBGBCR14_EL1", 163 },
    { "DBGBCR15_EL1", 164 },
    { "DBGBCR1_EL1", 150 },
    { "DBGBCR2_EL1", 151 },
    { "DBGBCR3_EL1", 152 },
    { "DBGBCR4_EL1", 153 },
    { "DBGBCR5_EL1", 154 },
    { "DBGBCR6_EL1", 155 },
    { "DBGBCR7_EL1", 156 },
    { "DBGBCR8_EL1", 157 },
    { "DBGBCR9_EL1", 158 },
    { "DBGBVR0_EL1", 133 },
    { "DBGBVR10_EL1", 143 },
    { "DBGBVR11_EL1", 144 },
    { "DBGBVR12_EL1", 145 },
    { "DBGBVR13_EL1", 146 },
    { "DBGBVR14_EL1", 147 },
    { "DBGBVR15_EL1", 148 },
    { "DBGBVR1_EL1", 134 },
    { "DBGBVR2_EL1", 135 },
    { "DBGBVR3_EL1", 136 },
    { "DBGBVR4_EL1", 137 },
    { "DBGBVR5_EL1", 138 },
    { "DBGBVR6_EL1", 139 },
    { "DBGBVR7_EL1", 140 },
    { "DBGBVR8_EL1", 141 },
    { "DBGBVR9_EL1", 142 },
    { "DBGCLAIMCLR_EL1", 201 },
    { "DBGCLAIMSET_EL1", 200 },
    { "DBGDTRRX_EL0", 1 },
    { "DBGDTRTX_EL0", 114 },
    { "DBGDTR_EL0", 130 },
    { "DBGPRCR_EL1", 199 },
    { "DBGVCR32_EL2", 132 },
    { "DBGWCR0_EL1", 181 },
    { "DBGWCR10_EL1", 191 },
    { "DBGWCR11_EL1", 192 },
    { "DBGWCR12_EL1", 193 },
    { "DBGWCR13_EL1", 194 },
    { "DBGWCR14_EL1", 195 },
    { "DBGWCR15_EL1", 196 },
    { "DBGWCR1_EL1", 182 },
    { "DBGWCR2_EL1", 183 },
    { "DBGWCR3_EL1", 184 },
    { "DBGWCR4_EL1", 185 },
    { "DBGWCR5_EL1", 186 },
    { "DBGWCR6_EL1", 187 },
    { "DBGWCR7_EL1", 188 },
    { "DBGWCR8_EL1", 189 },
    { "DBGWCR9_EL1", 190 },
    { "DBGWVR0_EL1", 165 },
    { "DBGWVR10_EL1", 175 },
    { "DBGWVR11_EL1", 176 },
    { "DBGWVR12_EL1", 177 },
    { "DBGWVR13_EL1", 178 },
    { "DBGWVR14_EL1", 179 },
    { "DBGWVR15_EL1", 180 },
    { "DBGWVR1_EL1", 166 },
    { "DBGWVR2_EL1", 167 },
    { "DBGWVR3_EL1", 168 },
    { "DBGWVR4_EL1", 169 },
    { "DBGWVR5_EL1", 170 },
    { "DBGWVR6_EL1", 171 },
    { "DBGWVR7_EL1", 172 },
    { "DBGWVR8_EL1", 173 },
    { "DBGWVR9_EL1", 174 },
    { "DCZID_EL0", 15 },
    { "DISR_EL1", 724 },
    { "DIT", 818 },
    { "DLR_EL0", 252 },
    { "DSPSR_EL0", 251 },
    { "ELR_EL1", 235 },
    { "ELR_EL12", 702 },
    { "ELR_EL2", 236 },
    { "ELR_EL3", 237 },
    { "ERRIDR_EL1", 101 },
    { "ERRSELR_EL1", 718 },
    { "ERXADDR_EL1", 721 },
    { "ERXCTLR_EL1", 719 },
    { "ERXFR_EL1", 102 },
    { "ERXMISC0_EL1", 722 },
    { "ERXMISC1_EL1", 723 },
    { "ERXMISC2_EL1", 748 },
    { "ERXMISC3_EL1", 749 },
    { "ERXPFGCDN_EL1", 747 },
    { "ERXPFGCTL_EL1", 746 },
    { "ERXPFGF_EL1", 750 },
    { "ERXSTATUS_EL1", 720 },
    { "ESR_EL1", 260 },
    { "ESR_EL12", 688 },
    { "ESR_EL2", 261 },
    { "ESR_EL3", 262 },
    { "FAR_EL1", 264 },
    { "FAR_EL12", 689 },
    { "FAR_EL2", 265 },
    { "FAR_EL3", 266 },
    { "FPCR", 249 },
    { "FPEXC32_EL2", 263 },
    { "FPSR", 250 },
    { "GCR_EL1", 826 },
    { "GMID_EL1", 833 },
    { "GPCCR_EL3", 111 },
    { "GPTBR_EL3", 112 },
    { "HACR_EL2", 220 },
    { "HCRX_EL2", 213 },
    { "HCR_EL2", 212 },
    { "HDFGRTR_EL2", 881 },
    { "HDFGWTR_EL2", 882 },
    { "HFGITR_EL2", 880 },
    { "HFGRTR_EL2", 878 },
    { "HFGWTR_EL2", 879 },
    { "HPFAR_EL2", 267 },
    { "HSTR_EL2", 219 },
    { "ICC_AP0R0_EL1", 562 },
    { "ICC_AP0R1_EL1", 563 },
    { "ICC_AP0R2_EL1", 564 },
    { "ICC_AP0R3_EL1", 565 },
    { "ICC_AP1R0_EL1", 566 },
    { "ICC_AP1R1_EL1", 567 },
    { "ICC_AP1R2_EL1", 568 },
    { "ICC_AP1R3_EL1", 569 },
    { "ICC_ASGI1R_EL1", 123 },
    { "ICC_BPR0_EL1", 552 },
    { "ICC_BPR1_EL1", 551 },
    { "ICC_CTLR_EL1", 554 },
    { "ICC_CTLR_EL3", 555 },
    { "ICC_DIR_EL1", 121 },
    { "ICC_EOIR0_EL1", 120 },
    { "ICC_EOIR1_EL1", 119 },
    { "ICC_HPPIR0_EL1", 94 },
    { "ICC_HPPIR1_EL1", 93 },
    { "ICC_IAR0_EL1", 92 },
    { "ICC_IAR1_EL1", 91 },
    { "ICC_IGRPEN0_EL1", 559 },
    { "ICC_IGRPEN1_EL1", 560 },
    { "ICC_IGRPEN1_EL3", 561 },
    { "ICC_PMR_EL1", 553 },
    { "ICC_RPR_EL1", 95 },
    { "ICC_SGI0R_EL1", 124 },
    { "ICC_SGI1R_EL1", 122 },
    { "ICC_SRE_EL1", 556 },
    { "ICC_SRE_EL2", 557 },
    { "ICC_SRE_EL3", 558 },
    { "ICH_AP0R0_EL2", 570 },
    { "ICH_AP0R1_EL2", 571 },
    { "ICH_AP0R2_EL2", 572 },
    { "ICH_AP0R3_EL2", 573 },
    { "ICH_AP1R0_EL2", 574 },
    { "ICH_AP1R1_EL2", 575 },
    { "ICH_AP1R2_EL2", 576 },
    { "ICH_AP1R3_EL2", 577 },
    { "ICH_EISR_EL2", 97 },
    { "ICH_ELRSR_EL2", 98 },
    { "ICH_HCR_EL2", 578 },
    { "ICH_LR0_EL2", 581 },
    { "ICH_LR10_EL2", 591 },
    { "ICH_LR11_EL2", 592 },
    { "ICH_LR12_EL2", 593 },
    { "ICH_LR13_EL2", 594 },
    { "ICH_LR14_EL2", 595 },
    { "ICH_LR15_EL2", 596 },
    { "ICH_LR1_EL2", 582 },
    { "ICH_LR2_EL2", 583 },
    { "ICH_LR3_EL2", 584 },
    { "ICH_LR4_EL2", 585 },
    { "ICH_LR5_EL2", 586 },
    { "ICH_LR6_EL2", 587 },
    { "ICH_LR7_EL2", 588 },
    { "ICH_LR8_EL2", 589 },
    { "ICH_LR9_EL2", 590 },
    { "ICH_MISR_EL2", 579 },
    { "ICH_VMCR_EL2", 580 },
    { "ICH_VTR_EL2", 96 },
    { "ID_AA64AFR0_EL1", 36 },
    { "ID_AA64AFR1_EL1", 37 },
    { "ID_AA64DFR0_EL1", 34 },
    { "ID_AA64DFR1_EL1", 35 },
    { "ID_AA64ISAR0_EL1", 38 },
    { "ID_AA64ISAR1_EL1", 39 },
    { "ID_AA64ISAR2_EL1", 40 },
    { "ID_AA64MMFR0_EL1", 41 },
    { "ID_AA64MMFR1_EL1", 42 },
    { "ID_AA64MMFR2_EL1", 43 },
    { "ID_AA64PFR0_EL1", 32 },
    { "ID_AA64PFR1_EL1", 33 },
    { "ID_AA64SMFR0_EL1", 113 },
    { "ID_AA64ZFR0_EL1", 99 },
    { "ID_AFR0_EL1", 20 },
    { "ID_DFR0_EL1", 19 },
    { "ID_ISAR0_EL1", 25 },
    { "ID_ISAR1_EL1", 26 },
    { "ID_ISAR2_EL1", 27 },
    { "ID_ISAR3_EL1", 28 },
    { "ID_ISAR4_EL1", 29 },
    { "ID_ISAR5_EL1", 30 },
    { "ID_ISAR6_EL1", 31 },
    { "ID_MMFR0_EL1", 21 },
    { "ID_MMFR1_EL1", 22 },
    { "ID_MMFR2_EL1", 23 },
    { "ID_MMFR3_EL1", 24 },
    { "ID_MMFR4_EL1", 53 },
    { "ID_MMFR5_EL1", 54 },
    { "ID_PFR0_EL1", 16 },
    { "ID_PFR1_EL1", 17 },
    { "ID_PFR2_EL1", 18 },
    { "IFSR32_EL2", 253 },
    { "ISR_EL1", 50 },
    { "LORC_EL1", 676 },
    { "LOREA_EL1", 674 },
    { "LORID_EL1", 100 },
    { "LORN_EL1", 675 },
    { "LORSA_EL1", 673 },
    { "MAIR_EL1", 282 },
    { "MAIR_EL12", 690 },
    { "MAIR_EL2", 283 },
    { "MAIR_EL3", 284 },
    { "MDCCINT_EL1", 128 },
    { "MDCCSR_EL0", 0 },
    { "MDCR_EL2", 215 },
    { "MDCR_EL3", 221 },
    { "MDRAR_EL1", 2 },
    { "MDSCR_EL1", 129 },
    { "MFAR_EL3", 110 },
    { "MIDR_EL1", 7 },
    { "MPAM0_EL1", 751 },
    { "MPAM1_EL1", 752 },
    { "MPAM1_EL12", 755 },
    { "MPAM2_EL2", 753 },
    { "MPAM3_EL3", 754 },
    { "MPAMHCR_EL2", 756 },
    { "MPAMIDR_EL1", 766 },
    { "MPAMSM_EL1", 1006 },
    { "MPAMVPM0_EL2", 758 },
    { "MPAMVPM1_EL2", 759 },
    { "MPAMVPM2_EL2", 760 },
    { "MPAMVPM3_EL2", 761 },
    { "MPAMVPM4_EL2", 762 },
    { "MPAMVPM5_EL2", 763 },
    { "MPAMVPM6_EL2", 764 },
    { "MPAMVPM7_EL2", 765 },
    { "MPAMVPMV_EL2", 757 },
    { "MPIDR_EL1", 12 },
    { "MPUIR_EL1", 598 },
    { "MPUIR_EL2", 599 },
    { "MVFR0_EL1", 44 },
    { "MVFR1_EL1", 45 },
    { "MVFR2_EL1", 46 },
    { "NZCV", 242 },
    { "OSDLR_EL1", 198 },
    { "OSDTRRX_EL1", 125 },
    { "OSDTRTX_EL1", 126 },
    { "OSECCR_EL1", 131 },
    { "OSLAR_EL1", 115 },
    { "OSLSR_EL1", 3 },
    { "PAN", 672 },
    { "PAR_EL1", 268 },
    { "PMBIDR_EL1", 708 },
    { "PMBLIMITR_EL1", 705 },
    { "PMBPTR_EL1", 706 },
    { "PMBSR_EL1", 707 },
    { "PMCCFILTR_EL0", 347 },
    { "PMCCNTR_EL0", 274 },
    { "PMCEID0_EL0", 5 },
    { "PMCEID1_EL0", 6 },
    { "PMCNTENCLR_EL0", 271 },
    { "PMCNTENSET_EL0", 270 },
    { "PMCR_EL0", 269 },
    { "PMEVCNTR0_EL0", 316 },
    { "PMEVCNTR10_EL0", 326 },
    { "PMEVCNTR11_EL0", 327 },
    { "PMEVCNTR12_EL0", 328 },
    { "PMEVCNTR13_EL0", 329 },
    { "PMEVCNTR14_EL0", 330 },
    { "PMEVCNTR15_EL0", 331 },
    { "PMEVCNTR16_EL0", 332 },
    { "PMEVCNTR17_EL0", 333 },
    { "PMEVCNTR18_EL0", 334 },
    { "PMEVCNTR19_EL0", 335 },
    { "PMEVCNTR1_EL0", 317 },
    { "PMEVCNTR20_EL0", 336 },
    { "PMEVCNTR21_EL0", 337 },
    { "PMEVCNTR22_EL0", 338 },
    { "PMEVCNTR23_EL0", 339 },
    { "PMEVCNTR24_EL0", 340 },
    { "PMEVCNTR25_EL0", 341 },
    { "PMEVCNTR26_EL0", 342 },
    { "PMEVCNTR27_EL0", 343 },
    { "PMEVCNTR28_EL0", 344 },
    { "PMEVCNTR29_EL0", 345 },
    { "PMEVCNTR2_EL0", 318 },
    { "PMEVCNTR30_EL0", 346 },
    { "PMEVCNTR3_EL0", 319 },
    { "PMEVCNTR4_EL0", 320 },
    { "PMEVCNTR5_EL0", 321 },
    { "PMEVCNTR6_EL0", 322 },
    { "PMEVCNTR7_EL0", 323 },
    { "PMEVCNTR8_EL0", 324 },
    { "PMEVCNTR9_EL0", 325 },
    { "PMEVTYPER0_EL0", 348 },
    { "PMEVTYPER10_EL0", 358 },
    { "PMEVTYPER11_EL0", 359 },
    { "PMEVTYPER12_EL0", 360 },
    { "PMEVTYPER13_EL0", 361 },
    { "PMEVTYPER14_EL0", 362 },
    { "PMEVTYPER15_EL0", 363 },
    { "PMEVTYPER16_EL0", 364 },
    { "PMEVTYPER17_EL0", 365 },
    { "PMEVTYPER18_EL0", 366 },
    { "PMEVTYPER19_EL0", 367 },
    { "PMEVTYPER1_EL0", 349 },
    { "PMEVTYPER20_EL0", 368 },
    { "PMEVTYPER21_EL0", 369 },
    { "PMEVTYPER22_EL0", 370 },
    { "PMEVTYPER23_EL0", 371 },
    { "PMEVTYPER24_EL0", 372 },
    { "PMEVTYPER25_EL0", 373 },
    { "PMEVTYPER26_EL0", 374 },
    { "PMEVTYPER27_EL0", 375 },
    { "PMEVTYPER28_EL0", 376 },
    { "PMEVTYPER29_EL0", 377 },
    { "PMEVTYPER2_EL0", 350 },
    { "PMEVTYPER30_EL0", 378 },
    { "PMEVTYPER3_EL0", 351 },
    { "PMEVTYPER4_EL0", 352 },
    { "PMEVTYPER5_EL0", 353 },
    { "PMEVTYPER6_EL0", 354 },
    { "PMEVTYPER7_EL0", 355 },
    { "PMEVTYPER8_EL0", 356 },
    { "PMEVTYPER9_EL0", 357 },
    { "PMINTENCLR_EL1", 279 },
    { "PMINTENSET_EL1", 278 },
    { "PMMIR_EL1", 281 },
    { "PMOVSCLR_EL0", 272 },
    { "PMOVSSET_EL0", 280 },
    { "PMSCR_EL1", 711 },
    { "PMSCR_EL12", 710 },
    { "PMSCR_EL2", 709 },
    { "PMSELR_EL0", 273 },
    { "PMSEVFR_EL1", 715 },
    { "PMSFCR_EL1", 714 },
    { "PMSICR_EL1", 712 },
    { "PMSIDR_EL1", 717 },
    { "PMSIRR_EL1", 713 },
    { "PMSLATFR_EL1", 716 },
    { "PMSNEVFR_EL1", 995 },
    { "PMSWINC_EL0", 116 },
    { "PMUSERENR_EL0", 277 },
    { "PMXEVCNTR_EL0", 276 },
    { "PMXEVTYPER_EL0", 275 },
    { "PRBAR0_EL1", 608 },
    { "PRBAR0_EL2", 610 },
    { "PRBAR10_EL1", 648 },
    { "PRBAR10_EL2", 650 },
    { "PRBAR11_EL1", 652 },
    { "PRBAR11_EL2", 654 },
    { "PRBAR12_EL1", 656 },
    { "PRBAR12_EL2", 658 },
    { "PRBAR13_EL1", 660 },
    { "PRBAR13_EL2", 662 },
    { "PRBAR14_EL1", 664 },
    { "PRBAR14_EL2", 666 },
    { "PRBAR15_EL1", 668 },
    { "PRBAR15_EL2", 670 },
    { "PRBAR1_EL1", 612 },
    { "PRBAR1_EL2", 614 },
    { "PRBAR2_EL1", 616 },
    { "PRBAR2_EL2", 618 },
    { "PRBAR3_EL1", 620 },
    { "PRBAR3_EL2", 622 },
    { "PRBAR4_EL1", 624 },
    { "PRBAR4_EL2", 626 },
    { "PRBAR5_EL1", 628 },
    { "PRBAR5_EL2", 630 },
    { "PRBAR6_EL1", 632 },
    { "PRBAR6_EL2", 634 },
    { "PRBAR7_EL1", 636 },
    { "PRBAR7_EL2", 638 },
    { "PRBAR8_EL1", 640 },
    { "PRBAR8_EL2", 642 },
    { "PRBAR9_EL1", 644 },
    { "PRBAR9_EL2", 646 },
    { "PRBAR_EL1", 604 },
    { "PRBAR_EL2", 605 },
    { "PRENR_EL1", 600 },
    { "PRENR_EL2", 601 },
    { "PRLAR0_EL1", 609 },
    { "PRLAR0_EL2", 611 },
    { "PRLAR10_EL1", 649 },
    { "PRLAR10_EL2", 651 },
    { "PRLAR11_EL1", 653 },
    { "PRLAR11_EL2", 655 },
    { "PRLAR12_EL1", 657 },
    { "PRLAR12_EL2", 659 },
    { "PRLAR13_EL1", 661 },
    { "PRLAR13_EL2", 663 },
    { "PRLAR14_EL1", 665 },
    { "PRLAR14_EL2", 667 },
    { "PRLAR15_EL1", 669 },
    { "PRLAR15_EL2", 671 },
    { "PRLAR1_EL1", 613 },
    { "PRLAR1_EL2", 615 },
    { "PRLAR2_EL1", 617 },
    { "PRLAR2_EL2", 619 },
    { "PRLAR3_EL1", 621 },
    { "PRLAR3_EL2", 623 },
    { "PRLAR4_EL1", 625 },
    { "PRLAR4_EL2", 627 },
    { "PRLAR5_EL1", 629 },
    { "PRLAR5_EL2", 631 },
    { "PRLAR6_EL1", 633 },
    { "PRLAR6_EL2", 635 },
    { "PRLAR7_EL1", 637 },
    { "PRLAR7_EL2", 639 },
    { "PRLAR8_EL1", 641 },
    { "PRLAR8_EL2", 643 },
    { "PRLAR9_EL1", 645 },
    { "PRLAR9_EL2", 647 },
    { "PRLAR_EL1", 606 },
    { "PRLAR_EL2", 607 },
    { "PRSELR_EL1", 602 },
    { "PRSELR_EL2", 603 },
    { "REVIDR_EL1", 13 },
    { "RGSR_EL1", 827 },
    { "RMR_EL1", 291 },
    { "RMR_EL2", 292 },
    { "RMR_EL3", 293 },
    { "RNDR", 103 },
    { "RNDRRS", 104 },
    { "RVBAR_EL1", 47 },
    { "RVBAR_EL2", 48 },
    { "RVBAR_EL3", 49 },
    { "SCR_EL3", 214 },
    { "SCTLR_EL1", 206 },
    { "SCTLR_EL12", 681 },
    { "SCTLR_EL2", 207 },
    { "SCTLR_EL3", 208 },
    { "SCXTNUM_EL0", 105 },
    { "SCXTNUM_EL1", 106 },
    { "SCXTNUM_EL12", 109 },
    { "SCXTNUM_EL2", 107 },
    { "SCXTNUM_EL3", 108 },
    { "SDER32_EL2", 745 },
    { "SDER32_EL3", 216 },
    { "SMCR_EL1", 997 },
    { "SMCR_EL12", 1000 },
    { "SMCR_EL2", 998 },
    { "SMCR_EL3", 999 },
    { "SMIDR_EL1", 1004 },
    { "SMPRIMAP_EL2", 1003 },
    { "SMPRI_EL1", 1002 },
    { "SPSEL", 241 },
    { "SPSR_ABT", 246 },
    { "SPSR_EL1", 232 },
    { "SPSR_EL12", 701 },
    { "SPSR_EL2", 233 },
    { "SPSR_EL3", 234 },
    { "SPSR_FIQ", 248 },
    { "SPSR_IRQ", 245 },
    { "SPSR_UND", 247 },
    { "SP_EL0", 238 },
    { "SP_EL1", 239 },
    { "SP_EL2", 240 },
    { "SSBS", 824 },
    { "SVCR", 1001 },
    { "TCO", 825 },
    { "TCR_EL1", 227 },
    { "TCR_EL12", 685 },
    { "TCR_EL2", 228 },
    { "TCR_EL3", 229 },
    { "TEECR32_EL1", 127 },
    { "TEEHBR32_EL1", 197 },
    { "TFSRE0_EL1", 832 },
    { "TFSR_EL1", 828 },
    { "TFSR_EL12", 831 },
    { "TFSR_EL2", 829 },
    { "TFSR_EL3", 830 },
    { "TPIDR2_EL0", 1005 },
    { "TPIDRRO_EL0", 298 },
    { "TPIDR_EL0", 295 },
    { "TPIDR_EL1", 299 },
    { "TPIDR_EL2", 296 },
    { "TPIDR_EL3", 297 },
    { "TRBBASER_EL1", 841 },
    { "TRBIDR_EL1", 845 },
    { "TRBLIMITR_EL1", 839 },
    { "TRBMAR_EL1", 843 },
    { "TRBPTR_EL1", 840 },
    { "TRBSR_EL1", 842 },
    { "TRBTRG_EL1", 844 },
    { "TRCACATR0", 496 },
    { "TRCACATR1", 497 },
    { "TRCACATR10", 506 },
    { "TRCACATR11", 507 },
    { "TRCACATR12", 508 },
    { "TRCACATR13", 509 },
    { "TRCACATR14", 510 },
    { "TRCACATR15", 511 },
    { "TRCACATR2", 498 },
    { "TRCACATR3", 499 },
    { "TRCACATR4", 500 },
    { "TRCACATR5", 501 },
    { "TRCACATR6", 502 },
    { "TRCACATR7", 503 },
    { "TRCACATR8", 504 },
    { "TRCACATR9", 505 },
    { "TRCACVR0", 480 },
    { "TRCACVR1", 481 },
    { "TRCACVR10", 490 },
    { "TRCACVR11", 491 },
    { "TRCACVR12", 492 },
    { "TRCACVR13", 493 },
    { "TRCACVR14", 494 },
    { "TRCACVR15", 495 },
    { "TRCACVR2", 482 },
    { "TRCACVR3", 483 },
    { "TRCACVR4", 484 },
    { "TRCACVR5", 485 },
    { "TRCACVR6", 486 },
    { "TRCACVR7", 487 },
    { "TRCACVR8", 488 },
    { "TRCACVR9", 489 },
    { "TRCAUTHSTATUS", 75 },
    { "TRCAUXCTLR", 382 },
    { "TRCBBCTLR", 389 },
    { "TRCCCCTLR", 388 },
    { "TRCCIDCCTLR0", 544 },
    { "TRCCIDCCTLR1", 545 },
    { "TRCCIDCVR0", 528 },
    { "TRCCIDCVR1", 529 },
    { "TRCCIDCVR2", 530 },
    { "TRCCIDCVR3", 531 },
    { "TRCCIDCVR4", 532 },
    { "TRCCIDCVR5", 533 },
    { "TRCCIDCVR6", 534 },
    { "TRCCIDCVR7", 535 },
    { "TRCCIDR0", 87 },
    { "TRCCIDR1", 88 },
    { "TRCCIDR2", 89 },
    { "TRCCIDR3", 90 },
    { "TRCCLAIMCLR", 550 },
    { "TRCCLAIMSET", 549 },
    { "TRCCNTCTLR0", 409 },
    { "TRCCNTCTLR1", 410 },
    { "TRCCNTCTLR2", 411 },
    { "TRCCNTCTLR3", 412 },
    { "TRCCNTRLDVR0", 405 },
    { "TRCCNTRLDVR1", 406 },
    { "TRCCNTRLDVR2", 407 },
    { "TRCCNTRLDVR3", 408 },
    { "TRCCNTVR0", 413 },
    { "TRCCNTVR1", 414 },
    { "TRCCNTVR2", 415 },
    { "TRCCNTVR3", 416 },
    { "TRCCONFIGR", 381 },
    { "TRCDEVAFF0", 72 },
    { "TRCDEVAFF1", 73 },
    { "TRCDEVARCH", 76 },
    { "TRCDEVID", 77 },
    { "TRCDEVTYPE", 78 },
    { "TRCDVCMR0", 520 },
    { "TRCDVCMR1", 521 },
    { "TRCDVCMR2", 522 },
    { "TRCDVCMR3", 523 },
    { "TRCDVCMR4", 524 },
    { "TRCDVCMR5", 525 },
    { "TRCDVCMR6", 526 },
    { "TRCDVCMR7", 527 },
    { "TRCDVCVR0", 512 },
    { "TRCDVCVR1", 513 },
    { "TRCDVCVR2", 514 },
    { "TRCDVCVR3", 515 },
    { "TRCDVCVR4", 516 },
    { "TRCDVCVR5", 517 },
    { "TRCDVCVR6", 518 },
    { "TRCDVCVR7", 519 },
    { "TRCEVENTCTL0R", 383 },
    { "TRCEVENTCTL1R", 384 },
    { "TRCEXTINSELR", 404 },
    { "TRCEXTINSELR0", 835 },
    { "TRCEXTINSELR1", 836 },
    { "TRCEXTINSELR2", 837 },
    { "TRCEXTINSELR3", 838 },
    { "TRCIDR0", 62 },
    { "TRCIDR1", 63 },
    { "TRCIDR10", 58 },
    { "TRCIDR11", 59 },
    { "TRCIDR12", 60 },
    { "TRCIDR13", 61 },
    { "TRCIDR2", 64 },
    { "TRCIDR3", 65 },
    { "TRCIDR4", 66 },
    { "TRCIDR5", 67 },
    { "TRCIDR6", 68 },
    { "TRCIDR7", 69 },
    { "TRCIDR8", 56 },
    { "TRCIDR9", 57 },
    { "TRCIMSPEC0", 417 },
    { "TRCIMSPEC1", 418 },
    { "TRCIMSPEC2", 419 },
    { "TRCIMSPEC3", 420 },
    { "TRCIMSPEC4", 421 },
    { "TRCIMSPEC5", 422 },
    { "TRCIMSPEC6", 423 },
    { "TRCIMSPEC7", 424 },
    { "TRCITCTRL", 548 },
    { "TRCLAR", 118 },
    { "TRCLSR", 74 },
    { "TRCOSLAR", 117 },
    { "TRCOSLSR", 70 },
    { "TRCPDCR", 479 },
    { "TRCPDSR", 71 },
    { "TRCPIDR0", 83 },
    { "TRCPIDR1", 84 },
    { "TRCPIDR2", 85 },
    { "TRCPIDR3", 86 },
    { "TRCPIDR4", 79 },
    { "TRCPIDR5", 80 },
    { "TRCPIDR6", 81 },
    { "TRCPIDR7", 82 },
    { "TRCPRGCTLR", 379 },
    { "TRCPROCSELR", 380 },
    { "TRCQCTLR", 391 },
    { "TRCRSCTLR10", 433 },
    { "TRCRSCTLR11", 434 },
    { "TRCRSCTLR12", 435 },
    { "TRCRSCTLR13", 436 },
    { "TRCRSCTLR14", 437 },
    { "TRCRSCTLR15", 438 },
    { "TRCRSCTLR16", 439 },
    { "TRCRSCTLR17", 440 },
    { "TRCRSCTLR18", 441 },
    { "TRCRSCTLR19", 442 },
    { "TRCRSCTLR2", 425 },
    { "TRCRSCTLR20", 443 },
    { "TRCRSCTLR21", 444 },
    { "TRCRSCTLR22", 445 },
    { "TRCRSCTLR23", 446 },
    { "TRCRSCTLR24", 447 },
    { "TRCRSCTLR25", 448 },
    { "TRCRSCTLR26", 449 },
    { "TRCRSCTLR27", 450 },
    { "TRCRSCTLR28", 451 },
    { "TRCRSCTLR29", 452 },
    { "TRCRSCTLR3", 426 },
    { "TRCRSCTLR30", 453 },
    { "TRCRSCTLR31", 454 },
    { "TRCRSCTLR4", 427 },
    { "TRCRSCTLR5", 428 },
    { "TRCRSCTLR6", 429 },
    { "TRCRSCTLR7", 430 },
    { "TRCRSCTLR8", 431 },
    { "TRCRSCTLR9", 432 },
    { "TRCRSR", 834 },
    { "TRCSEQEVR0", 399 },
    { "TRCSEQEVR1", 400 },
    { "TRCSEQEVR2", 401 },
    { "TRCSEQRSTEVR", 402 },
    { "TRCSEQSTR", 403 },
    { "TRCSSCCR0", 455 },
    { "TRCSSCCR1", 456 },
    { "TRCSSCCR2", 457 },
    { "TRCSSCCR3", 458 },
    { "TRCSSCCR4", 459 },
    { "TRCSSCCR5", 460 },
    { "TRCSSCCR6", 461 },
    { "TRCSSCCR7", 462 },
    { "TRCSSCSR0", 463 },
    { "TRCSSCSR1", 464 },
    { "TRCSSCSR2", 465 },
    { "TRCSSCSR3", 466 },
    { "TRCSSCSR4", 467 },
    { "TRCSSCSR5", 468 },
    { "TRCSSCSR6", 469 },
    { "TRCSSCSR7", 470 },
    { "TRCSSPCICR0", 471 },
    { "TRCSSPCICR1", 472 },
    { "TRCSSPCICR2", 473 },
    { "TRCSSPCICR3", 474 },
    { "TRCSSPCICR4", 475 },
    { "TRCSSPCICR5", 476 },
    { "TRCSSPCICR6", 477 },
    { "TRCSSPCICR7", 478 },
    { "TRCSTALLCTLR", 385 },
    { "TRCSTATR", 55 },
    { "TRCSYNCPR", 387 },
    { "TRCTRACEIDR", 390 },
    { "TRCTSCTLR", 386 },
    { "TRCVDARCCTLR", 398 },
    { "TRCVDCTLR", 396 },
    { "TRCVDSACCTLR", 397 },
    { "TRCVICTLR", 392 },
    { "TRCVIIECTLR", 393 },
    { "TRCVIPCSSCTLR", 395 },
    { "TRCVISSCTLR", 394 },
    { "TRCVMIDCCTLR0", 546 },
    { "TRCVMIDCCTLR1", 547 },
    { "TRCVMIDCVR0", 536 },
    { "TRCVMIDCVR1", 537 },
    { "TRCVMIDCVR2", 538 },
    { "TRCVMIDCVR3", 539 },
    { "TRCVMIDCVR4", 540 },
    { "TRCVMIDCVR5", 541 },
    { "TRCVMIDCVR6", 542 },
    { "TRCVMIDCVR7", 543 },
    { "TRFCR_EL1", 815 },
    { "TRFCR_EL12", 817 },
    { "TRFCR_EL2", 816 },
    { "TTBR0_EL1", 222 },
    { "TTBR0_EL12", 683 },
    { "TTBR0_EL2", 224 },
    { "TTBR0_EL3", 223 },
    { "TTBR1_EL1", 226 },
    { "TTBR1_EL12", 684 },
    { "TTBR1_EL2", 677 },
    { "UAO", 704 },
    { "VBAR_EL1", 288 },
    { "VBAR_EL12", 692 },
    { "VBAR_EL2", 289 },
    { "VBAR_EL3", 290 },
    { "VDISR_EL2", 725 },
    { "VMPIDR_EL2", 204 },
    { "VNCR_EL2", 819 },
    { "VPIDR_EL2", 203 },
    { "VSCTLR_EL2", 597 },
    { "VSESR_EL2", 726 },
    { "VSTCR_EL2", 737 },
    { "VSTTBR_EL2", 738 },
    { "VTCR_EL2", 230 },
    { "VTTBR_EL2", 225 },
    { "ZCR_EL1", 820 },
    { "ZCR_EL12", 823 },
    { "ZCR_EL2", 821 },
    { "ZCR_EL3", 822 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &SysRegsList[Idx->_index];
}

const SysReg *lookupSysRegByEncoding(uint16_t Encoding) {
  struct IndexType {
    uint16_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x8002, 125 },
    { 0x8004, 133 },
    { 0x8005, 149 },
    { 0x8006, 165 },
    { 0x8007, 181 },
    { 0x800C, 134 },
    { 0x800D, 150 },
    { 0x800E, 166 },
    { 0x800F, 182 },
    { 0x8010, 128 },
    { 0x8012, 129 },
    { 0x8014, 135 },
    { 0x8015, 151 },
    { 0x8016, 167 },
    { 0x8017, 183 },
    { 0x801A, 126 },
    { 0x801C, 136 },
    { 0x801D, 152 },
    { 0x801E, 168 },
    { 0x801F, 184 },
    { 0x8024, 137 },
    { 0x8025, 153 },
    { 0x8026, 169 },
    { 0x8027, 185 },
    { 0x802C, 138 },
    { 0x802D, 154 },
    { 0x802E, 170 },
    { 0x802F, 186 },
    { 0x8032, 131 },
    { 0x8034, 139 },
    { 0x8035, 155 },
    { 0x8036, 171 },
    { 0x8037, 187 },
    { 0x803C, 140 },
    { 0x803D, 156 },
    { 0x803E, 172 },
    { 0x803F, 188 },
    { 0x8044, 141 },
    { 0x8045, 157 },
    { 0x8046, 173 },
    { 0x8047, 189 },
    { 0x804C, 142 },
    { 0x804D, 158 },
    { 0x804E, 174 },
    { 0x804F, 190 },
    { 0x8054, 143 },
    { 0x8055, 159 },
    { 0x8056, 175 },
    { 0x8057, 191 },
    { 0x805C, 144 },
    { 0x805D, 160 },
    { 0x805E, 176 },
    { 0x805F, 192 },
    { 0x8064, 145 },
    { 0x8065, 161 },
    { 0x8066, 177 },
    { 0x8067, 193 },
    { 0x806C, 146 },
    { 0x806D, 162 },
    { 0x806E, 178 },
    { 0x806F, 194 },
    { 0x8074, 147 },
    { 0x8075, 163 },
    { 0x8076, 179 },
    { 0x8077, 195 },
    { 0x807C, 148 },
    { 0x807D, 164 },
    { 0x807E, 180 },
    { 0x807F, 196 },
    { 0x8080, 2 },
    { 0x8084, 115 },
    { 0x808C, 3 },
    { 0x809C, 198 },
    { 0x80A4, 199 },
    { 0x83C6, 200 },
    { 0x83CE, 201 },
    { 0x83F6, 4 },
    { 0x8801, 390 },
    { 0x8802, 392 },
    { 0x8804, 399 },
    { 0x8805, 405 },
    { 0x8806, 56 },
    { 0x8807, 417 },
    { 0x8808, 379 },
    { 0x8809, 391 },
    { 0x880A, 393 },
    { 0x880C, 400 },
    { 0x880D, 406 },
    { 0x880E, 57 },
    { 0x880F, 418 },
    { 0x8810, 380 },
    { 0x8812, 394 },
    { 0x8814, 401 },
    { 0x8815, 407 },
    { 0x8816, 58 },
    { 0x8817, 419 },
    { 0x8818, 55 },
    { 0x881A, 395 },
    { 0x881D, 408 },
    { 0x881E, 59 },
    { 0x881F, 420 },
    { 0x8820, 381 },
    { 0x8825, 409 },
    { 0x8826, 60 },
    { 0x8827, 421 },
    { 0x882D, 410 },
    { 0x882E, 61 },
    { 0x882F, 422 },
    { 0x8830, 382 },
    { 0x8834, 402 },
    { 0x8835, 411 },
    { 0x8837, 423 },
    { 0x883C, 403 },
    { 0x883D, 412 },
    { 0x883F, 424 },
    { 0x8840, 383 },
    { 0x8842, 396 },
    { 0x8844, 404 },
    { 0x8844, 835 },
    { 0x8845, 413 },
    { 0x8847, 62 },
    { 0x8848, 384 },
    { 0x884A, 397 },
    { 0x884C, 836 },
    { 0x884D, 414 },
    { 0x884F, 63 },
    { 0x8850, 834 },
    { 0x8852, 398 },
    { 0x8854, 837 },
    { 0x8855, 415 },
    { 0x8857, 64 },
    { 0x8858, 385 },
    { 0x885C, 838 },
    { 0x885D, 416 },
    { 0x885F, 65 },
    { 0x8860, 386 },
    { 0x8867, 66 },
    { 0x8868, 387 },
    { 0x886F, 67 },
    { 0x8870, 388 },
    { 0x8877, 68 },
    { 0x8878, 389 },
    { 0x887F, 69 },
    { 0x8881, 439 },
    { 0x8882, 455 },
    { 0x8883, 471 },
    { 0x8884, 117 },
    { 0x8889, 440 },
    { 0x888A, 456 },
    { 0x888B, 472 },
    { 0x888C, 70 },
    { 0x8890, 425 },
    { 0x8891, 441 },
    { 0x8892, 457 },
    { 0x8893, 473 },
    { 0x8898, 426 },
    { 0x8899, 442 },
    { 0x889A, 458 },
    { 0x889B, 474 },
    { 0x88A0, 427 },
    { 0x88A1, 443 },
    { 0x88A2, 459 },
    { 0x88A3, 475 },
    { 0x88A4, 479 },
    { 0x88A8, 428 },
    { 0x88A9, 444 },
    { 0x88AA, 460 },
    { 0x88AB, 476 },
    { 0x88AC, 71 },
    { 0x88B0, 429 },
    { 0x88B1, 445 },
    { 0x88B2, 461 },
    { 0x88B3, 477 },
    { 0x88B8, 430 },
    { 0x88B9, 446 },
    { 0x88BA, 462 },
    { 0x88BB, 478 },
    { 0x88C0, 431 },
    { 0x88C1, 447 },
    { 0x88C2, 463 },
    { 0x88C8, 432 },
    { 0x88C9, 448 },
    { 0x88CA, 464 },
    { 0x88D0, 433 },
    { 0x88D1, 449 },
    { 0x88D2, 465 },
    { 0x88D8, 434 },
    { 0x88D9, 450 },
    { 0x88DA, 466 },
    { 0x88E0, 435 },
    { 0x88E1, 451 },
    { 0x88E2, 467 },
    { 0x88E8, 436 },
    { 0x88E9, 452 },
    { 0x88EA, 468 },
    { 0x88F0, 437 },
    { 0x88F1, 453 },
    { 0x88F2, 469 },
    { 0x88F8, 438 },
    { 0x88F9, 454 },
    { 0x88FA, 470 },
    { 0x8900, 480 },
    { 0x8901, 488 },
    { 0x8902, 496 },
    { 0x8903, 504 },
    { 0x8904, 512 },
    { 0x8905, 516 },
    { 0x8906, 520 },
    { 0x8907, 524 },
    { 0x8910, 481 },
    { 0x8911, 489 },
    { 0x8912, 497 },
    { 0x8913, 505 },
    { 0x8920, 482 },
    { 0x8921, 490 },
    { 0x8922, 498 },
    { 0x8923, 506 },
    { 0x8924, 513 },
    { 0x8925, 517 },
    { 0x8926, 521 },
    { 0x8927, 525 },
    { 0x8930, 483 },
    { 0x8931, 491 },
    { 0x8932, 499 },
    { 0x8933, 507 },
    { 0x8940, 484 },
    { 0x8941, 492 },
    { 0x8942, 500 },
    { 0x8943, 508 },
    { 0x8944, 514 },
    { 0x8945, 518 },
    { 0x8946, 522 },
    { 0x8947, 526 },
    { 0x8950, 485 },
    { 0x8951, 493 },
    { 0x8952, 501 },
    { 0x8953, 509 },
    { 0x8960, 486 },
    { 0x8961, 494 },
    { 0x8962, 502 },
    { 0x8963, 510 },
    { 0x8964, 515 },
    { 0x8965, 519 },
    { 0x8966, 523 },
    { 0x8967, 527 },
    { 0x8970, 487 },
    { 0x8971, 495 },
    { 0x8972, 503 },
    { 0x8973, 511 },
    { 0x8980, 528 },
    { 0x8981, 536 },
    { 0x8982, 544 },
    { 0x898A, 545 },
    { 0x8990, 529 },
    { 0x8991, 537 },
    { 0x8992, 546 },
    { 0x899A, 547 },
    { 0x89A0, 530 },
    { 0x89A1, 538 },
    { 0x89B0, 531 },
    { 0x89B1, 539 },
    { 0x89C0, 532 },
    { 0x89C1, 540 },
    { 0x89D0, 533 },
    { 0x89D1, 541 },
    { 0x89E0, 534 },
    { 0x89E1, 542 },
    { 0x89F0, 535 },
    { 0x89F1, 543 },
    { 0x8B84, 548 },
    { 0x8B97, 77 },
    { 0x8B9F, 78 },
    { 0x8BA7, 79 },
    { 0x8BAF, 80 },
    { 0x8BB7, 81 },
    { 0x8BBF, 82 },
    { 0x8BC6, 549 },
    { 0x8BC7, 83 },
    { 0x8BCE, 550 },
    { 0x8BCF, 84 },
    { 0x8BD6, 72 },
    { 0x8BD7, 85 },
    { 0x8BDE, 73 },
    { 0x8BDF, 86 },
    { 0x8BE6, 118 },
    { 0x8BE7, 87 },
    { 0x8BEE, 74 },
    { 0x8BEF, 88 },
    { 0x8BF6, 75 },
    { 0x8BF7, 89 },
    { 0x8BFE, 76 },
    { 0x8BFF, 90 },
    { 0x8C00, 899 },
    { 0x8C01, 900 },
    { 0x8C02, 901 },
    { 0x8C04, 947 },
    { 0x8C05, 948 },
    { 0x8C06, 949 },
    { 0x8C08, 902 },
    { 0x8C09, 903 },
    { 0x8C0A, 904 },
    { 0x8C0C, 950 },
    { 0x8C0D, 951 },
    { 0x8C0E, 952 },
    { 0x8C10, 905 },
    { 0x8C11, 906 },
    { 0x8C12, 907 },
    { 0x8C14, 953 },
    { 0x8C15, 954 },
    { 0x8C16, 955 },
    { 0x8C18, 908 },
    { 0x8C19, 909 },
    { 0x8C1A, 910 },
    { 0x8C1C, 956 },
    { 0x8C1D, 957 },
    { 0x8C1E, 958 },
    { 0x8C20, 911 },
    { 0x8C21, 912 },
    { 0x8C22, 913 },
    { 0x8C24, 959 },
    { 0x8C25, 960 },
    { 0x8C26, 961 },
    { 0x8C28, 914 },
    { 0x8C29, 915 },
    { 0x8C2A, 916 },
    { 0x8C2C, 962 },
    { 0x8C2D, 963 },
    { 0x8C2E, 964 },
    { 0x8C30, 917 },
    { 0x8C31, 918 },
    { 0x8C32, 919 },
    { 0x8C34, 965 },
    { 0x8C35, 966 },
    { 0x8C36, 967 },
    { 0x8C38, 920 },
    { 0x8C39, 921 },
    { 0x8C3A, 922 },
    { 0x8C3C, 968 },
    { 0x8C3D, 969 },
    { 0x8C3E, 970 },
    { 0x8C40, 923 },
    { 0x8C41, 924 },
    { 0x8C42, 925 },
    { 0x8C44, 971 },
    { 0x8C45, 972 },
    { 0x8C46, 973 },
    { 0x8C48, 926 },
    { 0x8C49, 927 },
    { 0x8C4A, 928 },
    { 0x8C4C, 974 },
    { 0x8C4D, 975 },
    { 0x8C4E, 976 },
    { 0x8C50, 929 },
    { 0x8C51, 930 },
    { 0x8C52, 931 },
    { 0x8C54, 977 },
    { 0x8C55, 978 },
    { 0x8C56, 979 },
    { 0x8C58, 932 },
    { 0x8C59, 933 },
    { 0x8C5A, 934 },
    { 0x8C5C, 980 },
    { 0x8C5D, 981 },
    { 0x8C5E, 982 },
    { 0x8C60, 935 },
    { 0x8C61, 936 },
    { 0x8C62, 937 },
    { 0x8C64, 983 },
    { 0x8C65, 984 },
    { 0x8C66, 985 },
    { 0x8C68, 938 },
    { 0x8C69, 939 },
    { 0x8C6A, 940 },
    { 0x8C6C, 986 },
    { 0x8C6D, 987 },
    { 0x8C6E, 988 },
    { 0x8C70, 941 },
    { 0x8C71, 942 },
    { 0x8C72, 943 },
    { 0x8C74, 989 },
    { 0x8C75, 990 },
    { 0x8C76, 991 },
    { 0x8C78, 944 },
    { 0x8C79, 945 },
    { 0x8C7A, 946 },
    { 0x8C7C, 992 },
    { 0x8C7D, 993 },
    { 0x8C7E, 994 },
    { 0x8C80, 890 },
    { 0x8C81, 893 },
    { 0x8C82, 898 },
    { 0x8C88, 895 },
    { 0x8C89, 896 },
    { 0x8C8A, 897 },
    { 0x8C90, 894 },
    { 0x9000, 127 },
    { 0x9080, 197 },
    { 0x9808, 0 },
    { 0x9820, 130 },
    { 0x9828, 1 },
    { 0x9828, 114 },
    { 0xA038, 132 },
    { 0xA480, 892 },
    { 0xAC80, 891 },
    { 0xC000, 7 },
    { 0xC004, 598 },
    { 0xC005, 12 },
    { 0xC006, 13 },
    { 0xC008, 16 },
    { 0xC009, 17 },
    { 0xC00A, 19 },
    { 0xC00B, 20 },
    { 0xC00C, 21 },
    { 0xC00D, 22 },
    { 0xC00E, 23 },
    { 0xC00F, 24 },
    { 0xC010, 25 },
    { 0xC011, 26 },
    { 0xC012, 27 },
    { 0xC013, 28 },
    { 0xC014, 29 },
    { 0xC015, 30 },
    { 0xC016, 53 },
    { 0xC017, 31 },
    { 0xC018, 44 },
    { 0xC019, 45 },
    { 0xC01A, 46 },
    { 0xC01C, 18 },
    { 0xC01E, 54 },
    { 0xC020, 32 },
    { 0xC021, 33 },
    { 0xC024, 99 },
    { 0xC025, 113 },
    { 0xC028, 34 },
    { 0xC029, 35 },
    { 0xC02C, 36 },
    { 0xC02D, 37 },
    { 0xC030, 38 },
    { 0xC031, 39 },
    { 0xC032, 40 },
    { 0xC038, 41 },
    { 0xC039, 42 },
    { 0xC03A, 43 },
    { 0xC080, 206 },
    { 0xC081, 209 },
    { 0xC082, 205 },
    { 0xC085, 827 },
    { 0xC086, 826 },
    { 0xC090, 820 },
    { 0xC091, 815 },
    { 0xC094, 1002 },
    { 0xC096, 997 },
    { 0xC100, 222 },
    { 0xC101, 226 },
    { 0xC102, 227 },
    { 0xC108, 727 },
    { 0xC109, 728 },
    { 0xC10A, 729 },
    { 0xC10B, 730 },
    { 0xC110, 731 },
    { 0xC111, 732 },
    { 0xC112, 733 },
    { 0xC113, 734 },
    { 0xC118, 735 },
    { 0xC119, 736 },
    { 0xC200, 232 },
    { 0xC201, 235 },
    { 0xC208, 238 },
    { 0xC210, 241 },
    { 0xC212, 244 },
    { 0xC213, 672 },
    { 0xC214, 704 },
    { 0xC230, 553 },
    { 0xC288, 254 },
    { 0xC289, 257 },
    { 0xC290, 260 },
    { 0xC298, 101 },
    { 0xC299, 718 },
    { 0xC2A0, 102 },
    { 0xC2A1, 719 },
    { 0xC2A2, 720 },
    { 0xC2A3, 721 },
    { 0xC2A4, 750 },
    { 0xC2A5, 746 },
    { 0xC2A6, 747 },
    { 0xC2A8, 722 },
    { 0xC2A9, 723 },
    { 0xC2AA, 748 },
    { 0xC2AB, 749 },
    { 0xC2B0, 828 },
    { 0xC2B1, 832 },
    { 0xC300, 264 },
    { 0xC309, 600 },
    { 0xC311, 602 },
    { 0xC340, 604 },
    { 0xC340, 608 },
    { 0xC341, 606 },
    { 0xC341, 609 },
    { 0xC344, 612 },
    { 0xC345, 613 },
    { 0xC348, 616 },
    { 0xC349, 617 },
    { 0xC34C, 620 },
    { 0xC34D, 621 },
    { 0xC350, 624 },
    { 0xC351, 625 },
    { 0xC354, 628 },
    { 0xC355, 629 },
    { 0xC358, 632 },
    { 0xC359, 633 },
    { 0xC35C, 636 },
    { 0xC35D, 637 },
    { 0xC360, 640 },
    { 0xC361, 641 },
    { 0xC364, 644 },
    { 0xC365, 645 },
    { 0xC368, 648 },
    { 0xC369, 649 },
    { 0xC36C, 652 },
    { 0xC36D, 653 },
    { 0xC370, 656 },
    { 0xC371, 657 },
    { 0xC374, 660 },
    { 0xC375, 661 },
    { 0xC378, 664 },
    { 0xC379, 665 },
    { 0xC37C, 668 },
    { 0xC37D, 669 },
    { 0xC3A0, 268 },
    { 0xC4C8, 711 },
    { 0xC4C9, 995 },
    { 0xC4CA, 712 },
    { 0xC4CB, 713 },
    { 0xC4CC, 714 },
    { 0xC4CD, 715 },
    { 0xC4CE, 716 },
    { 0xC4CF, 717 },
    { 0xC4D0, 705 },
    { 0xC4D1, 706 },
    { 0xC4D3, 707 },
    { 0xC4D7, 708 },
    { 0xC4D8, 839 },
    { 0xC4D9, 840 },
    { 0xC4DA, 841 },
    { 0xC4DB, 842 },
    { 0xC4DC, 843 },
    { 0xC4DE, 844 },
    { 0xC4DF, 845 },
    { 0xC4F1, 278 },
    { 0xC4F2, 279 },
    { 0xC4F6, 281 },
    { 0xC510, 282 },
    { 0xC518, 285 },
    { 0xC520, 673 },
    { 0xC521, 674 },
    { 0xC522, 675 },
    { 0xC523, 676 },
    { 0xC524, 766 },
    { 0xC527, 100 },
    { 0xC528, 752 },
    { 0xC529, 751 },
    { 0xC52B, 1006 },
    { 0xC600, 288 },
    { 0xC601, 47 },
    { 0xC602, 291 },
    { 0xC608, 50 },
    { 0xC609, 724 },
    { 0xC640, 92 },
    { 0xC641, 120 },
    { 0xC642, 94 },
    { 0xC643, 552 },
    { 0xC644, 562 },
    { 0xC645, 563 },
    { 0xC646, 564 },
    { 0xC647, 565 },
    { 0xC648, 566 },
    { 0xC649, 567 },
    { 0xC64A, 568 },
    { 0xC64B, 569 },
    { 0xC659, 121 },
    { 0xC65B, 95 },
    { 0xC65D, 122 },
    { 0xC65E, 123 },
    { 0xC65F, 124 },
    { 0xC660, 91 },
    { 0xC661, 119 },
    { 0xC662, 93 },
    { 0xC663, 551 },
    { 0xC664, 554 },
    { 0xC665, 556 },
    { 0xC666, 559 },
    { 0xC667, 560 },
    { 0xC681, 294 },
    { 0xC684, 299 },
    { 0xC685, 889 },
    { 0xC687, 106 },
    { 0xC708, 302 },
    { 0xC800, 8 },
    { 0xC801, 10 },
    { 0xC802, 9 },
    { 0xC804, 833 },
    { 0xC806, 1004 },
    { 0xC807, 14 },
    { 0xD000, 202 },
    { 0xD801, 11 },
    { 0xD807, 15 },
    { 0xD920, 103 },
    { 0xD921, 104 },
    { 0xDA10, 242 },
    { 0xDA11, 243 },
    { 0xDA12, 1001 },
    { 0xDA15, 818 },
    { 0xDA16, 824 },
    { 0xDA17, 825 },
    { 0xDA20, 249 },
    { 0xDA21, 250 },
    { 0xDA28, 251 },
    { 0xDA29, 252 },
    { 0xDCE0, 269 },
    { 0xDCE1, 270 },
    { 0xDCE2, 271 },
    { 0xDCE3, 272 },
    { 0xDCE4, 116 },
    { 0xDCE5, 273 },
    { 0xDCE6, 5 },
    { 0xDCE7, 6 },
    { 0xDCE8, 274 },
    { 0xDCE9, 275 },
    { 0xDCEA, 276 },
    { 0xDCF0, 277 },
    { 0xDCF3, 280 },
    { 0xDE82, 295 },
    { 0xDE83, 298 },
    { 0xDE85, 1005 },
    { 0xDE87, 105 },
    { 0xDE90, 767 },
    { 0xDE91, 768 },
    { 0xDE92, 769 },
    { 0xDE93, 770 },
    { 0xDE94, 771 },
    { 0xDE95, 772 },
    { 0xDE98, 781 },
    { 0xDE99, 782 },
    { 0xDEA0, 773 },
    { 0xDEA1, 774 },
    { 0xDEA2, 775 },
    { 0xDEA3, 776 },
    { 0xDEB0, 777 },
    { 0xDEB1, 778 },
    { 0xDEB2, 779 },
    { 0xDEB3, 780 },
    { 0xDEE0, 783 },
    { 0xDEE1, 784 },
    { 0xDEE2, 785 },
    { 0xDEE3, 786 },
    { 0xDEE4, 787 },
    { 0xDEE5, 788 },
    { 0xDEE6, 789 },
    { 0xDEE7, 790 },
    { 0xDEE8, 791 },
    { 0xDEE9, 792 },
    { 0xDEEA, 793 },
    { 0xDEEB, 794 },
    { 0xDEEC, 795 },
    { 0xDEED, 796 },
    { 0xDEEE, 797 },
    { 0xDEEF, 798 },
    { 0xDEF0, 799 },
    { 0xDEF1, 800 },
    { 0xDEF2, 801 },
    { 0xDEF3, 802 },
    { 0xDEF4, 803 },
    { 0xDEF5, 804 },
    { 0xDEF6, 805 },
    { 0xDEF7, 806 },
    { 0xDEF8, 807 },
    { 0xDEF9, 808 },
    { 0xDEFA, 809 },
    { 0xDEFB, 810 },
    { 0xDEFC, 811 },
    { 0xDEFD, 812 },
    { 0xDEFE, 813 },
    { 0xDEFF, 814 },
    { 0xDF00, 300 },
    { 0xDF01, 51 },
    { 0xDF02, 52 },
    { 0xDF05, 887 },
    { 0xDF06, 888 },
    { 0xDF10, 304 },
    { 0xDF11, 307 },
    { 0xDF12, 310 },
    { 0xDF18, 313 },
    { 0xDF19, 314 },
    { 0xDF1A, 315 },
    { 0xDF40, 316 },
    { 0xDF41, 317 },
    { 0xDF42, 318 },
    { 0xDF43, 319 },
    { 0xDF44, 320 },
    { 0xDF45, 321 },
    { 0xDF46, 322 },
    { 0xDF47, 323 },
    { 0xDF48, 324 },
    { 0xDF49, 325 },
    { 0xDF4A, 326 },
    { 0xDF4B, 327 },
    { 0xDF4C, 328 },
    { 0xDF4D, 329 },
    { 0xDF4E, 330 },
    { 0xDF4F, 331 },
    { 0xDF50, 332 },
    { 0xDF51, 333 },
    { 0xDF52, 334 },
    { 0xDF53, 335 },
    { 0xDF54, 336 },
    { 0xDF55, 337 },
    { 0xDF56, 338 },
    { 0xDF57, 339 },
    { 0xDF58, 340 },
    { 0xDF59, 341 },
    { 0xDF5A, 342 },
    { 0xDF5B, 343 },
    { 0xDF5C, 344 },
    { 0xDF5D, 345 },
    { 0xDF5E, 346 },
    { 0xDF60, 348 },
    { 0xDF61, 349 },
    { 0xDF62, 350 },
    { 0xDF63, 351 },
    { 0xDF64, 352 },
    { 0xDF65, 353 },
    { 0xDF66, 354 },
    { 0xDF67, 355 },
    { 0xDF68, 356 },
    { 0xDF69, 357 },
    { 0xDF6A, 358 },
    { 0xDF6B, 359 },
    { 0xDF6C, 360 },
    { 0xDF6D, 361 },
    { 0xDF6E, 362 },
    { 0xDF6F, 363 },
    { 0xDF70, 364 },
    { 0xDF71, 365 },
    { 0xDF72, 366 },
    { 0xDF73, 367 },
    { 0xDF74, 368 },
    { 0xDF75, 369 },
    { 0xDF76, 370 },
    { 0xDF77, 371 },
    { 0xDF78, 372 },
    { 0xDF79, 373 },
    { 0xDF7A, 374 },
    { 0xDF7B, 375 },
    { 0xDF7C, 376 },
    { 0xDF7D, 377 },
    { 0xDF7E, 378 },
    { 0xDF7F, 347 },
    { 0xE000, 203 },
    { 0xE004, 599 },
    { 0xE005, 204 },
    { 0xE080, 207 },
    { 0xE081, 210 },
    { 0xE088, 212 },
    { 0xE089, 215 },
    { 0xE08A, 217 },
    { 0xE08B, 219 },
    { 0xE08C, 878 },
    { 0xE08D, 879 },
    { 0xE08E, 880 },
    { 0xE08F, 220 },
    { 0xE090, 821 },
    { 0xE091, 816 },
    { 0xE092, 213 },
    { 0xE095, 1003 },
    { 0xE096, 998 },
    { 0xE099, 745 },
    { 0xE100, 224 },
    { 0xE100, 597 },
    { 0xE101, 677 },
    { 0xE102, 228 },
    { 0xE108, 225 },
    { 0xE10A, 230 },
    { 0xE110, 819 },
    { 0xE130, 738 },
    { 0xE132, 737 },
    { 0xE180, 231 },
    { 0xE18C, 881 },
    { 0xE18D, 882 },
    { 0xE200, 233 },
    { 0xE201, 236 },
    { 0xE208, 239 },
    { 0xE218, 245 },
    { 0xE219, 246 },
    { 0xE21A, 247 },
    { 0xE21B, 248 },
    { 0xE281, 253 },
    { 0xE288, 255 },
    { 0xE289, 258 },
    { 0xE290, 261 },
    { 0xE293, 726 },
    { 0xE298, 263 },
    { 0xE2B0, 829 },
    { 0xE300, 265 },
    { 0xE304, 267 },
    { 0xE309, 601 },
    { 0xE311, 603 },
    { 0xE340, 605 },
    { 0xE340, 610 },
    { 0xE341, 607 },
    { 0xE341, 611 },
    { 0xE344, 614 },
    { 0xE345, 615 },
    { 0xE348, 618 },
    { 0xE349, 619 },
    { 0xE34C, 622 },
    { 0xE34D, 623 },
    { 0xE350, 626 },
    { 0xE351, 627 },
    { 0xE354, 630 },
    { 0xE355, 631 },
    { 0xE358, 634 },
    { 0xE359, 635 },
    { 0xE35C, 638 },
    { 0xE35D, 639 },
    { 0xE360, 642 },
    { 0xE361, 643 },
    { 0xE364, 646 },
    { 0xE365, 647 },
    { 0xE368, 650 },
    { 0xE369, 651 },
    { 0xE36C, 654 },
    { 0xE36D, 655 },
    { 0xE370, 658 },
    { 0xE371, 659 },
    { 0xE374, 662 },
    { 0xE375, 663 },
    { 0xE378, 666 },
    { 0xE379, 667 },
    { 0xE37C, 670 },
    { 0xE37D, 671 },
    { 0xE4C8, 709 },
    { 0xE510, 283 },
    { 0xE518, 286 },
    { 0xE520, 756 },
    { 0xE521, 757 },
    { 0xE528, 753 },
    { 0xE530, 758 },
    { 0xE531, 759 },
    { 0xE532, 760 },
    { 0xE533, 761 },
    { 0xE534, 762 },
    { 0xE535, 763 },
    { 0xE536, 764 },
    { 0xE537, 765 },
    { 0xE600, 289 },
    { 0xE601, 48 },
    { 0xE602, 292 },
    { 0xE609, 725 },
    { 0xE640, 570 },
    { 0xE641, 571 },
    { 0xE642, 572 },
    { 0xE643, 573 },
    { 0xE648, 574 },
    { 0xE649, 575 },
    { 0xE64A, 576 },
    { 0xE64B, 577 },
    { 0xE64D, 557 },
    { 0xE658, 578 },
    { 0xE659, 96 },
    { 0xE65A, 579 },
    { 0xE65B, 97 },
    { 0xE65D, 98 },
    { 0xE65F, 580 },
    { 0xE660, 581 },
    { 0xE661, 582 },
    { 0xE662, 583 },
    { 0xE663, 584 },
    { 0xE664, 585 },
    { 0xE665, 586 },
    { 0xE666, 587 },
    { 0xE667, 588 },
    { 0xE668, 589 },
    { 0xE669, 590 },
    { 0xE66A, 591 },
    { 0xE66B, 592 },
    { 0xE66C, 593 },
    { 0xE66D, 594 },
    { 0xE66E, 595 },
    { 0xE66F, 596 },
    { 0xE681, 703 },
    { 0xE682, 296 },
    { 0xE687, 107 },
    { 0xE6C0, 846 },
    { 0xE6C1, 848 },
    { 0xE6C2, 850 },
    { 0xE6C3, 852 },
    { 0xE6C4, 854 },
    { 0xE6C5, 856 },
    { 0xE6C6, 858 },
    { 0xE6C7, 860 },
    { 0xE6C8, 862 },
    { 0xE6C9, 864 },
    { 0xE6CA, 866 },
    { 0xE6CB, 868 },
    { 0xE6CC, 870 },
    { 0xE6CD, 872 },
    { 0xE6CE, 874 },
    { 0xE6CF, 876 },
    { 0xE6D0, 847 },
    { 0xE6D1, 849 },
    { 0xE6D2, 851 },
    { 0xE6D3, 853 },
    { 0xE6D4, 855 },
    { 0xE6D5, 857 },
    { 0xE6D6, 859 },
    { 0xE6D7, 861 },
    { 0xE6D8, 863 },
    { 0xE6D9, 865 },
    { 0xE6DA, 867 },
    { 0xE6DB, 869 },
    { 0xE6DC, 871 },
    { 0xE6DD, 873 },
    { 0xE6DE, 875 },
    { 0xE6DF, 877 },
    { 0xE703, 301 },
    { 0xE704, 883 },
    { 0xE705, 884 },
    { 0xE706, 885 },
    { 0xE707, 886 },
    { 0xE708, 303 },
    { 0xE710, 305 },
    { 0xE711, 308 },
    { 0xE712, 311 },
    { 0xE718, 678 },
    { 0xE719, 680 },
    { 0xE71A, 679 },
    { 0xE720, 739 },
    { 0xE721, 741 },
    { 0xE722, 740 },
    { 0xE728, 742 },
    { 0xE729, 744 },
    { 0xE72A, 743 },
    { 0xE880, 681 },
    { 0xE882, 682 },
    { 0xE890, 823 },
    { 0xE891, 817 },
    { 0xE896, 1000 },
    { 0xE900, 683 },
    { 0xE901, 684 },
    { 0xE902, 685 },
    { 0xEA00, 701 },
    { 0xEA01, 702 },
    { 0xEA88, 686 },
    { 0xEA89, 687 },
    { 0xEA90, 688 },
    { 0xEAB0, 831 },
    { 0xEB00, 689 },
    { 0xECC8, 710 },
    { 0xED10, 690 },
    { 0xED18, 691 },
    { 0xED28, 755 },
    { 0xEE00, 692 },
    { 0xEE81, 693 },
    { 0xEE87, 109 },
    { 0xEF08, 694 },
    { 0xEF10, 695 },
    { 0xEF11, 696 },
    { 0xEF12, 697 },
    { 0xEF18, 698 },
    { 0xEF19, 699 },
    { 0xEF1A, 700 },
    { 0xF080, 208 },
    { 0xF081, 211 },
    { 0xF088, 214 },
    { 0xF089, 216 },
    { 0xF08A, 218 },
    { 0xF090, 822 },
    { 0xF096, 999 },
    { 0xF099, 221 },
    { 0xF100, 223 },
    { 0xF102, 229 },
    { 0xF10C, 112 },
    { 0xF10E, 111 },
    { 0xF200, 234 },
    { 0xF201, 237 },
    { 0xF208, 240 },
    { 0xF288, 256 },
    { 0xF289, 259 },
    { 0xF290, 262 },
    { 0xF2B0, 830 },
    { 0xF300, 266 },
    { 0xF305, 110 },
    { 0xF510, 284 },
    { 0xF518, 287 },
    { 0xF528, 754 },
    { 0xF600, 290 },
    { 0xF601, 49 },
    { 0xF602, 293 },
    { 0xF664, 555 },
    { 0xF665, 558 },
    { 0xF667, 561 },
    { 0xF682, 297 },
    { 0xF687, 108 },
    { 0xFF10, 306 },
    { 0xFF11, 309 },
    { 0xFF12, 312 },
    { 0xFF90, 996 },
  };

  struct KeyType {
    uint16_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &SysRegsList[Idx->_index];
}
#endif

#ifdef GET_TSB_DECL
const TSB *lookupTSBByName(StringRef Name);
const TSB *lookupTSBByEncoding(uint8_t Encoding);
#endif

#ifdef GET_TSB_IMPL
constexpr TSB TSBsList[] = {
  { "csync", 0x0,  {AArch64::FeatureTRACEV8_4}  }, // 0
 };

const TSB *lookupTSBByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "CSYNC", 0 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &TSBsList[Idx->_index];
}

const TSB *lookupTSBByEncoding(uint8_t Encoding) {
  struct IndexType {
    uint8_t Encoding;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { 0x0, 0 },
  };

  auto Table = makeArrayRef(Index);
  size_t Idx = Encoding;
  return Idx >= Table.size() ? nullptr : &TSBsList[Table[Idx]._index];
}
#endif

#undef GET_AT_DECL
#undef GET_AT_IMPL
#undef GET_BTI_DECL
#undef GET_BTI_IMPL
#undef GET_DBNXS_DECL
#undef GET_DBNXS_IMPL
#undef GET_DB_DECL
#undef GET_DB_IMPL
#undef GET_DC_DECL
#undef GET_DC_IMPL
#undef GET_EXACTFPIMM_DECL
#undef GET_EXACTFPIMM_IMPL
#undef GET_IC_DECL
#undef GET_IC_IMPL
#undef GET_ISB_DECL
#undef GET_ISB_IMPL
#undef GET_PRCTX_DECL
#undef GET_PRCTX_IMPL
#undef GET_PRFM_DECL
#undef GET_PRFM_IMPL
#undef GET_PSB_DECL
#undef GET_PSB_IMPL
#undef GET_PSTATE_DECL
#undef GET_PSTATE_IMPL
#undef GET_SVCR_DECL
#undef GET_SVCR_IMPL
#undef GET_SVEPREDPAT_DECL
#undef GET_SVEPREDPAT_IMPL
#undef GET_SVEPRFM_DECL
#undef GET_SVEPRFM_IMPL
#undef GET_SYSREG_DECL
#undef GET_SYSREG_IMPL
#undef GET_TLBITable_DECL
#undef GET_TLBITable_IMPL
#undef GET_TSB_DECL
#undef GET_TSB_IMPL
